"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CombinedSearchBar = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var styled_components_1 = __importDefault(require("styled-components"));
var rimble_ui_1 = require("rimble-ui");
var utils_1 = require("../../utils");
var themes_1 = require("../../themes");
var DropDown_1 = require("./DropDown/DropDown");
var Icons_1 = require("./Icons");
var StyledWrap = styled_components_1.default(rimble_ui_1.Flex)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  &:focus-within {\n    border-color: ", ";\n  }\n"], ["\n  &:focus-within {\n    border-color: ", ";\n  }\n"])), themes_1.colors.primary.base);
var StyledInput = styled_components_1.default(rimble_ui_1.Input)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  border-radius: 0 4px 4px 0;\n  border: none !important;\n  box-shadow: none !important;\n  padding-right: 40px;\n  width: 100%;\n"], ["\n  border-radius: 0 4px 4px 0;\n  border: none !important;\n  box-shadow: none !important;\n  padding-right: 40px;\n  width: 100%;\n"])));
var options = [
    { name: "Search", value: "1" },
    { name: "NFTs", value: "2" },
    { name: "VCs", value: "3" },
];
var CombinedSearchBar = function (props) {
    var urlParams = new URLSearchParams(window.location.search);
    var contract = urlParams.get("contract");
    var vc = urlParams.get("vc");
    var startingState;
    if (contract) {
        startingState = "2";
    }
    else if (vc) {
        startingState = "3";
    }
    else {
        startingState = "1";
    }
    var _a = react_1.useState(startingState), dropDownState = _a[0], setDropDownState = _a[1];
    var _b = react_1.useState(""), search = _b[0], setSearch = _b[1];
    function onKeyDown(event) {
        if (event.code === "Enter") {
            doSearch();
        }
    }
    function doSearch() {
        if (dropDownState === "1") {
            props.onSearch(search);
        }
        else if (dropDownState === "2") {
            var nftIdentifiers = utils_1.getNftIdentifiersFromUrl(search);
            props.onNftVerify(nftIdentifiers.contractAddress, nftIdentifiers.tokenId);
        }
        else {
            props.onVcVerify(search);
        }
    }
    return (jsx_runtime_1.jsxs(StyledWrap, __assign({ bg: themes_1.baseColors.white, border: 4, borderRadius: 1, position: "relative", width: "100%" }, { children: [jsx_runtime_1.jsx(rimble_ui_1.Box, __assign({ width: "182px" }, { children: jsx_runtime_1.jsx(DropDown_1.DropDown, { onChange: function (value) {
                        setDropDownState(value);
                        setSearch("");
                    }, options: options, defaultSelectedValue: startingState, combinedSearch: true, arrowColor: themes_1.colors.primary.base }, void 0) }), void 0),
            jsx_runtime_1.jsx(rimble_ui_1.Box, { bg: themes_1.colors.lightGray, my: 2, width: "1px" }, void 0),
            jsx_runtime_1.jsxs(rimble_ui_1.Flex, __assign({ flexGrow: "1" }, { children: [jsx_runtime_1.jsx(StyledInput, { onChange: function (event) { return setSearch(event.target.value); }, onKeyDown: function (event) { return onKeyDown(event); }, placeholder: props.placeholderText ||
                            (dropDownState === "1"
                                ? "Domains & DIDs"
                                : dropDownState === "2"
                                    ? "Search by NFT URL"
                                    : "Enter Verifiable Credential as JWT"), required: true, type: "text", value: search }, void 0),
                    jsx_runtime_1.jsx(rimble_ui_1.Button.Text, __assign({ onClick: function () { return doSearch(); }, style: { position: "absolute", top: 0, right: 0, zIndex: 9 } }, { children: jsx_runtime_1.jsx(Icons_1.SearchIcon, { size: "20px" }, void 0) }), void 0)] }), void 0)] }), void 0));
};
exports.CombinedSearchBar = CombinedSearchBar;
var templateObject_1, templateObject_2;
//# sourceMappingURL=CombinedSearchBar.js.map