"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("@storybook/react");
var themes_1 = require("../../themes");
var DidSelect_1 = require("./DidSelect");
var DidView_1 = require("./DidView");
var DidByDomain_1 = require("./DidByDomain");
var identifiers = [
    {
        did: "did:ethr:rinkeby:0xcfa8829812f1b4fe09b27cacf7d36e4d1b5dce76",
        provider: "did:ethr:rinkeby",
        alias: "Admin",
    },
    {
        did: "did:ethr:rinkeby:0x88298d36e4d1b5dce76cf9b27cacf7a12f1b4fe0",
        provider: "did:ethr:rinkeby",
        alias: "Another User",
    },
    {
        did: "did:ethr:rinkeby:0x1b5dce8826e4d76cf9b27cac12f1b4fe098d3f7a",
        provider: "did:ethr:rinkeby",
        alias: "Really really really really really really long alias",
    },
    {
        did: "did:ethr:rinkeby:0x9812f1d36e4d1b5dce7acf76cfa882b4fe09b27c",
        provider: "did:ethr:rinkeby",
    },
    {
        did: "did:ethr:rinkeby:0x82b4fe09b27c5dce7acbd3fa1d36e4d1bf76cfa8",
        alias: "ABC user 1",
        provider: "did:ethr:rinkeby",
        userName: "Organization ABC",
    },
    {
        did: "did:ethr:rinkeby:0xbd3fa1d36e4d1bf76cfa882b4fe09b27c5dce7ac",
        provider: "did:ethr:rinkeby",
        userName: "Organization ABC",
    },
];
react_1.storiesOf("DID", module)
    .add("DID Select: Default", function () {
    return jsx_runtime_1.jsx(DidSelect_1.DidSelect, { identifiers: identifiers, onChange: function (value) { return console.log("changed to", value); } }, void 0);
})
    .add("DID Select: Allow custom DID", function () {
    return (jsx_runtime_1.jsx(DidSelect_1.DidSelect, { identifiers: identifiers, onChange: function (value) { return console.log("changed to", value); }, allowCustom: true }, void 0));
})
    .add("DID Select: Allow custom w/ default selected DID", function () {
    return (jsx_runtime_1.jsx(DidSelect_1.DidSelect, { identifiers: identifiers, defaultSelectedDid: "did:ethr:rinkeby:0xbd3fa1d36e4d1bf76cfa882b4fe09b27c5dce7ac", onChange: function (value) { return console.log("changed to", value); }, allowCustom: true }, void 0));
})
    .add("DID View", function () {
    return jsx_runtime_1.jsx(DidView_1.DidView, { did: "did:ethr:rinkeby:0xbd3fa1d36e4d1bf76cfa882b4fe09b27c5dce7ac", copy: true }, void 0);
})
    .add("DID View large variant", function () {
    return (jsx_runtime_1.jsx(DidView_1.DidView, { did: "did:ethr:rinkeby:0xbd3fa1d36e4d1bf76cfa882b4fe09b27c5dce7ac", copy: true, maxCharCount: 100, size: "large" }, void 0));
})
    .add("DID by Domain", function () {
    return (jsx_runtime_1.jsx(themes_1.IdentityThemeProvider, { children: jsx_runtime_1.jsx(DidByDomain_1.DidByDomain, { didDocs: [{ id: "did:ethr:rinkeby:0xbd3fa1d36e4d1bf76cfa882b4fe09b27c5dce7ac" }], domain: "serto.id", didCopy: true }, void 0) }, void 0));
});
//# sourceMappingURL=Did.stories.js.map