"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DidSearch = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var styled_components_1 = __importDefault(require("styled-components"));
var config_1 = require("../../config");
var SertoUiContext_1 = require("../../context/SertoUiContext");
var icons_1 = require("@rimble/icons");
var rimble_ui_1 = require("rimble-ui");
var themes_1 = require("../../themes");
var DidSearchOption_1 = require("./DidSearchOption");
var SearchIcon_1 = require("./Icons/SearchIcon");
var StyledLink = styled_components_1.default.a(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  color: ", ";\n  font-family: ", ";\n  font-size: 14px;\n  font-weight: 600;\n  text-decoration: none;\n  &:hover {\n    text-decoration: underline;\n  }\n"], ["\n  color: ", ";\n  font-family: ", ";\n  font-size: 14px;\n  font-weight: 600;\n  text-decoration: none;\n  &:hover {\n    text-decoration: underline;\n  }\n"])), themes_1.colors.primary.base, themes_1.fonts.sansSerif);
var DidSearch = function (props) {
    var defaultSelectedDid = props.defaultSelectedDid, identifiers = props.identifiers, onChange = props.onChange, required = props.required, onBlur = props.onBlur;
    var node = react_1.useRef();
    var context = react_1.useContext(SertoUiContext_1.SertoUiContext);
    var searchService = context.searchService;
    var _a = react_1.useState(defaultSelectedDid || ""), value = _a[0], setValue = _a[1];
    var _b = react_1.useState(false), isOpen = _b[0], setIsOpen = _b[1];
    var _c = react_1.useState(), internalResults = _c[0], setInternalResults = _c[1];
    var _d = react_1.useState(), externalResults = _d[0], setExternalResults = _d[1];
    function searchExternalIdentifiers(search) {
        return __awaiter(this, void 0, void 0, function () {
            var results, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, searchService.getEntries(search)];
                    case 1:
                        results = _a.sent();
                        setExternalResults(results);
                        return [3 /*break*/, 3];
                    case 2:
                        err_1 = _a.sent();
                        console.error("failed to get identifiers:", err_1);
                        return [2 /*return*/];
                    case 3: return [2 /*return*/];
                }
            });
        });
    }
    var searchInternalIdentifiers = function (search) {
        var _a;
        var res = (_a = (identifiers || context.userDids)) === null || _a === void 0 ? void 0 : _a.filter(function (obj) {
            return Object.values(obj).some(function (val) { return val.includes(search); });
        });
        setInternalResults(res);
    };
    var onClickOutside = function (e) {
        if (node.current.contains(e.target)) {
            return;
        }
        setIsOpen(false);
    };
    react_1.useEffect(function () {
        document.addEventListener("mousedown", onClickOutside);
        return function () {
            document.removeEventListener("mousedown", onClickOutside);
        };
    });
    return (jsx_runtime_1.jsxs(rimble_ui_1.Box, __assign({ position: "relative", ref: node, width: "100%" }, { children: [jsx_runtime_1.jsx(SearchIcon_1.SearchIcon, { size: "20", style: { position: "absolute", left: "12px", top: "14px" } }, void 0),
            jsx_runtime_1.jsx(rimble_ui_1.Input, { borderRadius: isOpen ? "4px 4px 0 0" : 1, onChange: function (event) {
                    onChange({ did: event.target.value });
                    setValue(event.target.value);
                    searchInternalIdentifiers(event.target.value);
                    searchExternalIdentifiers(event.target.value);
                    !isOpen && setIsOpen(true);
                }, borderColor: isOpen && themes_1.colors.primary.base, borderBottomColor: isOpen && themes_1.colors.midGray, p: "16px 16px 16px 40px", placeholder: "Search by domain or DID", required: required, type: "url", value: value, width: "100%", onBlur: onBlur &&
                    (function () {
                        // Dumb, but since blur happens on mousedown, and onclick selection of DID from dropdown happens on mouseup, blur can get called before the DID is selected. In IssueVcForm input, blur may cause "messaging unsupported" warning to show which changes position of DidSelect and so the selection from DID dropdown doesn't line up with mouse cursor any more. And anyway, conceptually, DidSearch shouldn't fire onBlur right before selection - should fire after.
                        setTimeout(onBlur, 500);
                    }) }, void 0),
            ((externalResults && externalResults.length > 0) || (internalResults && internalResults.length > 0)) && isOpen && (jsx_runtime_1.jsxs(rimble_ui_1.Box, __assign({ bg: themes_1.baseColors.white, border: 3, borderTop: 0, borderRadius: "0 0 4px 4px", boxShadow: 1, position: "absolute", width: "100%", style: { zIndex: 9 } }, { children: [jsx_runtime_1.jsxs(rimble_ui_1.Box, __assign({ maxHeight: "250px", style: { overflow: "scroll" } }, { children: [internalResults && internalResults.length > 0 && (jsx_runtime_1.jsx(rimble_ui_1.Box, { children: internalResults.map(function (did, i) {
                                    var _a;
                                    return (jsx_runtime_1.jsx(DidSearchOption_1.DidSearchOptionDid, { onSelect: function (selectedDid) {
                                            onChange(selectedDid);
                                            setValue(selectedDid.did);
                                            setIsOpen(false);
                                        }, did: {
                                            did: did.did,
                                            // @TODO/tobek Is this how we'll detect messaging support for now?
                                            messagingSupported: !!((_a = did.services) === null || _a === void 0 ? void 0 : _a.length),
                                        }, alias: did.alias }, i));
                                }) }, void 0)),
                            externalResults && externalResults.length > 0 && (jsx_runtime_1.jsx(rimble_ui_1.Box, { children: externalResults.map(function (result, i) {
                                    return (jsx_runtime_1.jsx(DidSearchOption_1.DidSearchOption, { onSelect: function (selectedDid) {
                                            onChange(selectedDid);
                                            setValue(selectedDid.did);
                                            setIsOpen(false);
                                        }, didDocs: result.didDocs, domain: result.domain }, i));
                                }) }, void 0))] }), void 0),
                    jsx_runtime_1.jsx(rimble_ui_1.Flex, __assign({ justifyContent: "flex-end", p: 3 }, { children: jsx_runtime_1.jsxs(StyledLink, __assign({ href: config_1.config.SEARCH_UI_URL, target: "_blank" }, { children: [jsx_runtime_1.jsx(icons_1.Launch, { color: themes_1.colors.primary.base, mr: 1, size: "16px", style: { verticalAlign: "text-bottom" } }, void 0), "Go to Serto Search"] }), void 0) }), void 0)] }), void 0))] }), void 0));
};
exports.DidSearch = DidSearch;
var templateObject_1;
//# sourceMappingURL=DidSearch.js.map