"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var react_2 = require("@storybook/react");
var SertoUiProvider_1 = require("../../context/SertoUiProvider");
var helpers_1 = require("../../utils/helpers");
var DidSearch_1 = require("./DidSearch");
var DidSearchWithMessagingInfo_1 = require("./DidSearchWithMessagingInfo");
var identifiers = [
    {
        did: "did:ethr:0xcfa8829812f1b4fe09b27cacf7d36e4d1b5dce76",
        provider: "did:ethr",
        alias: "Admin",
        services: [
            {
                id: "foo",
                serviceEndpoint: "https://foo",
                type: "messaging",
            },
        ],
    },
    {
        did: "did:ethr:rinkeby:0x88298d36e4d1b5dce76cf9b27cacf7a12f1b4fe0",
        provider: "did:ethr:rinkeby",
        alias: "Another User",
    },
    {
        did: "did:key:0x1b5dce8826e4d76cf9b27cac12f1b4fe098d3f7a",
        provider: "did:key",
        alias: "Really really really really really really long alias",
    },
    {
        did: "did:web:consensys.net",
        provider: "did:web",
    },
    {
        did: "did:ethr:rinkeby:0x82b4fe09b27c5dce7acbd3fa1d36e4d1bf76cfa8",
        alias: "ABC user 1",
        provider: "did:ethr:rinkeby",
        userName: "Organization ABC",
    },
    {
        did: "did:ethr:rinkeby:0xbd3fa1d36e4d1bf76cfa882b4fe09b27c5dce7ac",
        provider: "did:ethr:rinkeby",
        userName: "Organization ABC",
    },
];
var entries = [
    {
        dids: "did:ethr:0x99dc16bff4fd8f6e33588daa4654e9ab5c5339f3",
        domain: "codefi.consensys.net",
        numBaselineEndpoints: "0",
        numVeramoEndpoints: "1",
    },
    {
        dids: "did:ethr:0xe32d444beed28c6c28ba1f84d2c8e07031b8a5d5",
        domain: "consensys.net",
        numBaselineEndpoints: "0",
        numVeramoEndpoints: "1",
    },
    {
        dids: "did:ethr:0xf570f773d825f5a30c3200962f59534d25a20018",
        domain: "diligence.consensys.net",
        numBaselineEndpoints: "0",
        numVeramoEndpoints: "1",
    },
    {
        dids: "did:ethr:0xc0b92f3f31a146e4422daf8eac9a047e3340051a",
        domain: "quorum.consensys.net",
        numBaselineEndpoints: "0",
        numVeramoEndpoints: "2",
    },
];
react_2.storiesOf("DID Search", module)
    .add("DID Search", function () {
    return (jsx_runtime_1.jsx(SertoUiProvider_1.SertoUiProvider, __assign({ context: {
            searchService: {
                getEntries: helpers_1.createMockApiRequest(entries),
            },
        } }, { children: jsx_runtime_1.jsx(DidSearch_1.DidSearch, { identifiers: identifiers, onChange: function (value) { return console.log("changed to:", value); } }, void 0) }), void 0));
})
    .add("DID Search with messaging info", function () {
    var _a = react_1.useState(false), supportsMessaging = _a[0], setSupportsMessaging = _a[1];
    return (jsx_runtime_1.jsx(SertoUiProvider_1.SertoUiProvider, __assign({ context: {
            searchService: {
                getEntries: helpers_1.createMockApiRequest(entries),
            },
        } }, { children: jsx_runtime_1.jsx(DidSearchWithMessagingInfo_1.DidSearchWithMessagingInfo, { supportsMessaging: supportsMessaging, setSupportsMessaging: setSupportsMessaging, identifiers: identifiers, onChange: function (value) { return console.log("changed to:", value); } }, void 0) }), void 0));
});
//# sourceMappingURL=DidSearch.stories.js.map