"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DidSearchOptionDid = exports.DidSearchOption = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var styled_components_1 = __importDefault(require("styled-components"));
var icons_1 = require("@rimble/icons");
var rimble_ui_1 = require("rimble-ui");
var themes_1 = require("../../themes");
var layouts_1 = require("../layouts");
var elements_1 = require("../elements");
var DidTruncate_1 = require("./DidTruncate");
var DidSearchOptionStyled = styled_components_1.default(rimble_ui_1.Box)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  cursor: pointer;\n  overflow: hidden;\n  &:hover {\n    background-color: ", ";\n    color: ", ";\n  }\n"], ["\n  cursor: pointer;\n  overflow: hidden;\n  &:hover {\n    background-color: ", ";\n    color: ", ";\n  }\n"])), themes_1.colors.primary.border, themes_1.colors.primary.base);
var DidSearchOption = function (props) {
    var alias = props.alias, didDocs = props.didDocs, domain = props.domain, imageUrl = props.imageUrl, orgName = props.orgName, onSelect = props.onSelect;
    return (jsx_runtime_1.jsxs(rimble_ui_1.Box, __assign({ borderTop: 2 }, { children: [jsx_runtime_1.jsxs(rimble_ui_1.Box, __assign({ position: "relative", pb: 2, pl: "50px", pr: 3, pt: 3 }, { children: [imageUrl ? (jsx_runtime_1.jsx("img", { src: imageUrl, style: { height: "24px", left: "16px", position: "absolute", top: "16px", width: "24px" } }, void 0)) : (jsx_runtime_1.jsx(rimble_ui_1.Box, __assign({ height: "16px", width: "16px", position: "absolute", left: "18px", top: "18px" }, { children: jsx_runtime_1.jsx(elements_1.DomainImage, { domain: domain }, void 0) }), void 0)),
                    jsx_runtime_1.jsx(layouts_1.H5, __assign({ m: 0 }, { children: domain }), void 0),
                    jsx_runtime_1.jsx(rimble_ui_1.Text, __assign({ color: themes_1.colors.midGray, fontSize: 0 }, { children: orgName }), void 0)] }), void 0),
            (didDocs === null || didDocs === void 0 ? void 0 : didDocs.length) &&
                didDocs.map(function (didDoc, i) {
                    var _a;
                    var parsedDidDoc = JSON.parse(didDoc);
                    return (jsx_runtime_1.jsx(exports.DidSearchOptionDid, { alias: alias, did: {
                            did: parsedDidDoc.id,
                            messagingSupported: !!((_a = parsedDidDoc.service) === null || _a === void 0 ? void 0 : _a.length),
                        }, onSelect: onSelect }, i));
                })] }), void 0));
};
exports.DidSearchOption = DidSearchOption;
var DidSearchOptionDid = function (props) {
    var alias = props.alias, did = props.did, onSelect = props.onSelect;
    return (jsx_runtime_1.jsx(DidSearchOptionStyled, __assign({ pl: "50px", onClick: function () { return onSelect(did); } }, { children: jsx_runtime_1.jsxs(rimble_ui_1.Flex, __assign({ borderTop: 2, justifyContent: "space-between", maxWidth: "100%" }, { children: [jsx_runtime_1.jsxs(rimble_ui_1.Flex, __assign({ alignItems: "center", fontFamily: themes_1.fonts.sansSerif, maxWidth: "calc(100% - 50px)", pl: "26px", position: "relative", py: 3 }, { children: [jsx_runtime_1.jsx(rimble_ui_1.Box, __assign({ left: 0, position: "absolute", top: "21px" }, { children: jsx_runtime_1.jsx(elements_1.DidMethodIcon, { did: did.did, size: "16px" }, void 0) }), void 0),
                        alias ? (jsx_runtime_1.jsxs(jsx_runtime_1.Fragment, { children: [jsx_runtime_1.jsx(rimble_ui_1.Text, __assign({ color: themes_1.colors.midGray, fontSize: 1, fontWeight: 3, mr: 2 }, { children: alias }), void 0),
                                jsx_runtime_1.jsx(rimble_ui_1.Text, __assign({ color: themes_1.colors.midGray, fontSize: 0, maxWidth: "calc(100% - 50px)", title: did }, { children: jsx_runtime_1.jsx(DidTruncate_1.DidTruncate, { did: did.did }, void 0) }), void 0)] }, void 0)) : (jsx_runtime_1.jsx(rimble_ui_1.Text, __assign({ color: themes_1.colors.midGray, fontSize: 0, maxWidth: "100%", title: did }, { children: jsx_runtime_1.jsx(DidTruncate_1.DidTruncate, { did: did.did }, void 0) }), void 0))] }), void 0),
                jsx_runtime_1.jsx(rimble_ui_1.Flex, __assign({ alignItems: "center", background: themes_1.baseColors.white, borderLeft: 2, justifyContent: "center", width: "40px" }, { children: did.messagingSupported ? (jsx_runtime_1.jsx(rimble_ui_1.Tooltip, __assign({ placement: "top", message: "This DID can receive secure messages and credentials." }, { children: jsx_runtime_1.jsx(icons_1.CheckCircle, { color: themes_1.colors.success.base }, void 0) }), void 0)) : (jsx_runtime_1.jsx(rimble_ui_1.Tooltip, __assign({ placement: "top", message: "This DID does not receive messages and credentials." }, { children: jsx_runtime_1.jsx(icons_1.Warning, { color: themes_1.colors.warning.base }, void 0) }), void 0)) }), void 0)] }), void 0) }), void 0));
};
exports.DidSearchOptionDid = DidSearchOptionDid;
var templateObject_1;
//# sourceMappingURL=DidSearchOption.js.map