"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DidSelect = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = __importDefault(require("react"));
var rimble_ui_1 = require("rimble-ui");
var DropDown_1 = require("./DropDown/DropDown");
var CUSTOM_DID = Symbol();
var DidSelect = function (props) {
    var _a;
    var identifiers = props.identifiers, value = props.value, onChange = props.onChange, defaultSelectedDid = props.defaultSelectedDid;
    var _b = react_1.default.useState(false), showCustom = _b[0], setShowCustom = _b[1];
    var _c = react_1.default.useState(props.defaultSelectedDid || ""), selectedDid = _c[0], setSelectedDid = _c[1];
    var _d = react_1.default.useState(""), customDid = _d[0], setCustomDid = _d[1];
    react_1.default.useEffect(function () {
        if (defaultSelectedDid && !showCustom && value !== defaultSelectedDid && selectedDid === defaultSelectedDid) {
            onChange(defaultSelectedDid);
        }
    }, [defaultSelectedDid, showCustom, onChange, selectedDid, value]);
    if (!((_a = identifiers[0]) === null || _a === void 0 ? void 0 : _a.did)) {
        return (jsx_runtime_1.jsx(rimble_ui_1.Box, __assign({ width: "100%", height: "48px", border: 1, borderRadius: 1, p: 3, mb: 3 }, { children: jsx_runtime_1.jsx(rimble_ui_1.Loader, {}, void 0) }), void 0));
    }
    var options = identifiers.map(function (id) {
        var name;
        if (id.alias && id.userName) {
            name = id.userName + ": " + id.alias + " (" + id.did + ")";
        }
        else if (id.alias) {
            name = id.alias + " (" + id.did + ")";
        }
        else if (id.userName) {
            name = id.userName + ": " + id.did;
        }
        else {
            name = id.did;
        }
        return {
            name: name,
            value: id.did,
        };
    });
    if (props.allowCustom) {
        options = [
            {
                name: "Select DID...",
                value: "",
            },
            {
                name: "Enter DID manually",
                value: CUSTOM_DID,
            },
        ].concat(options);
    }
    var onDropDownChange = function (value) {
        if (value === CUSTOM_DID) {
            setShowCustom(true);
            onChange(customDid);
        }
        else {
            setShowCustom(false);
            setSelectedDid(value);
            onChange(value);
        }
    };
    return (jsx_runtime_1.jsxs(rimble_ui_1.Box, __assign({ width: "100%", position: "relative" }, { children: [jsx_runtime_1.jsx(DropDown_1.DropDown, { onChange: onDropDownChange, options: options, defaultSelectedValue: defaultSelectedDid }, void 0),
            jsx_runtime_1.jsx(rimble_ui_1.Input, { type: "url", value: showCustom ? customDid : selectedDid, required: props.required, onChange: function (event) {
                    if (!showCustom) {
                        return false;
                    }
                    setCustomDid(event.target.value);
                    onChange(event.target.value);
                }, width: "100%", placeholder: "did:example:0xabc123", style: showCustom
                    ? undefined
                    : {
                        /* When `showCustom` is true we have a normal input field here and browser can handle "required" validation normally. When `showCustom` is not true, we hide this with CSS but fill it out based on value selected in DropDown, so that if user tries to submit and this is required and no value has been selected, the native browser validation tooltip ("please fill out this required field") points to our DropDown. The reason we have to hide with CSS is that if we hide with input `hidden` attribute (and/or use `disabled`) then browser ignores validation for the input. */
                        position: "absolute",
                        opacity: 0,
                        top: 0,
                        pointerEvents: "none",
                    } }, void 0)] }), void 0));
};
exports.DidSelect = DidSelect;
//# sourceMappingURL=DidSelect.js.map