"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DropDown = exports.Option = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var React = __importStar(require("react"));
var styled_components_1 = __importDefault(require("styled-components"));
var icons_1 = require("@rimble/icons");
var rimble_ui_1 = require("rimble-ui");
var themes_1 = require("../../../themes");
exports.Option = styled_components_1.default(rimble_ui_1.Box)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  &:hover {\n    background-color: ", ";\n  }\n  &:hover span {\n    color: ", ";\n  }\n"], ["\n  &:hover {\n    background-color: ", ";\n  }\n  &:hover span {\n    color: ", ";\n  }\n"])), themes_1.colors.primary.background, themes_1.colors.primary.base);
var DropDown = function (props) {
    var _a;
    var combinedSearch = props.combinedSearch;
    var node = React.useRef();
    var _b = React.useState(props.defaultSelectedValue
        ? props.options.filter(function (option) { return option.value === props.defaultSelectedValue; })[0] || props.options[0]
        : props.options[0]), selectedOption = _b[0], setSelectedOption = _b[1];
    var _c = React.useState(false), isOpen = _c[0], setIsOpen = _c[1];
    var toggle = function () { return !props.disabled && setIsOpen(!isOpen); };
    var onOptionClicked = function (option) { return function () {
        setSelectedOption(option);
        setIsOpen(false);
        props.onChange(option.value, props.options.indexOf(option));
    }; };
    var onClickOutside = function (e) {
        if (node.current.contains(e.target)) {
            return;
        }
        setIsOpen(false);
    };
    React.useEffect(function () {
        document.addEventListener("mousedown", onClickOutside);
        return function () {
            document.removeEventListener("mousedown", onClickOutside);
        };
    });
    var optionsTextProps = __assign({ color: themes_1.colors.silver, fontSize: 2, fontFamily: themes_1.fonts.sansSerif }, props.optionsTextProps);
    var selectedOptionTextProps = __assign(__assign({}, optionsTextProps), { style: __assign({ color: themes_1.baseColors.black, whiteSpace: "nowrap", overflow: "hidden", textOverflow: "ellipsis" }, (_a = props.optionsTextProps) === null || _a === void 0 ? void 0 : _a.style) });
    return (jsx_runtime_1.jsxs(rimble_ui_1.Box, __assign({ ref: node, bg: themes_1.baseColors.white, borderRadius: 1, borderBottomRightRadius: combinedSearch && 0, borderTopRightRadius: combinedSearch && 0, boxShadow: combinedSearch ? 0 : 1, width: "100%", style: {
            position: "relative",
            zIndex: isOpen ? 2 : 1,
            opacity: props.disabled ? 0.4 : 1,
        } }, { children: [jsx_runtime_1.jsxs(rimble_ui_1.Flex, __assign({ onClick: toggle, alignItems: "center", border: combinedSearch ? 0 : 1, borderRight: combinedSearch && 0, borderRadius: 1, borderBottomRightRadius: combinedSearch && 0, borderTopRightRadius: combinedSearch && 0, height: "48px", p: 3, pr: 4, width: "100%", style: __assign({ cursor: props.disabled ? "default" : "pointer", position: "relative" }, props.style) }, { children: [jsx_runtime_1.jsx(rimble_ui_1.Text.span, __assign({}, selectedOptionTextProps, { title: selectedOption.name }, { children: selectedOption.name }), void 0),
                    isOpen ? (jsx_runtime_1.jsx(icons_1.KeyboardArrowUp, { color: props.arrowColor || themes_1.colors.moonGray, style: { position: "absolute", right: "8px", top: "calc(50% - 12px)" } }, void 0)) : (jsx_runtime_1.jsx(icons_1.KeyboardArrowDown, { color: props.arrowColor || themes_1.colors.moonGray, style: { position: "absolute", right: "8px", top: "calc(50% - 12px)" } }, void 0))] }), void 0),
            isOpen && (jsx_runtime_1.jsxs(rimble_ui_1.Box, __assign({ bg: themes_1.baseColors.white, borderRadius: 1, border: 4, boxShadow: combinedSearch ? 0 : 1, width: "100%", style: { position: "absolute", left: "0" } }, { children: [jsx_runtime_1.jsx(rimble_ui_1.Box, { children: props.options.map(function (option, key) {
                            if (option !== selectedOption) {
                                return (jsx_runtime_1.jsx(exports.Option, __assign({ onClick: onOptionClicked(option), borderBottom: combinedSearch ? 0 : 1, px: 3, py: 2, style: { cursor: "pointer" } }, { children: jsx_runtime_1.jsx(rimble_ui_1.Text.span, __assign({}, optionsTextProps, { children: option.name }), void 0) }), key));
                            }
                            return null;
                        }) }, void 0), props.children] }), void 0))] }), void 0));
};
exports.DropDown = DropDown;
var templateObject_1;
//# sourceMappingURL=DropDown.js.map