"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NftSearchBox = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var icons_1 = require("@rimble/icons");
var rimble_ui_1 = require("rimble-ui");
var LayoutComponents_1 = require("../layouts/LayoutComponents");
var utils_1 = require("../../utils");
var themes_1 = require("../../themes");
var _1 = require("./");
var Icons_1 = require("./Icons");
var NftSearchBox = function (props) {
    var urlParams = new URLSearchParams(window.location.search);
    var contract = urlParams.get("contract");
    var tokenId = urlParams.get("tokenId");
    var _a = react_1.useState(contract || ""), contractAddress = _a[0], setContractAddress = _a[1];
    var _b = react_1.useState(tokenId || ""), token = _b[0], setToken = _b[1];
    var _c = react_1.useState(""), search = _c[0], setSearch = _c[1];
    var _d = react_1.useState(""), error = _d[0], setError = _d[1];
    function onKeyDown(event) {
        if (event.code === "Enter") {
            props.onSearch(contractAddress, token);
        }
    }
    function onSearchChanged(val) {
        setError("");
        setSearch(val);
        var nftIdentifiers = utils_1.getNftIdentifiersFromUrl(val);
        setContractAddress(nftIdentifiers.contractAddress);
        setToken(nftIdentifiers.tokenId);
        setError(nftIdentifiers.error);
    }
    function onTrySearch() {
        if (!error) {
            props.onSearch(contractAddress, token);
        }
    }
    return (jsx_runtime_1.jsxs(jsx_runtime_1.Fragment, { children: [jsx_runtime_1.jsxs(rimble_ui_1.Box, __assign({ position: "relative", mb: "2", width: "100%" }, { children: [jsx_runtime_1.jsx(_1.StyledTabbedInput, { onChange: function (event) { return onSearchChanged(event.target.value); }, onKeyDown: function (event) { return onKeyDown(event); }, placeholder: "Enter NFT URL", required: true, type: "text", value: search }, void 0),
                    jsx_runtime_1.jsx(rimble_ui_1.Button.Text, __assign({ onClick: function () { return onTrySearch(); }, style: { position: "absolute", top: 10, right: 5, zIndex: 9 } }, { children: jsx_runtime_1.jsx(Icons_1.SearchIcon, {}, void 0) }), void 0)] }), void 0),
            jsx_runtime_1.jsxs(rimble_ui_1.Box, __assign({ bg: themes_1.baseColors.white, border: 2, borderRadius: 1, pb: 5, pt: 3, px: 4, width: "100%" }, { children: [error && jsx_runtime_1.jsx(rimble_ui_1.Flash, __assign({ variant: "danger" }, { children: error }), void 0),
                    jsx_runtime_1.jsx(LayoutComponents_1.H5, __assign({ color: "silver", mb: 2 }, { children: "Or search by" }), void 0),
                    jsx_runtime_1.jsxs(rimble_ui_1.Box, __assign({ mb: 3 }, { children: [jsx_runtime_1.jsxs(rimble_ui_1.Flex, __assign({ alignItems: "center", mb: 2 }, { children: [jsx_runtime_1.jsx(LayoutComponents_1.H6, __assign({ mr: 1, my: 0 }, { children: "NFT Contract Address" }), void 0),
                                    jsx_runtime_1.jsx(rimble_ui_1.Tooltip, __assign({ placement: "top", message: "The Ethereum ERC721 or ERC1155 Contract Address associated with the token" }, { children: jsx_runtime_1.jsx(icons_1.Info, { color: themes_1.colors.silver, size: "16px" }, void 0) }), void 0)] }), void 0),
                            jsx_runtime_1.jsx(rimble_ui_1.Input, { onChange: function (event) { return setContractAddress(event.target.value); }, onKeyDown: function (event) { return onKeyDown(event); }, placeholder: "Enter NFT contract address", required: true, type: "text", value: contractAddress, width: "100%" }, void 0)] }), void 0),
                    jsx_runtime_1.jsxs(rimble_ui_1.Box, { children: [jsx_runtime_1.jsxs(rimble_ui_1.Flex, __assign({ alignItems: "center", mb: 2 }, { children: [jsx_runtime_1.jsx(LayoutComponents_1.H6, __assign({ mr: 1, my: 0 }, { children: "NFT Token ID" }), void 0),
                                    jsx_runtime_1.jsx(rimble_ui_1.Tooltip, __assign({ placement: "top", message: "The Token ID associated with the NFT" }, { children: jsx_runtime_1.jsx(icons_1.Info, { color: themes_1.colors.silver, size: "16px" }, void 0) }), void 0)] }), void 0),
                            jsx_runtime_1.jsxs(rimble_ui_1.Flex, { children: [jsx_runtime_1.jsx(rimble_ui_1.Input, { onChange: function (event) { return setToken(event.target.value); }, onKeyDown: function (event) { return onKeyDown(event); }, placeholder: "Enter NFT token ID", required: true, type: "text", value: token, width: "100%", mr: 3 }, void 0),
                                    jsx_runtime_1.jsx(rimble_ui_1.Button, __assign({ onClick: function () { return props.onSearch(contractAddress, token); }, width: "125px" }, { children: "Search" }), void 0)] }, void 0)] }, void 0)] }), void 0)] }, void 0));
};
exports.NftSearchBox = NftSearchBox;
//# sourceMappingURL=NftSearchBox.js.map