"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Popup = exports.PopupGroup = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var React = __importStar(require("react"));
var styled_components_1 = __importDefault(require("styled-components"));
var rimble_ui_1 = require("rimble-ui");
var themes_1 = require("../../../themes");
var PopupBox = styled_components_1.default(rimble_ui_1.Box)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  display: none;\n  position: absolute;\n  right: ", "px;\n  top: ", ";\n  background: ", ";\n  border: 1px solid ", ";\n  border-radius: 4px;\n  min-width: 180px;\n  font-size: 14px;\n\n  &:before {\n    content: \"\";\n    position: absolute;\n    right: ", "px;\n    top: -10px;\n    border-left: 10px solid transparent;\n    border-right: 10px solid transparent;\n    border-bottom: 10px solid ", ";\n  }\n  &:after {\n    content: \"\";\n    position: absolute;\n    right: ", "px;\n    top: -9px;\n    border-left: 9px solid transparent;\n    border-right: 9px solid transparent;\n    border-bottom: 9px solid ", ";\n  }\n"], ["\n  display: none;\n  position: absolute;\n  right: ", "px;\n  top: ", ";\n  background: ", ";\n  border: 1px solid ", ";\n  border-radius: 4px;\n  min-width: 180px;\n  font-size: 14px;\n\n  &:before {\n    content: \"\";\n    position: absolute;\n    right: ", "px;\n    top: -10px;\n    border-left: 10px solid transparent;\n    border-right: 10px solid transparent;\n    border-bottom: 10px solid ", ";\n  }\n  &:after {\n    content: \"\";\n    position: absolute;\n    right: ", "px;\n    top: -9px;\n    border-left: 9px solid transparent;\n    border-right: 9px solid transparent;\n    border-bottom: 9px solid ", ";\n  }\n"])), function (props) { return props.popupRightPos; }, function (props) { return props.popupTopPos; }, themes_1.baseColors.white, themes_1.colors.lightGray, function (props) { return props.arrowOffset - 1; }, themes_1.colors.lightGray, function (props) { return props.arrowOffset; }, themes_1.baseColors.white);
var PopupWrap = styled_components_1.default(rimble_ui_1.Box)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  position: relative;\n  z-index: 1;\n  &:hover ", ".hoverable, ", ".open {\n    display: block;\n  }\n"], ["\n  position: relative;\n  z-index: 1;\n  &:hover ", ".hoverable, ", ".open {\n    display: block;\n  }\n"])), PopupBox, PopupBox);
exports.PopupGroup = styled_components_1.default.div(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  padding: 12px 16px;\n  border-bottom: 1px solid ", ";\n  &:last-child {\n    border-bottom: 0;\n  }\n\n  & > a {\n    display: block;\n    margin-bottom: 12px;\n    text-decoration: none;\n    cursor: pointer;\n    color: ", ";\n\n    &:hover {\n      color: ", ";\n    }\n    &.selected {\n      cursor: default;\n      font-weight: bold;\n      color: ", ";\n    }\n  }\n  & > a:last-child {\n    margin-bottom: 0;\n  }\n"], ["\n  padding: 12px 16px;\n  border-bottom: 1px solid ", ";\n  &:last-child {\n    border-bottom: 0;\n  }\n\n  & > a {\n    display: block;\n    margin-bottom: 12px;\n    text-decoration: none;\n    cursor: pointer;\n    color: ", ";\n\n    &:hover {\n      color: ", ";\n    }\n    &.selected {\n      cursor: default;\n      font-weight: bold;\n      color: ", ";\n    }\n  }\n  & > a:last-child {\n    margin-bottom: 0;\n  }\n"])), themes_1.colors.lightGray, themes_1.baseColors.black, themes_1.baseColors.blurple, themes_1.baseColors.black);
var Popup = function (props) {
    var node = React.useRef();
    var _a = React.useState(false), isOpen = _a[0], setIsOpen = _a[1];
    var onClickOutside = React.useMemo(function () { return function (e) {
        if (!isOpen || node.current.contains(e.target)) {
            return;
        }
        setIsOpen(false);
    }; }, [node, isOpen]);
    React.useEffect(function () {
        if (props.triggerOnClick) {
            document.addEventListener("mousedown", onClickOutside);
            return function () {
                document.removeEventListener("mousedown", onClickOutside);
            };
        }
    }, [onClickOutside, props.triggerOnClick]);
    return (jsx_runtime_1.jsxs(PopupWrap, __assign({ ref: node }, props.rimbleProps, { onClick: function () { return setIsOpen(!isOpen); } }, { children: [props.children, jsx_runtime_1.jsx(PopupBox, __assign({ className: !props.triggerOnClick ? "hoverable" : isOpen ? "open" : undefined, arrowOffset: props.arrowOffset || 10, popupTopPos: props.popupTopPos || "calc(100% + 10px)", popupRightPos: props.popupRightPos || 0, onClick: props.remainOpenOnClick && (function (e) { return e.stopPropagation(); }) }, props.popupRimbleProps, { children: props.popupContents }), void 0)] }), void 0));
};
exports.Popup = Popup;
var templateObject_1, templateObject_2, templateObject_3;
//# sourceMappingURL=Popup.js.map