"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TabbedSearch = exports.TabbedSearchBox = exports.StyledTabbedInput = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var styled_components_1 = __importDefault(require("styled-components"));
var rimble_ui_1 = require("rimble-ui");
var themes_1 = require("../../themes");
var layouts_1 = require("../layouts");
var Icons_1 = require("./Icons");
exports.StyledTabbedInput = styled_components_1.default(rimble_ui_1.Input)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  border-radius: 0 0 4px 4px !important;\n  border: 0 !important;\n  padding: 34px 50px 34px 24px !important;\n  width: 100%;\n"], ["\n  border-radius: 0 0 4px 4px !important;\n  border: 0 !important;\n  padding: 34px 50px 34px 24px !important;\n  width: 100%;\n"])));
var TabbedSearchBox = function (props) {
    var urlParams = new URLSearchParams(window.location.search);
    var filter = urlParams.get("filter");
    var _a = react_1.useState(filter || ""), search = _a[0], setSearch = _a[1];
    function onKeyDown(event) {
        if (event.code === "Enter") {
            props.onSearch(search);
        }
    }
    return (jsx_runtime_1.jsxs(rimble_ui_1.Box, __assign({ position: "relative", width: "100%" }, { children: [jsx_runtime_1.jsx(exports.StyledTabbedInput, { onChange: function (event) { return setSearch(event.target.value); }, onKeyDown: function (event) { return onKeyDown(event); }, placeholder: props.placeholderText || "Search", required: true, type: "text", value: search }, void 0),
            jsx_runtime_1.jsx(rimble_ui_1.Button.Text, __assign({ onClick: function () { return props.onSearch(search); }, style: { position: "absolute", top: 10, right: 5, zIndex: 9 } }, { children: jsx_runtime_1.jsx(Icons_1.SearchIcon, {}, void 0) }), void 0)] }), void 0));
};
exports.TabbedSearchBox = TabbedSearchBox;
var TabbedSearch = function (props) {
    var _a = react_1.useState(props.activeTab), activeTabName = _a[0], setActiveTabName = _a[1];
    return (jsx_runtime_1.jsx(rimble_ui_1.Box, __assign({ border: 2, borderRadius: 1 }, { children: jsx_runtime_1.jsx(layouts_1.Tabs, { bg: themes_1.colors.primary.background, tabs: props.tabs, activeTabName: activeTabName, onTabClicked: function (tabName) { return setActiveTabName(tabName); } }, void 0) }), void 0));
};
exports.TabbedSearch = TabbedSearch;
var templateObject_1;
//# sourceMappingURL=TabbedSearch.js.map