"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Nav = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var react_2 = require("react");
var react_router_dom_1 = require("react-router-dom");
var icons_1 = require("@rimble/icons");
var rimble_ui_1 = require("rimble-ui");
var SertoUiContext_1 = require("../../../context/SertoUiContext");
var themes_1 = require("../../../themes");
var NavComponents_1 = require("./NavComponents");
var Nav = function (props) {
    var context = react_2.useContext(SertoUiContext_1.SertoUiContext);
    var navItems = props.navItems || context.navItems;
    return (jsx_runtime_1.jsx(jsx_runtime_1.Fragment, { children: navItems === null || navItems === void 0 ? void 0 : navItems.map(function (navItemProps) { return (react_1.createElement(NavItem, __assign({}, navItemProps, { currentUrl: props.currentUrl, hasPermissions: props.hasPermissions, key: navItemProps.url, currentSection: props.currentSection }))); }) }, void 0));
};
exports.Nav = Nav;
var NavItem = function (props) {
    var currentSection = props.currentSection, currentUrl = props.currentUrl, hasPermissions = props.hasPermissions, icon = props.icon, section = props.section, subNav = props.subNav, text = props.text, url = props.url;
    var sectionActive = section ? section === currentSection : url === currentUrl;
    var _a = react_2.useState(sectionActive), isOpen = _a[0], setIsOpen = _a[1];
    if (subNav) {
        return (jsx_runtime_1.jsxs(NavComponents_1.NavItemTabsStyled, __assign({ active: sectionActive, open: isOpen, bg: sectionActive || isOpen ? themes_1.baseColors.white : "none", borderRadius: 1, mb: 1, p: 1 }, { children: [jsx_runtime_1.jsxs(rimble_ui_1.Flex, __assign({ alignItems: "center", justifyContent: "space-between", onClick: function () { return setIsOpen(!isOpen); }, p: "8px", width: "100%" }, { children: [jsx_runtime_1.jsx(NavComponents_1.NavItemPrimary, { active: sectionActive, icon: icon, text: text }, void 0),
                        isOpen ? jsx_runtime_1.jsx(icons_1.KeyboardArrowUp, { color: themes_1.colors.moonGray }, void 0) : jsx_runtime_1.jsx(icons_1.KeyboardArrowDown, { color: themes_1.colors.moonGray }, void 0)] }), void 0),
                isOpen && (subNav === null || subNav === void 0 ? void 0 : subNav.map(function (tab, i) {
                    var subNavActive = currentUrl === tab.url;
                    if (tab.admin && !hasPermissions) {
                        return jsx_runtime_1.jsx(react_2.Fragment, {}, i);
                    }
                    return (jsx_runtime_1.jsx(NavComponents_1.SubNavItemStyled, __assign({ active: subNavActive }, { children: jsx_runtime_1.jsx(react_router_dom_1.Link, __assign({ to: react_router_dom_1.generatePath(tab.url) }, { children: jsx_runtime_1.jsx(rimble_ui_1.Text.span, __assign({ color: themes_1.baseColors.black, fontSize: 1, fontWeight: 3, px: 2 }, { children: tab.text }), void 0) }), void 0) }), i));
                }))] }), void 0));
    }
    return (jsx_runtime_1.jsx(NavComponents_1.NavItemStyled, __assign({ className: sectionActive ? "active" : "", active: sectionActive, mb: 1 }, { children: jsx_runtime_1.jsx(react_router_dom_1.Link, __assign({ to: react_router_dom_1.generatePath(url) }, { children: jsx_runtime_1.jsx(NavComponents_1.NavItemPrimary, { active: sectionActive, icon: icon, text: text }, void 0) }), void 0) }), void 0));
};
//# sourceMappingURL=Nav.js.map