"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TBody = exports.TR = exports.TH = exports.THead = exports.SecondaryHeader = exports.HeaderBox = exports.Header = exports.H6 = exports.H5 = exports.H4 = exports.H3 = exports.H2 = exports.H1 = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var styled_components_1 = __importDefault(require("styled-components"));
var rimble_ui_1 = require("rimble-ui");
var themes_1 = require("../../themes/");
// font-size: 48px
var H1 = function (props) {
    return (jsx_runtime_1.jsx(rimble_ui_1.Heading.h1, __assign({ fontFamily: themes_1.fonts.sansSerifHeader }, props, { children: props.children }), void 0));
};
exports.H1 = H1;
// font-size: 32px
var H2 = function (props) {
    return (jsx_runtime_1.jsx(rimble_ui_1.Heading.h2, __assign({ fontFamily: themes_1.fonts.sansSerifHeader, letterSpacing: ".1px" }, props, { children: props.children }), void 0));
};
exports.H2 = H2;
// font-size: 24px
var H3 = function (props) {
    return (jsx_runtime_1.jsx(rimble_ui_1.Heading.h3, __assign({ fontFamily: themes_1.fonts.sansSerifHeader, letterSpacing: ".3px" }, props, { children: props.children }), void 0));
};
exports.H3 = H3;
// font-size: 20px
var H4 = function (props) {
    return (jsx_runtime_1.jsx(rimble_ui_1.Heading.h4, __assign({ fontFamily: themes_1.fonts.sansSerifHeader }, props, { children: props.children }), void 0));
};
exports.H4 = H4;
// font-size: 16px
var H5 = function (props) {
    return (jsx_runtime_1.jsx(rimble_ui_1.Heading.h5, __assign({ fontFamily: themes_1.fonts.sansSerifHeader }, props, { children: props.children }), void 0));
};
exports.H5 = H5;
// font-size: 14px
var H6 = function (props) {
    return (jsx_runtime_1.jsx(rimble_ui_1.Heading.h6, __assign({ fontFamily: themes_1.fonts.sansSerifHeader }, props, { children: props.children }), void 0));
};
exports.H6 = H6;
var Header = function (props) {
    return (jsx_runtime_1.jsxs(rimble_ui_1.Flex, __assign({ alignItems: "center", justifyContent: "space-between", px: 4, py: 3, minHeight: "4rem" }, { children: [jsx_runtime_1.jsx(exports.H2, __assign({ color: themes_1.colors.primary.base, m: 0 }, { children: props.heading }), void 0), props.children] }), void 0));
};
exports.Header = Header;
var HeaderBox = function (props) {
    return (jsx_runtime_1.jsx(rimble_ui_1.Box, __assign({ bg: themes_1.baseColors.white, borderRadius: 1, mb: 3 }, { children: props.children }), void 0));
};
exports.HeaderBox = HeaderBox;
var SecondaryHeader = function (props) {
    return (jsx_runtime_1.jsxs(rimble_ui_1.Box, __assign({ mb: 4, mt: 5, mx: 4 }, { children: [jsx_runtime_1.jsx(exports.H3, __assign({ mb: 2, mt: 0 }, { children: props.heading }), void 0),
            jsx_runtime_1.jsxs(rimble_ui_1.Flex, __assign({ alignItems: "center", justifyContent: "space-between" }, { children: [props.activeTenantID && (jsx_runtime_1.jsxs(rimble_ui_1.Text, __assign({ fontSize: 2, color: themes_1.colors.silver }, { children: ["Organization ID: ", props.activeTenantID] }), void 0)), props.children] }), void 0)] }), void 0));
};
exports.SecondaryHeader = SecondaryHeader;
exports.THead = styled_components_1.default.thead(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  border-top: 1px solid #edecfa;\n\n  th:first-of-type {\n    padding: 16px 16px 16px 24px !important;\n  }\n\n  th:last-of-type {\n    padding: 16px 24px 16px 16px !important;\n  }\n"], ["\n  border-top: 1px solid #edecfa;\n\n  th:first-of-type {\n    padding: 16px 16px 16px 24px !important;\n  }\n\n  th:last-of-type {\n    padding: 16px 24px 16px 16px !important;\n  }\n"])));
var TH = function (props) {
    return (jsx_runtime_1.jsx("th", __assign({ style: __assign({ borderTop: "none", padding: "16px", textTransform: "none" }, props.style) }, { children: jsx_runtime_1.jsx(rimble_ui_1.Text.span, __assign({ color: themes_1.colors.lightSilver, fontFamily: themes_1.fonts.sansSerif, fontSize: 2, fontWeight: 3, lineHeight: "title" }, { children: props.children }), void 0) }), void 0));
};
exports.TH = TH;
exports.TR = styled_components_1.default.tr(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  border-bottom: 1px solid #edecfa;\n"], ["\n  border-bottom: 1px solid #edecfa;\n"])));
exports.TBody = styled_components_1.default.tbody(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  tr {\n    height: auto;\n  }\n\n  td {\n    font-size: 16px;\n    padding: 30px 16px;\n  }\n\n  td:first-of-type {\n    padding: 30px 16px 30px 24px !important;\n  }\n\n  td:last-of-type {\n    padding: 30px 24px 30px 16px !important;\n  }\n"], ["\n  tr {\n    height: auto;\n  }\n\n  td {\n    font-size: 16px;\n    padding: 30px 16px;\n  }\n\n  td:first-of-type {\n    padding: 30px 16px 30px 24px !important;\n  }\n\n  td:last-of-type {\n    padding: 30px 24px 30px 16px !important;\n  }\n"])));
var templateObject_1, templateObject_2, templateObject_3;
//# sourceMappingURL=LayoutComponents.js.map