"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CredentialDetailsTDLeft = exports.CredentialDetailsTDRight = exports.CredentialTDLeft = exports.CredentialTDRight = exports.CredentialTR = exports.CredentialJsonDownload = exports.QRCodeExpand = exports.CredentialEmbed = exports.CredentialFooter = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var icons_1 = require("@rimble/icons");
var rimble_ui_1 = require("rimble-ui");
var elements_1 = require("../../elements");
var layouts_1 = require("../../layouts");
var context_1 = require("../../../context");
var themes_1 = require("../../../themes");
var useVcSchema_1 = require("../../../services/useVcSchema");
var CredentialShare_1 = require("./CredentialShare");
var SocialMediaVerify_1 = require("./CredentialShare/SocialMediaVerify");
var ShareViaQr_1 = require("./CredentialShare/ShareViaQr");
var CredentialFooter = function (props) {
    var _a, _b;
    return (jsx_runtime_1.jsxs(rimble_ui_1.Flex, __assign({ alignItems: "center", justifyContent: "space-between" }, { children: [jsx_runtime_1.jsxs(rimble_ui_1.Flex, { children: [jsx_runtime_1.jsx(exports.CredentialJsonDownload, { vc: props.vc }, void 0),
                    props.renderContext !== context_1.RENDER_CONTEXT.VC_EMBED && (jsx_runtime_1.jsxs(jsx_runtime_1.Fragment, { children: [jsx_runtime_1.jsx(rimble_ui_1.Box, __assign({ mr: 2 }, { children: jsx_runtime_1.jsx(CredentialShare_1.CredentialShareButton, { vc: props.vc }, void 0) }), void 0),
                            ((_a = props.vc.proof) === null || _a === void 0 ? void 0 : _a.jwt) && jsx_runtime_1.jsx(exports.CredentialEmbed, { jwt: props.vc.proof.jwt }, void 0)] }, void 0)),
                    props.vcUrl && ((_b = props.vc.proof) === null || _b === void 0 ? void 0 : _b.jwt) && (jsx_runtime_1.jsxs(jsx_runtime_1.Fragment, { children: [props.renderContext !== context_1.RENDER_CONTEXT.VC_EMBED && jsx_runtime_1.jsx(exports.QRCodeExpand, { vcUrl: props.vcUrl }, void 0),
                            jsx_runtime_1.jsx(elements_1.CopyToClipboard, { color: themes_1.colors.midGray, iconPadding: 1, hoverTitle: "Copy Token", size: "15px", text: props.vc.proof.jwt }, void 0),
                            jsx_runtime_1.jsx(rimble_ui_1.Box, __assign({ mt: "1px", ml: 2, p: "3px" }, { children: jsx_runtime_1.jsx(SocialMediaVerify_1.SocialMediaVerify, { vc: props.vc, vcUrl: props.vcUrl }, void 0) }), void 0)] }, void 0))] }, void 0),
            props.expired && jsx_runtime_1.jsx(elements_1.ExpiredPill, {}, void 0),
            props.renderContext !== context_1.RENDER_CONTEXT.VC_EMBED ? (jsx_runtime_1.jsx(rimble_ui_1.Flex, __assign({ alignItems: "center", color: themes_1.colors.silver, fontSize: 0, fontFamily: themes_1.fonts.sansSerif, onClick: function () { return props.setIsOpen(!props.isOpen); }, style: { cursor: "pointer" } }, { children: props.isOpen ? (jsx_runtime_1.jsxs(jsx_runtime_1.Fragment, { children: ["Collapse", jsx_runtime_1.jsx(icons_1.KeyboardArrowUp, { color: themes_1.colors.midGray, ml: 1, size: "18px" }, void 0)] }, void 0)) : (jsx_runtime_1.jsxs(jsx_runtime_1.Fragment, { children: ["Expand", jsx_runtime_1.jsx(icons_1.KeyboardArrowDown, { color: themes_1.colors.midGray, ml: 1, size: "18px" }, void 0)] }, void 0)) }), void 0)) : (jsx_runtime_1.jsx(jsx_runtime_1.Fragment, { children: props.vcUrl && (jsx_runtime_1.jsx(rimble_ui_1.Button.Text, __assign({ as: "a", href: props.vcUrl, size: "small", target: "_blank" }, { children: jsx_runtime_1.jsxs(rimble_ui_1.Flex, __assign({ alignItems: "center" }, { children: ["Verify on Serto Search ", jsx_runtime_1.jsx(icons_1.OpenInNew, { color: themes_1.colors.primary.base, ml: 1, size: "18px" }, void 0)] }), void 0) }), void 0)) }, void 0))] }), void 0));
};
exports.CredentialFooter = CredentialFooter;
var CredentialEmbed = function (props) {
    var _a = react_1.useState(false), isEmbedModalOpen = _a[0], setIsEmbedModalOpen = _a[1];
    var embedHtml = "<iframe src=\"https://search.serto.id/vc-embed?vc=" + props.jwt + "\" sandbox=\"allow-popups allow-same-origin allow-scripts\" style=\"border: none;\" width=\"480px\" height=\"160px\"></iframe>";
    return (jsx_runtime_1.jsxs(jsx_runtime_1.Fragment, { children: [jsx_runtime_1.jsx(elements_1.UnstyledButton, __assign({ onClick: function () { return setIsEmbedModalOpen(true); }, mr: 2 }, { children: jsx_runtime_1.jsx(rimble_ui_1.Box, __assign({ p: 1, title: "View Embed Code" }, { children: jsx_runtime_1.jsx(elements_1.HoverSvgFill, { children: jsx_runtime_1.jsx(icons_1.Code, { color: themes_1.colors.midGray, size: "18px" }, void 0) }, void 0) }), void 0) }), void 0),
            jsx_runtime_1.jsx(elements_1.ModalWithX, __assign({ borderRadius: 2, isOpen: isEmbedModalOpen, close: function () { return setIsEmbedModalOpen(false); } }, { children: jsx_runtime_1.jsxs(rimble_ui_1.Box, __assign({ borderRadius: 2, maxWidth: "450px", pb: 3, px: 3 }, { children: [jsx_runtime_1.jsx(layouts_1.H3, __assign({ mt: 0 }, { children: "Embed Credential" }), void 0),
                        jsx_runtime_1.jsxs(rimble_ui_1.Box, __assign({ position: "relative" }, { children: [jsx_runtime_1.jsx(rimble_ui_1.Box, __assign({ position: "absolute", right: 3, top: 3, zIndex: 1 }, { children: jsx_runtime_1.jsx(elements_1.CopyToClipboard, { text: embedHtml }, void 0) }), void 0),
                                jsx_runtime_1.jsx(rimble_ui_1.Box, __assign({ bg: themes_1.colors.nearWhite, borderRadius: 1, maxHeight: "300px", p: 3, style: { overflow: "scroll", overflowWrap: "break-word" } }, { children: jsx_runtime_1.jsx("code", __assign({ style: { fontSize: "12px" } }, { children: embedHtml }), void 0) }), void 0)] }), void 0)] }), void 0) }), void 0)] }, void 0));
};
exports.CredentialEmbed = CredentialEmbed;
var QRCodeExpand = function (props) {
    var _a = react_1.useState(false), isQrModalOpen = _a[0], setIsQrModalOpen = _a[1];
    return (jsx_runtime_1.jsxs(jsx_runtime_1.Fragment, { children: [jsx_runtime_1.jsx(elements_1.UnstyledButton, __assign({ onClick: function () { return setIsQrModalOpen(true); }, mr: 2 }, { children: jsx_runtime_1.jsx(rimble_ui_1.Box, __assign({ p: 1, title: "View QR Code" }, { children: jsx_runtime_1.jsx(elements_1.HoverPathStroke, { children: jsx_runtime_1.jsx(elements_1.QrCode, { color: themes_1.colors.midGray, size: "18px" }, void 0) }, void 0) }), void 0) }), void 0),
            jsx_runtime_1.jsx(elements_1.ModalWithX, __assign({ borderRadius: 2, isOpen: isQrModalOpen, close: function () { return setIsQrModalOpen(false); } }, { children: jsx_runtime_1.jsxs(rimble_ui_1.Box, __assign({ bg: themes_1.baseColors.white, borderRadius: 2, maxWidth: "450px", pb: 5, px: 6 }, { children: [jsx_runtime_1.jsx(rimble_ui_1.Text, __assign({ color: themes_1.colors.midGray, my: 3, textAlign: "center" }, { children: "Scan to Verify on Serto Search" }), void 0),
                        jsx_runtime_1.jsx(ShareViaQr_1.ShareViaQr, { url: props.vcUrl }, void 0)] }), void 0) }), void 0)] }, void 0));
};
exports.QRCodeExpand = QRCodeExpand;
var CredentialJsonDownload = function (props) {
    var vcSchema = useVcSchema_1.useVcSchema(props.vc).vcSchema;
    var fileName = (vcSchema === null || vcSchema === void 0 ? void 0 : vcSchema.slug) ? vcSchema.slug + ".json" : "credential.json";
    var credential = "text/json;charset=utf-8," + encodeURIComponent(JSON.stringify(props.vc));
    return (jsx_runtime_1.jsx(rimble_ui_1.Link, __assign({ href: "data:" + credential, download: fileName, mr: 2, p: 1, title: "Download Credential JSON" }, { children: jsx_runtime_1.jsx(elements_1.HoverSvgFill, { children: jsx_runtime_1.jsx(icons_1.FileDownload, { color: themes_1.colors.midGray, size: "18px" }, void 0) }, void 0) }), void 0));
};
exports.CredentialJsonDownload = CredentialJsonDownload;
var CredentialTR = function (props) {
    return (jsx_runtime_1.jsx("tr", __assign({ style: {
            height: "auto",
        } }, { children: props.children }), void 0));
};
exports.CredentialTR = CredentialTR;
var CredentialTDRight = function (props) {
    return (jsx_runtime_1.jsx("td", __assign({ style: {
            border: "none",
            padding: "5px 0",
            textAlign: "right",
            verticalAlign: "top",
            wordBreak: "break-word",
        } }, { children: jsx_runtime_1.jsx(rimble_ui_1.Text.span, __assign({ color: themes_1.baseColors.black, fontFamily: themes_1.fonts.sansSerif, fontSize: 1, lineHeight: "copy" }, { children: props.children }), void 0) }), void 0));
};
exports.CredentialTDRight = CredentialTDRight;
var CredentialTDLeft = function (props) {
    return (jsx_runtime_1.jsx("td", __assign({ style: {
            border: "none",
            padding: "5px 0",
            verticalAlign: "top",
        } }, { children: jsx_runtime_1.jsx(rimble_ui_1.Text.span, __assign({ color: themes_1.colors.silver, fontFamily: themes_1.fonts.sansSerif, fontSize: 1, lineHeight: "copy" }, { children: props.children }), void 0) }), void 0));
};
exports.CredentialTDLeft = CredentialTDLeft;
var CredentialDetailsTDRight = function (props) {
    return (jsx_runtime_1.jsx("td", __assign({ style: {
            border: "none",
            padding: "3px 0",
            textAlign: "right",
            verticalAlign: "top",
            wordBreak: "break-word",
        } }, { children: jsx_runtime_1.jsx(rimble_ui_1.Text.span, __assign({ color: themes_1.colors.silver, fontFamily: themes_1.fonts.sansSerif, fontSize: 0, lineHeight: "copy" }, { children: props.children }), void 0) }), void 0));
};
exports.CredentialDetailsTDRight = CredentialDetailsTDRight;
var CredentialDetailsTDLeft = function (props) {
    return (jsx_runtime_1.jsx("td", __assign({ style: {
            border: "none",
            padding: "3px 0",
            verticalAlign: "top",
        } }, { children: jsx_runtime_1.jsx(rimble_ui_1.Text.span, __assign({ color: props.color || themes_1.colors.silver, fontFamily: themes_1.fonts.sansSerif, fontSize: 0, lineHeight: "copy" }, { children: props.children }), void 0) }), void 0));
};
exports.CredentialDetailsTDLeft = CredentialDetailsTDLeft;
//# sourceMappingURL=CredentialComponents.js.map