"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CredentialHeader = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
// import { usePalette } from "react-palette";
// import { readableColor } from "polished";
var utils_1 = require("../../../utils");
var rimble_ui_1 = require("rimble-ui");
var elements_1 = require("../../elements");
var layouts_1 = require("../../layouts");
var themes_1 = require("../../../themes");
var vc_schema_tools_1 = require("vc-schema-tools");
var CredentialHeader = function (props) {
    var issuer = props.issuer, issuerDomain = props.issuerDomain, vc = props.vc, vcSchema = props.vcSchema, vcType = props.vcType;
    var _a = react_1.useState(), isValid = _a[0], setIsValid = _a[1];
    // TODO add org profile data
    /*let logoUrl = "https://www.google.com/s2/favicons?sz=64&domain=" + issuerDomain;
    const googleProxyURL =
      "https://images1-focus-opensocial.googleusercontent.com/gadgets/proxy?container=focus&refresh=2592000&url=";
    logoUrl = googleProxyURL + encodeURIComponent(logoUrl);
    const { data, loading, error } = usePalette(logoUrl);
    const backgroundColor = loading ? "transparent" : error ? colors.primary.base : data.vibrant;
    const textColor = loading ? "transparent" : error ? baseColors.white : readableColor(data.vibrant);*/
    var backgroundColor = themes_1.colors.primary.base;
    var textColor = themes_1.baseColors.white;
    react_1.useEffect(function () {
        return void (function validate() {
            return __awaiter(this, void 0, void 0, function () {
                var valid, error_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _a.trys.push([0, 2, , 3]);
                            return [4 /*yield*/, vc_schema_tools_1.validateVc(vc)];
                        case 1:
                            valid = (_a.sent()).valid;
                            if (valid) {
                                setIsValid(true);
                            }
                            else {
                                setIsValid(false);
                            }
                            return [3 /*break*/, 3];
                        case 2:
                            error_1 = _a.sent();
                            console.error("error verifying vc: ", error_1);
                            setIsValid(false);
                            return [3 /*break*/, 3];
                        case 3: return [2 /*return*/];
                    }
                });
            });
        })();
    }, [vc]);
    return (jsx_runtime_1.jsxs(rimble_ui_1.Box, __assign({ bg: backgroundColor, px: 3, pb: 3, pt: 2 }, { children: [jsx_runtime_1.jsxs(rimble_ui_1.Flex, __assign({ alignItems: "center", justifyContent: "space-between", mb: 3 }, { children: [issuerDomain ? (jsx_runtime_1.jsxs(rimble_ui_1.Flex, __assign({ alignItems: "center" }, { children: [jsx_runtime_1.jsx(elements_1.DomainImage, { background: true, domain: issuerDomain }, void 0),
                            jsx_runtime_1.jsx(rimble_ui_1.Text.span, __assign({ color: textColor, fontFamily: themes_1.fonts.sansSerif, fontSize: 1, mx: 2, style: { overflowX: "hidden", textOverflow: "ellipsis" } }, { children: issuerDomain }), void 0)] }), void 0)) : (jsx_runtime_1.jsx(rimble_ui_1.Text.span, __assign({ color: textColor, fontFamily: themes_1.fonts.sansSerif, fontSize: 1, mr: 2, style: { overflowX: "hidden", textOverflow: "ellipsis" }, title: issuer }, { children: utils_1.truncateDid(issuer) }), void 0)),
                    isValid ? jsx_runtime_1.jsx(elements_1.LockVerified, {}, void 0) : jsx_runtime_1.jsx(elements_1.LockUnverified, {}, void 0)] }), void 0),
            jsx_runtime_1.jsxs(rimble_ui_1.Flex, { children: [(vcSchema === null || vcSchema === void 0 ? void 0 : vcSchema.icon) && (jsx_runtime_1.jsx(rimble_ui_1.Flex, __assign({ alignItems: "center", bg: themes_1.baseColors.white, border: 2, borderRadius: "50%", fontSize: "24px", height: "40px", justifyContent: "center", mr: 2, width: "40px" }, { children: vcSchema.icon }), void 0)),
                    jsx_runtime_1.jsxs(rimble_ui_1.Box, __assign({ flexGrow: "1" }, { children: [jsx_runtime_1.jsx(layouts_1.H4, __assign({ color: textColor, fontFamily: themes_1.fonts.sansSerif, my: 0 }, { children: (vcSchema === null || vcSchema === void 0 ? void 0 : vcSchema.name) || vc.credentialSubject.title || vcType }), void 0),
                            vc.credentialSubject.id && (jsx_runtime_1.jsxs(rimble_ui_1.Text, __assign({ color: textColor, fontFamily: themes_1.fonts.sansSerif, fontSize: 1, fontWeight: 3 }, { children: ["Subject: ", utils_1.truncateDid(vc.credentialSubject.id)] }), void 0))] }), void 0)] }, void 0)] }), void 0));
};
exports.CredentialHeader = CredentialHeader;
//# sourceMappingURL=CredentialHeader.js.map