"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CredentialProperty = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var rimble_ui_1 = require("rimble-ui");
var icons_1 = require("@rimble/icons");
var helpers_1 = require("../../../utils/helpers");
var CredentialComponents_1 = require("./CredentialComponents");
var colors_1 = require("../../../themes/colors");
var CredentialProperty = function (props) {
    var schema = props.schema, keyName = props.keyName, value = props.value;
    var nestedLevel = props.nestedLevel || 0;
    var parentKey = props.parentKey || "";
    var keyDisplay = (schema === null || schema === void 0 ? void 0 : schema.title) || keyName;
    var keyDescription = schema === null || schema === void 0 ? void 0 : schema.description;
    var valueDisplay = "";
    var valueTooltip = "";
    if (value === "boolean" || Array.isArray(value)) {
        valueDisplay = JSON.stringify(value);
    }
    else if (typeof value === "string" && value.indexOf("0x") !== -1) {
        valueDisplay = helpers_1.hexEllipsis(value);
        valueTooltip = value;
    }
    else if (value && typeof value !== "object") {
        valueDisplay = value;
    }
    return (jsx_runtime_1.jsxs(jsx_runtime_1.Fragment, { children: [jsx_runtime_1.jsxs(CredentialComponents_1.CredentialTR, { children: [jsx_runtime_1.jsx(CredentialComponents_1.CredentialTDLeft, { children: jsx_runtime_1.jsxs(rimble_ui_1.Box, __assign({ pl: nestedLevel * 24 }, { children: [keyDisplay, keyDescription && (jsx_runtime_1.jsx(rimble_ui_1.Tooltip, __assign({ message: keyDescription, placement: "top" }, { children: jsx_runtime_1.jsx(icons_1.Info, { size: 16, color: colors_1.colors.silver, ml: 1, style: { verticalAlign: "text-bottom" } }, void 0) }), void 0))] }), void 0) }, void 0),
                    jsx_runtime_1.jsx(CredentialComponents_1.CredentialTDRight, { children: valueTooltip ? (jsx_runtime_1.jsx(rimble_ui_1.Tooltip, __assign({ message: valueTooltip, placement: "top" }, { children: jsx_runtime_1.jsx(rimble_ui_1.Box, { children: valueDisplay }, void 0) }), void 0)) : (valueDisplay) }, void 0)] }, void 0),
            value &&
                typeof value === "object" &&
                !Array.isArray(value) &&
                Object.entries(value).map(function (_a) {
                    var _b;
                    var nestedKey = _a[0], nestedValue = _a[1];
                    return (jsx_runtime_1.jsx(exports.CredentialProperty, { keyName: nestedKey, value: nestedValue, nestedLevel: nestedLevel + 1, parentKey: parentKey + keyName, schema: (_b = schema === null || schema === void 0 ? void 0 : schema.properties) === null || _b === void 0 ? void 0 : _b[nestedKey] }, nestedKey));
                })] }, void 0));
};
exports.CredentialProperty = CredentialProperty;
//# sourceMappingURL=CredentialProperty.js.map