"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ShareViaDidComm = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var rimble_ui_1 = require("rimble-ui");
var icons_1 = require("@rimble/icons");
var DidSearchWithMessagingInfo_1 = require("../../../elements/DidSearchWithMessagingInfo");
var SertoUiContext_1 = require("../../../../context/SertoUiContext");
var ShareViaDidComm = function (props) {
    var vc = props.vc;
    var context = react_1.useContext(SertoUiContext_1.SertoUiContext);
    var _a = react_1.useState(false), loading = _a[0], setLoading = _a[1];
    var _b = react_1.useState(false), success = _b[0], setSuccess = _b[1];
    var _c = react_1.useState(""), error = _c[0], setError = _c[1];
    var _d = react_1.useState(""), recipientDid = _d[0], setRecipientDid = _d[1];
    var _e = react_1.useState(false), recipientSupportsMessaging = _e[0], setRecipientSupportsMessaging = _e[1];
    react_1.useEffect(function () {
        setError("");
    }, [recipientDid, recipientSupportsMessaging]);
    function sendVc(e) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function () {
            var senderDid_1, senderDidBelongsToUser, err_1;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        e.preventDefault();
                        if (!recipientDid || !recipientSupportsMessaging) {
                            return [2 /*return*/];
                        }
                        if (!context.sendVc) {
                            console.error("serto-ui context missing sendVc", context);
                            setError("This Serto instance is missing the ability to send VCs via DIDComm.");
                            return [2 /*return*/];
                        }
                        setError("");
                        setLoading(true);
                        setSuccess(false);
                        _c.label = 1;
                    case 1:
                        _c.trys.push([1, 3, , 4]);
                        senderDid_1 = typeof vc.issuer === "string" ? vc.issuer : vc.issuer.id;
                        senderDidBelongsToUser = (_a = context.userDids) === null || _a === void 0 ? void 0 : _a.some(function (did) { return did.did === senderDid_1; });
                        if (!senderDidBelongsToUser) {
                            if (!((_b = context.userDids) === null || _b === void 0 ? void 0 : _b[0])) {
                                throw Error("VC issuer DID " + senderDid_1 + " does not belong to user, and could not get any user DIDs to use as DIDComm sender");
                            }
                            // @TODO/tobek Is this the right behavior in this case?
                            console.warn("VC issuer " + senderDid_1 + " does not belong to user, sending VC from user's first DID instead", context.userDids[0]);
                            senderDid_1 = context.userDids[0].did;
                        }
                        return [4 /*yield*/, context.sendVc(senderDid_1, recipientDid, vc)];
                    case 2:
                        _c.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        err_1 = _c.sent();
                        console.error("failed to send VC:", err_1);
                        setError("Failed to send credential to subject: " + err_1.message);
                        setLoading(false);
                        return [2 /*return*/];
                    case 4:
                        setLoading(false);
                        setSuccess(true);
                        return [2 /*return*/];
                }
            });
        });
    }
    return (jsx_runtime_1.jsxs(rimble_ui_1.Form, __assign({ onSubmit: sendVc }, { children: [jsx_runtime_1.jsxs(rimble_ui_1.Flex, { children: [jsx_runtime_1.jsx(rimble_ui_1.Box, __assign({ width: "100%" }, { children: jsx_runtime_1.jsx(DidSearchWithMessagingInfo_1.DidSearchWithMessagingInfo, { required: true, onChange: function (val) { return setRecipientDid(val.did); }, supportsMessaging: recipientSupportsMessaging, setSupportsMessaging: setRecipientSupportsMessaging, messagingUnsupportedText: "This DID does not support receiving credentials via DIDComm." }, void 0) }), void 0),
                    jsx_runtime_1.jsx(rimble_ui_1.Button, __assign({ type: "submit", disabled: !recipientDid || !recipientSupportsMessaging, ml: 2 }, { children: jsx_runtime_1.jsx(rimble_ui_1.Flex, __assign({ alignItems: "center" }, { children: loading ? (jsx_runtime_1.jsx(rimble_ui_1.Loader, { color: "white" }, void 0)) : (jsx_runtime_1.jsxs(jsx_runtime_1.Fragment, { children: [jsx_runtime_1.jsx(icons_1.Send, { size: "24px", mr: 2 }, void 0), " Send"] }, void 0)) }), void 0) }), void 0)] }, void 0),
            recipientDid && error && (jsx_runtime_1.jsx(rimble_ui_1.Flash, __assign({ mt: 3, variant: "danger" }, { children: error }), void 0)),
            recipientDid && success && (jsx_runtime_1.jsx(rimble_ui_1.Flash, __assign({ mt: 3, variant: "success" }, { children: "Credential sent successfully." }), void 0))] }), void 0));
};
exports.ShareViaDidComm = ShareViaDidComm;
//# sourceMappingURL=ShareViaDidComm.js.map