"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ShareViaQr = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var rimble_ui_1 = require("rimble-ui");
var icons_1 = require("@rimble/icons");
var styled_components_1 = __importDefault(require("styled-components"));
var qrcode_react_1 = __importDefault(require("qrcode.react"));
var themes_1 = require("../../../../themes");
var helpers_1 = require("../../../../utils/helpers");
var StyledQRCode = styled_components_1.default(qrcode_react_1.default)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  max-width: 100%;\n  height: auto !important;\n"], ["\n  max-width: 100%;\n  height: auto !important;\n"])));
var ShareViaQr = function (props) {
    var url = props.url, inline = props.inline;
    var _a = react_1.useState(), canvas = _a[0], setCanvas = _a[1];
    var _b = react_1.useState(false), copied = _b[0], setCopied = _b[1];
    react_1.useEffect(function () {
        if (copied) {
            setTimeout(function () {
                setCopied(false);
            }, 2500);
        }
    }, [copied]);
    var getCanvasNode = react_1.useCallback(function (node) {
        setCanvas(node === null || node === void 0 ? void 0 : node.querySelector("canvas"));
    }, []);
    var PrimaryButton = inline ? rimble_ui_1.Button : rimble_ui_1.Button.Text;
    var SecondaryButton = inline ? rimble_ui_1.Button.Outline : rimble_ui_1.Button.Text;
    return (jsx_runtime_1.jsxs(rimble_ui_1.Flex, __assign({ flexDirection: inline ? "row" : "column", alignItems: "center" }, { children: [jsx_runtime_1.jsx(rimble_ui_1.Box, __assign({ ref: getCanvasNode, p: 3, mb: inline ? 0 : 4, border: inline ? 4 : undefined, backgroundColor: inline ? themes_1.colors.nearWhite : "transparent", maxWidth: 8 }, { children: jsx_runtime_1.jsx(StyledQRCode, { value: url, renderAs: "canvas", size: 512, bgColor: "transparent" }, void 0) }), void 0),
            jsx_runtime_1.jsxs(rimble_ui_1.Flex, __assign({ pl: inline ? 4 : 0, flexDirection: "column", justifyContent: "center" }, { children: [jsx_runtime_1.jsxs(PrimaryButton, __assign({ size: "small", mb: 3, onClick: function () { return canvas && helpers_1.downloadCanvasImage(canvas, "credential-QR-code.png"); } }, { children: [jsx_runtime_1.jsx(icons_1.FileDownload, { size: "15px", mr: 2 }, void 0), " Download QR code"] }), void 0),
                    helpers_1.copyImageSupported && (jsx_runtime_1.jsxs(SecondaryButton, __assign({ size: "small", onClick: function () { return canvas && setCopied(helpers_1.copyCanvasImage(canvas)); } }, { children: [jsx_runtime_1.jsx(icons_1.ContentCopy, { size: "15px", mr: 2 }, void 0), " ", copied ? "Copied" : "Copy to clipboard"] }), void 0))] }), void 0)] }), void 0));
};
exports.ShareViaQr = ShareViaQr;
var templateObject_1;
//# sourceMappingURL=ShareViaQr.js.map