"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SocialMediaVerify = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var styled_components_1 = __importDefault(require("styled-components"));
var react_1 = require("react");
var rimble_ui_1 = require("rimble-ui");
var Icons_1 = require("../../../elements/Icons");
var colors_1 = require("../../../../themes/colors");
var Modals_1 = require("../../../elements/Modals");
var CopyToClipboard_1 = require("../../../elements/CopyToClipboard/CopyToClipboard");
var ShareTextTextarea = styled_components_1.default.textarea(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  width: 100%;\n  height: 320px;\n"], ["\n  width: 100%;\n  height: 320px;\n"])));
function getShareLink(vc, vcUrl) {
    var profileUrl = vc.type.includes("SocialMediaProfileLinkage") && vc.credentialSubject.socialMediaProfileUrl;
    if (!profileUrl) {
        return {};
    }
    var shareText = "I'm linking this account to my Decentralized Identifier (DID)\n\nMy credential \uD83D\uDC49 " + vcUrl;
    var shareLink;
    var Icon;
    var showCopyModal = false;
    var siteName;
    if (profileUrl.includes("twitter.com")) {
        shareLink = "https://twitter.com/intent/tweet?hashtags=SertoID&text=" + encodeURIComponent(shareText);
        Icon = Icons_1.TwitterBird;
        siteName = "Twitter";
    }
    else if (profileUrl.includes("linkedin.com")) {
        shareLink = "https://www.linkedin.com/sharing/share-offsite/?url=" + encodeURIComponent(vcUrl);
        Icon = Icons_1.LinkedIn;
        siteName = "LinkedIn";
    }
    else if (profileUrl.includes("facebook.com")) {
        shareLink = "https://www.facebook.com/sharer.php?u=" + encodeURIComponent(vcUrl);
        Icon = Icons_1.Facebook;
        siteName = "Facebook";
    }
    else if (profileUrl.includes("medium.com")) {
        showCopyModal = true;
        Icon = Icons_1.Medium;
        siteName = "Medium";
    }
    else if (profileUrl.includes("youtube.com")) {
        showCopyModal = true;
        Icon = Icons_1.YouTube;
        siteName = "YouTube";
    }
    return { shareLink: shareLink, Icon: Icon, showCopyModal: showCopyModal, shareText: shareText, siteName: siteName };
}
var SocialMediaVerify = function (props) {
    var _a = getShareLink(props.vc, props.vcUrl), shareLink = _a.shareLink, Icon = _a.Icon, showCopyModal = _a.showCopyModal, shareText = _a.shareText, siteName = _a.siteName;
    var _b = react_1.useState(false), isModalOpen = _b[0], setIsModalOpen = _b[1];
    if (!Icon || !shareText) {
        return null;
    }
    return (jsx_runtime_1.jsxs(jsx_runtime_1.Fragment, { children: [jsx_runtime_1.jsx(rimble_ui_1.Tooltip, __assign({ placement: "top", message: "Verify account by publishing this credential" }, { children: showCopyModal ? (jsx_runtime_1.jsx("span", __assign({ onClick: function () { return setIsModalOpen(true); }, style: { cursor: "pointer" } }, { children: jsx_runtime_1.jsx(Icon, { color: colors_1.baseColors.warning }, void 0) }), void 0)) : (jsx_runtime_1.jsx("a", __assign({ href: shareLink, target: "_blank" }, { children: jsx_runtime_1.jsx(Icon, { color: colors_1.baseColors.warning }, void 0) }), void 0)) }), void 0),
            jsx_runtime_1.jsx(Modals_1.ModalWithX, __assign({ borderRadius: 2, isOpen: isModalOpen, close: function () { return setIsModalOpen(false); } }, { children: jsx_runtime_1.jsxs(rimble_ui_1.Box, __assign({ maxWidth: 9, px: 5, py: 3 }, { children: [jsx_runtime_1.jsxs(rimble_ui_1.Text, __assign({ my: 4 }, { children: ["Copy and paste the following message into your ", siteName, " about page, or into", " ", siteName === "YouTube" ? "the description of a video (can be unlisted)" : "a post", " on your account:"] }), void 0),
                        jsx_runtime_1.jsx(ShareTextTextarea, { value: shareText, readOnly: true }, void 0),
                        jsx_runtime_1.jsx(rimble_ui_1.Box, __assign({ mt: 3 }, { children: jsx_runtime_1.jsx(CopyToClipboard_1.CopyToClipboard, { textButton: true, text: shareText }, void 0) }), void 0),
                        jsx_runtime_1.jsx(rimble_ui_1.Text, __assign({ my: 4 }, { children: "Note that you may change the message, but the URL itself must be included for verification." }), void 0)] }), void 0) }), void 0)] }, void 0));
};
exports.SocialMediaVerify = SocialMediaVerify;
var templateObject_1;
//# sourceMappingURL=SocialMediaVerify.js.map