"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CredentialShareButton = exports.CredentialShare = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var styled_components_1 = __importDefault(require("styled-components"));
var react_1 = require("react");
var rimble_ui_1 = require("rimble-ui");
var icons_1 = require("@rimble/icons");
var elements_1 = require("../../../elements");
var Modals_1 = require("../../../elements/Modals");
var LayoutComponents_1 = require("../../../layouts/LayoutComponents");
var themes_1 = require("../../../../themes");
var config_1 = require("../../../../config");
var CopyableTruncatableText_1 = require("../../../elements/CopyableTruncatableText/CopyableTruncatableText");
var ShareViaDidComm_1 = require("./ShareViaDidComm");
var ShareViaQr_1 = require("./ShareViaQr");
var ShareViaSocial_1 = require("./ShareViaSocial");
var _ShareBox = function (props) { return (jsx_runtime_1.jsx(rimble_ui_1.Box, __assign({ borderBottom: 4, p: 4, className: props.className }, { children: props.children }), void 0)); };
var ShareBox = styled_components_1.default(_ShareBox)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  &:first-child {\n    padding-top: 0;\n  }\n  &:last-child {\n    padding-bottom: 0;\n    border-bottom: none;\n  }\n"], ["\n  &:first-child {\n    padding-top: 0;\n  }\n  &:last-child {\n    padding-bottom: 0;\n    border-bottom: none;\n  }\n"])));
var CredentialShare = function (props) {
    var _a;
    var vc = props.vc, issueVcFlow = props.issueVcFlow;
    if (!((_a = vc.proof) === null || _a === void 0 ? void 0 : _a.jwt)) {
        return jsx_runtime_1.jsx(rimble_ui_1.Flash, __assign({ variant: "danger" }, { children: "Cannot share VC: missing proof.jwt" }), void 0);
    }
    var vcUrl = config_1.config.SEARCH_UI_URL + "/vc-validator?vc=" + vc.proof.jwt;
    return (jsx_runtime_1.jsxs(jsx_runtime_1.Fragment, { children: [jsx_runtime_1.jsxs(ShareBox, { children: [jsx_runtime_1.jsx(LayoutComponents_1.H3, __assign({ mt: 0, mb: 1 }, { children: issueVcFlow ? "Recipient Information" : "Share Credential" }), void 0),
                    jsx_runtime_1.jsx(rimble_ui_1.Text, __assign({ color: themes_1.colors.silver, fontFamily: themes_1.fonts.sansSerif, fontSize: 1 }, { children: "Choose any methods below to send or share credential." }), void 0)] }, void 0),
            jsx_runtime_1.jsxs(ShareBox, { children: [jsx_runtime_1.jsx(LayoutComponents_1.H6, __assign({ mt: 0, mb: 2 }, { children: "Send by Identifier (DID)" }), void 0),
                    jsx_runtime_1.jsx(ShareViaDidComm_1.ShareViaDidComm, { vc: vc }, void 0)] }, void 0),
            jsx_runtime_1.jsxs(ShareBox, { children: [jsx_runtime_1.jsx(LayoutComponents_1.H6, __assign({ mt: 0, mb: 2 }, { children: "Share by link" }), void 0),
                    jsx_runtime_1.jsx(CopyableTruncatableText_1.CopyableTruncatableText, { text: vcUrl, useInput: true, copyButtonOverride: function (copied) { return (jsx_runtime_1.jsx(rimble_ui_1.Button, { children: jsx_runtime_1.jsxs(rimble_ui_1.Flex, __assign({ alignItems: "center" }, { children: [jsx_runtime_1.jsx(icons_1.ContentCopy, { size: "24px", mr: 2 }, void 0), " ", copied ? "Copied" : "Copy"] }), void 0) }, void 0)); } }, void 0)] }, void 0),
            jsx_runtime_1.jsxs(ShareBox, { children: [jsx_runtime_1.jsx(LayoutComponents_1.H6, __assign({ mt: 0, mb: 3 }, { children: "Share on social media" }), void 0),
                    jsx_runtime_1.jsx(ShareViaSocial_1.ShareViaSocial, { vc: vc, vcUrl: vcUrl }, void 0)] }, void 0),
            issueVcFlow && (jsx_runtime_1.jsxs(ShareBox, { children: [jsx_runtime_1.jsx(LayoutComponents_1.H6, __assign({ mt: 0, mb: 3 }, { children: "Share by QR code" }), void 0),
                    jsx_runtime_1.jsx(ShareViaQr_1.ShareViaQr, { url: vcUrl, inline: true }, void 0)] }, void 0))] }, void 0));
};
exports.CredentialShare = CredentialShare;
var CredentialShareButton = function (props) {
    var vc = props.vc;
    var _a = react_1.useState(false), modalOpen = _a[0], setModalOpen = _a[1];
    if (!vc.proof) {
        // VC has no JWT so can't initialize share component - it probably hasn't been isued yet
        return jsx_runtime_1.jsx(jsx_runtime_1.Fragment, {}, void 0);
    }
    return (jsx_runtime_1.jsxs(jsx_runtime_1.Fragment, { children: [props.children || (jsx_runtime_1.jsx(elements_1.UnstyledButton, __assign({ onClick: function () { return setModalOpen(true); } }, { children: jsx_runtime_1.jsx(elements_1.HoverPathFill, { children: jsx_runtime_1.jsx(rimble_ui_1.Box, __assign({ p: 1 }, { children: jsx_runtime_1.jsx(elements_1.ShareIcon, {}, void 0) }), void 0) }, void 0) }), void 0)),
            jsx_runtime_1.jsxs(Modals_1.ModalWithX, __assign({ isOpen: modalOpen, close: function () { return setModalOpen(false); }, width: 9 }, { children: [jsx_runtime_1.jsx(Modals_1.ModalContentFullWidth, { children: jsx_runtime_1.jsx(exports.CredentialShare, { vc: vc }, void 0) }, void 0),
                    jsx_runtime_1.jsx(rimble_ui_1.Box, { p: 3 }, void 0)] }), void 0)] }, void 0));
};
exports.CredentialShareButton = CredentialShareButton;
var templateObject_1;
//# sourceMappingURL=index.js.map