"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.IssueVcFlow = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var rimble_ui_1 = require("rimble-ui");
var Modals_1 = require("../../../elements/Modals");
var SchemasTable_1 = require("../../Schemas/SchemasTable");
var IssueVcForm_1 = require("./IssueVcForm");
var utils_1 = require("../../../../utils");
var IssueVcFlow = function (props) {
    var _a;
    var _b = react_1.useState(), schema = _b[0], setSchema = _b[1];
    function goBack() {
        setSchema(undefined);
    }
    if (typeof schema === "undefined") {
        var subjectName = "";
        if (props.subjectIdentifier) {
            var identifier = props.subjectIdentifier;
            if (identifier.alias && identifier.userName) {
                subjectName = identifier.alias + " (" + identifier.userName + " - " + utils_1.hexEllipsis(identifier.did) + ")";
            }
            else if (identifier.alias || identifier.userName) {
                subjectName = (identifier.alias || identifier.userName) + " (" + utils_1.hexEllipsis(identifier.did) + ")";
            }
            else {
                subjectName = identifier.did;
            }
        }
        return (jsx_runtime_1.jsxs(jsx_runtime_1.Fragment, { children: [jsx_runtime_1.jsx(Modals_1.ModalHeader, { children: "Issue Credential" }, void 0),
                jsx_runtime_1.jsxs(Modals_1.ModalContent, __assign({ width: 11 }, { children: [subjectName && (jsx_runtime_1.jsxs(rimble_ui_1.Text, { children: ["Issuing credential about ", jsx_runtime_1.jsx("b", __assign({ title: (_a = props.subjectIdentifier) === null || _a === void 0 ? void 0 : _a.did }, { children: subjectName }), void 0), "."] }, void 0)),
                        jsx_runtime_1.jsxs(rimble_ui_1.Text, { children: ["Please select a credential schema, or", " ", jsx_runtime_1.jsx(rimble_ui_1.Button.Text, __assign({ p: 0, onClick: function () { return setSchema(null); } }, { children: "enter credential as JSON" }), void 0), "."] }, void 0),
                        jsx_runtime_1.jsx(SchemasTable_1.SchemasTable, { discover: true, onSchemaSelect: setSchema, hideIssueVcInDetail: true }, void 0)] }), void 0)] }, void 0));
    }
    return (jsx_runtime_1.jsx(IssueVcForm_1.IssueVcForm, { identifiers: props.identifiers, subjectIdentifier: props.subjectIdentifier, schema: schema, onComplete: props.onComplete, goBack: goBack }, void 0));
};
exports.IssueVcFlow = IssueVcFlow;
//# sourceMappingURL=IssueVcFlow.js.map