"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.IssueVcForm = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = __importStar(require("react"));
var rimble_ui_1 = require("rimble-ui");
var icons_1 = require("@rimble/icons");
var swr_1 = require("swr");
var vc_schema_tools_1 = require("vc-schema-tools");
var Modals_1 = require("../../../elements/Modals");
var DidSelect_1 = require("../../../elements/DidSelect");
var IssueVcFormInput_1 = require("./IssueVcFormInput");
var SertoUiContext_1 = require("../../../../context/SertoUiContext");
var IssueVcSuccess_1 = require("./IssueVcSuccess");
var Credential_1 = require("../Credential");
var LayoutComponents_1 = require("../../../layouts/LayoutComponents");
var themes_1 = require("../../../../themes");
var utils_1 = require("../../Schemas/utils");
var STEPS = ["FORM", "REVIEW", "ISSUED"];
function buildCredential(schema, initialCred, issuer, vcData) {
    var _a;
    var _b = utils_1.getLdTypesFromSchemaResponse(schema), subjectLdType = _b.subjectLdType, credLdType = _b.credLdType;
    var uris = utils_1.getSchemaUris(schema);
    var ldContext = uris.jsonLdContext;
    if (!ldContext) {
        console.warn("Could not find JSON-LD context URL - embedding entire context in VC");
        ldContext = (_a = JSON.parse(schema.ldContext || "{}")) === null || _a === void 0 ? void 0 : _a["@context"];
    }
    var jsonSchemaUrl = uris.jsonSchema;
    if (!jsonSchemaUrl) {
        console.warn("Could not find JSON Schema URL - excluding `credentialSchema` property from VC");
    }
    return __assign(__assign({}, initialCred), { "@context": ldContext
            ? ["https://www.w3.org/2018/credentials/v1", ldContext]
            : "https://www.w3.org/2018/credentials/v1", type: credLdType ? __spreadArrays((initialCred.type || []), [credLdType]) : initialCred.type, issuer: {
            id: issuer,
        }, credentialSchema: jsonSchemaUrl
            ? {
                id: jsonSchemaUrl,
                type: "JsonSchemaValidator2018",
            }
            : undefined, credentialSubject: __assign(__assign({}, (subjectLdType ? { type: subjectLdType } : {})), vcData) });
}
var IssueVcForm = function (props) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
    var schema = props.schema, subjectIdentifier = props.subjectIdentifier, onComplete = props.onComplete, onVcDataChange = props.onVcDataChange;
    var context = react_1.default.useContext(SertoUiContext_1.SertoUiContext);
    var identifiers = props.identifiers || context.userDids;
    if (!(identifiers === null || identifiers === void 0 ? void 0 : identifiers[0])) {
        console.error("Could not get user DIDs: no `identifiers` prop supplied and no `userDids` property has been supplied to SertoUiContext via SertoUiProvider");
        identifiers = [];
    }
    var initialCred = {
        "@context": ["https://www.w3.org/2018/credentials/v1"],
        // "id": "uuid:9110652b-3676-4720-8139-9163b244680d", // @TODO Should the API generate this?
        type: ["VerifiableCredential"],
        issuer: { id: (_a = identifiers[0]) === null || _a === void 0 ? void 0 : _a.did },
        issuanceDate: new Date().toISOString(),
        credentialSubject: {
            id: (subjectIdentifier === null || subjectIdentifier === void 0 ? void 0 : subjectIdentifier.did) || ((_b = identifiers[0]) === null || _b === void 0 ? void 0 : _b.did),
            exampleData: {
                foo: 123,
                bar: true,
            },
        },
    };
    var _k = react_1.default.useState(STEPS[0]), step = _k[0], setStep = _k[1];
    var _l = react_1.default.useState(false), loading = _l[0], setLoading = _l[1];
    var _m = react_1.useState(), vcToIssue = _m[0], setVcToIssue = _m[1];
    var _o = react_1.useState(), issuedVc = _o[0], setIssuedVc = _o[1];
    var _p = react_1.default.useState(false), issueAndSend = _p[0], setIssueAndSend = _p[1];
    var _q = react_1.default.useState(false), subjectSupportsMessaging = _q[0], setSubjectSupportsMessaging = _q[1];
    var _r = react_1.useState(), error = _r[0], setError = _r[1];
    var _s = react_1.useState(), messagingError = _s[0], setMessagingError = _s[1];
    var _t = react_1.useState({}), vcData = _t[0], setVcData = _t[1];
    var _u = react_1.useState(JSON.stringify(initialCred, null, 2)), rawJsonVc = _u[0], setRawJsonVc = _u[1];
    var _v = react_1.useState((_c = identifiers[0]) === null || _c === void 0 ? void 0 : _c.did), issuer = _v[0], setIssuer = _v[1];
    var schemaInstance = react_1.default.useMemo(function () {
        if (schema) {
            try {
                setError("");
                return new vc_schema_tools_1.VcSchema(schema.jsonSchema);
            }
            catch (err) {
                console.error("Failed to generate schema instance:", err);
                setError(err.toString());
            }
        }
    }, [schema]);
    var credSchema = (_e = (_d = schemaInstance === null || schemaInstance === void 0 ? void 0 : schemaInstance.jsonSchema) === null || _d === void 0 ? void 0 : _d.properties) === null || _e === void 0 ? void 0 : _e.credentialSubject;
    react_1.default.useEffect(function () {
        onVcDataChange === null || onVcDataChange === void 0 ? void 0 : onVcDataChange(vcData);
    }, [onVcDataChange, vcData]);
    if (!context.issueVc) {
        console.error("issueVc function not present in SertoUiContext. Make sure to supply this function to the context passed in to SertoUiProvider or else serto-ui library cannot issue a VC for you.");
        return (jsx_runtime_1.jsx(rimble_ui_1.Flash, __assign({ my: 3, variant: "danger" }, { children: "Missing issue VC functionality" }), void 0));
    }
    function createVc(e) {
        e.preventDefault();
        setError(undefined);
        try {
            var credential = void 0;
            if (schema) {
                if (!schemaInstance) {
                    console.error("Can't issue VC: schema instance is undefined. Schema data:", schema);
                    setError("Could not initialize schema instance");
                    return;
                }
                credential = buildCredential(schema, initialCred, issuer, vcData);
            }
            else {
                credential = JSON.parse(rawJsonVc);
            }
            // @TODO/tobek Actually validate VC according to schema instance
            onVcDataChange === null || onVcDataChange === void 0 ? void 0 : onVcDataChange(credential);
            setVcToIssue(credential);
            setStep(STEPS[1]);
        }
        catch (err) {
            console.error("failed to create VC:", err);
            setError("Failed to create VC: " + err.message);
            return;
        }
    }
    function issueVc(e) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function () {
            var issueResponse, subject, sendResponse, err_1, err_2;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        e.preventDefault();
                        setError(undefined);
                        setLoading(true);
                        _c.label = 1;
                    case 1:
                        _c.trys.push([1, 8, , 9]);
                        return [4 /*yield*/, ((_a = context.issueVc) === null || _a === void 0 ? void 0 : _a.call(context, vcToIssue, {
                                revocable: false,
                                keepCopy: true,
                                save: "true",
                                proofFormat: "jwt",
                            }))];
                    case 2:
                        issueResponse = _c.sent();
                        console.log("issued VC, response:", issueResponse);
                        swr_1.mutate("/v1/agent/dataStoreORMGetVerifiableCredentials");
                        setIssuedVc(issueResponse);
                        if (!issueAndSend) return [3 /*break*/, 7];
                        subject = (_b = issueResponse.credentialSubject) === null || _b === void 0 ? void 0 : _b.id;
                        if (!!subject) return [3 /*break*/, 3];
                        console.error("failed to send VC: VC has no credentialSubject.id", issueResponse);
                        setMessagingError('Sending credential to subject failed: credential does not contain "credentialSubject.id" property to send to.');
                        return [3 /*break*/, 7];
                    case 3:
                        if (!!context.sendVc) return [3 /*break*/, 4];
                        console.error("serto-ui context missing sendVc", context);
                        setMessagingError("This Serto instance is missing the ability to send VCs via DIDComm.");
                        return [3 /*break*/, 7];
                    case 4:
                        _c.trys.push([4, 6, , 7]);
                        return [4 /*yield*/, context.sendVc(issuer, subject, issueResponse)];
                    case 5:
                        sendResponse = _c.sent();
                        console.log("sent VC, response:", sendResponse);
                        // We're done - no need to show final share step.
                        context.toastProvider.addMessage("Credential issued & sent", {
                            colorTheme: "light",
                            variant: "success",
                        });
                        onComplete();
                        return [2 /*return*/];
                    case 6:
                        err_1 = _c.sent();
                        console.error("failed to send VC:", err_1);
                        setMessagingError("Sending credential to subject failed: " + err_1.message);
                        return [3 /*break*/, 7];
                    case 7:
                        context.toastProvider.addMessage("Credential issued", {
                            colorTheme: "light",
                            variant: "success",
                        });
                        setLoading(false);
                        setStep(STEPS[2]);
                        return [3 /*break*/, 9];
                    case 8:
                        err_2 = _c.sent();
                        console.error("failed to issue VC:", err_2);
                        setError("Failed to issue VC: " + err_2.message);
                        setLoading(false);
                        return [2 /*return*/];
                    case 9: return [2 /*return*/];
                }
            });
        });
    }
    var showBackButton = !!props.goBack || step !== STEPS[0];
    function goBack() {
        if (step === STEPS[0] && props.goBack) {
            props.goBack();
        }
        else if (step !== STEPS[0]) {
            setStep(STEPS[STEPS.indexOf(step) - 1]);
        }
    }
    if (step === STEPS[2] && issuedVc) {
        return (jsx_runtime_1.jsx(Modals_1.ModalContentFullWidth, { children: jsx_runtime_1.jsx(IssueVcSuccess_1.IssueVcSuccess, { vc: issuedVc, onComplete: onComplete, messagingError: messagingError }, void 0) }, void 0));
    }
    if (step === STEPS[1] && vcToIssue) {
        return (jsx_runtime_1.jsxs(jsx_runtime_1.Fragment, { children: [showBackButton && jsx_runtime_1.jsx(Modals_1.ModalBack, { onClick: goBack }, void 0),
                jsx_runtime_1.jsxs(Modals_1.ModalHeader, { children: ["Issue ", (_f = schema === null || schema === void 0 ? void 0 : schema.name) === null || _f === void 0 ? void 0 : _f.replace(/\s?Credential$/, ""), " Credential"] }, void 0),
                jsx_runtime_1.jsxs(Modals_1.ModalContent, __assign({ width: 9 }, { children: [jsx_runtime_1.jsx(Credential_1.Credential, { vc: vcToIssue, isOpen: true }, void 0),
                        schema && (jsx_runtime_1.jsxs(jsx_runtime_1.Fragment, { children: [jsx_runtime_1.jsx(LayoutComponents_1.H4, __assign({ mt: 5, mb: 3 }, { children: "Recipient Information" }), void 0),
                                !subjectSupportsMessaging && (jsx_runtime_1.jsx(rimble_ui_1.Flash, __assign({ my: 3, variant: "warning" }, { children: jsx_runtime_1.jsxs(rimble_ui_1.Flex, { children: [jsx_runtime_1.jsx(icons_1.Warning, { color: themes_1.colors.warning.dark }, void 0),
                                            jsx_runtime_1.jsxs(rimble_ui_1.Text, __assign({ ml: 2, fontSize: 1 }, { children: [((_g = vcToIssue.credentialSubject) === null || _g === void 0 ? void 0 : _g.id) ? (jsx_runtime_1.jsxs(jsx_runtime_1.Fragment, { children: ["The credential subject DID you selected (", jsx_runtime_1.jsx("code", __assign({ style: { wordBreak: "break-word" } }, { children: vcToIssue.credentialSubject.id }), void 0), ") does not support receiving credentials."] }, void 0)) : ("Your credential doesn't have a subject DID to automatically send the issued credential to."), " ", "You may send it via link, QR code, or email after issuing the credential."] }), void 0)] }, void 0) }), void 0)),
                                jsx_runtime_1.jsx(rimble_ui_1.Checkbox, { label: "Recipient same as credential subject", checked: issueAndSend, onChange: function () { return setIssueAndSend(!issueAndSend); }, disabled: !subjectSupportsMessaging }, void 0)] }, void 0)),
                        error && (jsx_runtime_1.jsx(rimble_ui_1.Flash, __assign({ my: 3, variant: "danger" }, { children: error }), void 0)),
                        jsx_runtime_1.jsx(rimble_ui_1.Button, __assign({ mt: 5, type: "submit", width: "100%", disabled: loading, onClick: issueVc }, { children: loading ? jsx_runtime_1.jsx(rimble_ui_1.Loader, { color: "white" }, void 0) : "Issue Credential" }), void 0)] }), void 0)] }, void 0));
    }
    return (jsx_runtime_1.jsxs(jsx_runtime_1.Fragment, { children: [showBackButton && jsx_runtime_1.jsx(Modals_1.ModalBack, { onClick: goBack }, void 0),
            jsx_runtime_1.jsxs(Modals_1.ModalHeader, { children: ["Issue ", (_h = schema === null || schema === void 0 ? void 0 : schema.name) === null || _h === void 0 ? void 0 : _h.replace(/\s?Credential$/, ""), " Credential"] }, void 0),
            jsx_runtime_1.jsx(Modals_1.ModalContent, { children: jsx_runtime_1.jsxs(rimble_ui_1.Form, __assign({ onSubmit: createVc }, { children: [!(credSchema === null || credSchema === void 0 ? void 0 : credSchema.properties) ? (jsx_runtime_1.jsx(rimble_ui_1.Field, __assign({ label: "Credential body JSON", width: "100%" }, { children: jsx_runtime_1.jsx("textarea", { required: true, value: rawJsonVc, spellCheck: false, style: { width: "100%", minHeight: "250px" }, onChange: function (e) { return setRawJsonVc(e.target.value); } }, void 0) }), void 0)) : (jsx_runtime_1.jsxs(jsx_runtime_1.Fragment, { children: [jsx_runtime_1.jsx(rimble_ui_1.Field, __assign({ label: "Issuance Date", width: "100%" }, { children: jsx_runtime_1.jsx(rimble_ui_1.Input, { type: "datetime", disabled: true, value: new Date().toISOString(), width: "100%", required: true }, void 0) }), void 0),
                                jsx_runtime_1.jsx(rimble_ui_1.Field, __assign({ label: "Issuer ID", width: "100%" }, { children: jsx_runtime_1.jsx(DidSelect_1.DidSelect, { onChange: setIssuer, value: issuer, identifiers: identifiers, defaultSelectedDid: (_j = identifiers[0]) === null || _j === void 0 ? void 0 : _j.did, required: true, ownDidsOnly: true }, void 0) }), void 0),
                                Object.entries(credSchema.properties).map(function (_a) {
                                    var _b;
                                    var key = _a[0], node = _a[1];
                                    return (jsx_runtime_1.jsx(IssueVcFormInput_1.IssueVcFormInput, { name: key, node: node, value: vcData[key], identifiers: identifiers || [], defaultSubjectDid: key === "id" && node.format === "uri" ? subjectIdentifier === null || subjectIdentifier === void 0 ? void 0 : subjectIdentifier.did : undefined, required: (_b = credSchema === null || credSchema === void 0 ? void 0 : credSchema.required) === null || _b === void 0 ? void 0 : _b.includes(key), onChange: function (value) {
                                            var _a;
                                            return setVcData(__assign(__assign({}, vcData), (_a = {}, _a[key] = value, _a)));
                                        }, subjectSupportsMessaging: subjectSupportsMessaging, setSubjectSupportsMessaging: setSubjectSupportsMessaging }, key));
                                })] }, void 0)),
                        error && (jsx_runtime_1.jsx(rimble_ui_1.Flash, __assign({ my: 3, variant: "danger" }, { children: error }), void 0)),
                        jsx_runtime_1.jsx(rimble_ui_1.Flex, __assign({ my: 3, justifyContent: "space-between" }, { children: jsx_runtime_1.jsx(rimble_ui_1.Button, __assign({ type: "submit", width: "100%" }, { children: "Review Credential" }), void 0) }), void 0)] }), void 0) }, void 0)] }, void 0));
};
exports.IssueVcForm = IssueVcForm;
//# sourceMappingURL=IssueVcForm.js.map