"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = __importDefault(require("react"));
var react_2 = require("@storybook/react");
var rimble_ui_1 = require("rimble-ui");
var vc_schema_tools_1 = require("vc-schema-tools");
var utils_1 = require("../../Schemas/utils");
var IssueVcForm_1 = require("./IssueVcForm");
var HighlightedJson_1 = require("../../../elements/HighlightedJson/HighlightedJson");
var IdentityTheme_1 = require("../../../../themes/IdentityTheme");
var SertoUiProvider_1 = require("../../../../context/SertoUiProvider");
var helpers_1 = require("../../../../utils/helpers");
var DEFAULT_SCHEMA = "TestCredential";
var IDENTIFIERS = [
    { did: "did:ethr:rinkeby:0xcfa8829812f1b4fe09b27cacf7d36e4d1b5dce76", provider: "did:ethr:rinkeby", alias: "Admin" },
    {
        did: "did:ethr:rinkeby:0x88298d36e4d1b5dce76cf9b27cacf7a12f1b4fe0",
        provider: "did:ethr:rinkeby",
        alias: "Another User",
    },
    {
        did: "did:ethr:rinkeby:0x1b5dce8826e4d76cf9b27cac12f1b4fe098d3f7a",
        provider: "did:ethr:rinkeby",
        alias: "Really really really really really really long alias",
    },
    { did: "did:ethr:rinkeby:0x9812f1d36e4d1b5dce7acf76cfa882b4fe09b27c", provider: "did:ethr:rinkeby" },
];
react_2.storiesOf("Credential", module).add("IssueVcForm", function () {
    var _a = react_1.default.useState({}), vcData = _a[0], setVcData = _a[1];
    var _b = react_1.default.useState(""), error = _b[0], setError = _b[1];
    var _c = react_1.default.useState(DEFAULT_SCHEMA), schemaKey = _c[0], setSchemaKey = _c[1];
    var schemaData = react_1.default.useMemo(function () {
        setError("");
        if (schemaKey) {
            try {
                return utils_1.jsonSchemaToSchemaInput(vc_schema_tools_1.EXAMPLE_SCHEMAS[schemaKey]);
            }
            catch (err) {
                console.error("Failed to generate schema input from schema:", err);
                setError(err.toString());
            }
        }
    }, [schemaKey]);
    return (jsx_runtime_1.jsx(IdentityTheme_1.IdentityThemeProvider, { children: jsx_runtime_1.jsx(SertoUiProvider_1.SertoUiProvider, __assign({ context: {
                issueVc: helpers_1.createMockApiRequest(),
            } }, { children: jsx_runtime_1.jsxs(rimble_ui_1.Flex, { children: [jsx_runtime_1.jsxs("div", { children: [jsx_runtime_1.jsxs(rimble_ui_1.Box, __assign({ mb: 3 }, { children: ["Schema:", " ", jsx_runtime_1.jsxs("select", __assign({ value: schemaKey, onChange: function (event) {
                                            setSchemaKey(event.target.value);
                                            setVcData({});
                                            setError("");
                                        } }, { children: [jsx_runtime_1.jsx("option", __assign({ value: "" }, { children: "[Raw JSON input]" }), void 0),
                                            Object.keys(vc_schema_tools_1.EXAMPLE_SCHEMAS).map(function (key) { return (jsx_runtime_1.jsx("option", __assign({ value: key }, { children: key }), key)); })] }), void 0)] }), void 0),
                            jsx_runtime_1.jsxs(rimble_ui_1.Box, __assign({ width: 10 }, { children: [error && jsx_runtime_1.jsx(rimble_ui_1.Flash, __assign({ variant: "danger" }, { children: error }), void 0),
                                    jsx_runtime_1.jsx(IssueVcForm_1.IssueVcForm, { schema: schemaData, identifiers: IDENTIFIERS, onComplete: function () { }, onVcDataChange: setVcData }, schemaKey)] }), void 0)] }, void 0),
                    jsx_runtime_1.jsxs(rimble_ui_1.Box, __assign({ flexGrow: 1 }, { children: [jsx_runtime_1.jsx(rimble_ui_1.Box, __assign({ mb: 1 }, { children: "debug:" }), void 0),
                            jsx_runtime_1.jsx(HighlightedJson_1.HighlightedJson, { json: vcData }, void 0)] }), void 0)] }, void 0) }), void 0) }, void 0));
});
//# sourceMappingURL=IssueVcForm.stories.js.map