"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.IssueVcFormInput = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = __importDefault(require("react"));
var rimble_ui_1 = require("rimble-ui");
var DidSearchWithMessagingInfo_1 = require("../../../elements/DidSearchWithMessagingInfo");
var DidSearch_1 = require("../../../elements/DidSearch");
var helpers_1 = require("../../../../utils/helpers");
var IssueVcFormInput = function (props) {
    var _a, _b;
    var name = props.name, node = props.node, value = props.value, onChange = props.onChange, required = props.required, identifiers = props.identifiers, defaultSubjectDid = props.defaultSubjectDid, subjectSupportsMessaging = props.subjectSupportsMessaging, setSubjectSupportsMessaging = props.setSubjectSupportsMessaging, isNested = props.isNested;
    var isDid = node.type === "string" && node.format === "uri" && ((_a = node.$linkedData) === null || _a === void 0 ? void 0 : _a["@id"]) === "@id";
    var isSubjectDid = isDid && name === "id" && !isNested;
    react_1.default.useEffect(function () {
        // Most required fields will be handled by form validation, but requiring a boolean or a nested object is not.
        // @TODO/tobek In some cases this isn't handling nested required booleans but that's a heck of an edge case and ideally we should check final VC against JSON Schema anyway which would catch this.
        if (required && typeof value === "undefined") {
            if (node.type === "boolean") {
                onChange(false);
            }
            else if (node.type === "object") {
                onChange({});
            }
        }
    }, [node.type, required, value, onChange]);
    var renderInput = function () {
        var _a;
        if (node.properties && node.type === "object") {
            return (jsx_runtime_1.jsx(rimble_ui_1.Box, __assign({ pt: 2, pl: "24px", required: (_a = node.required) === null || _a === void 0 ? void 0 : _a.length }, { children: Object.entries(node.properties).map(function (_a) {
                    var _b;
                    var nestedKey = _a[0], nestedNode = _a[1];
                    return (jsx_runtime_1.jsx(exports.IssueVcFormInput, { name: nestedKey, node: nestedNode, value: value === null || value === void 0 ? void 0 : value[nestedKey], required: (_b = node.required) === null || _b === void 0 ? void 0 : _b.includes(nestedKey), identifiers: identifiers, onChange: function (updatedNestedValue) {
                            var _a;
                            return onChange(__assign(__assign({}, value), (_a = {}, _a[nestedKey] = updatedNestedValue, _a)));
                        }, subjectSupportsMessaging: subjectSupportsMessaging, setSubjectSupportsMessaging: setSubjectSupportsMessaging, isNested: true }, nestedKey));
                }) }), void 0));
        }
        if (isSubjectDid) {
            return (jsx_runtime_1.jsx(rimble_ui_1.Box, __assign({ mb: 3 }, { children: jsx_runtime_1.jsx(DidSearchWithMessagingInfo_1.DidSearchWithMessagingInfo, { onChange: function (val) { return onChange(val.did); }, required: required, identifiers: identifiers, defaultSelectedDid: defaultSubjectDid, supportsMessaging: subjectSupportsMessaging, setSupportsMessaging: setSubjectSupportsMessaging }, name) }), void 0));
        }
        else if (isDid) {
            return (jsx_runtime_1.jsx(rimble_ui_1.Box, __assign({ mb: 3 }, { children: jsx_runtime_1.jsx(DidSearch_1.DidSearch, { onChange: function (val) { return onChange(val.did); }, required: required, identifiers: identifiers, defaultSelectedDid: defaultSubjectDid }, name) }), void 0));
        }
        if (node.type === "boolean") {
            return jsx_runtime_1.jsx(rimble_ui_1.Checkbox, { checked: !!value, onChange: function () { return onChange(!value); } }, void 0);
        }
        var type = "text";
        var placeholder = "";
        var width = "100%";
        var inputValue = value || "";
        if (node.type === "number" || node.type === "integer") {
            type = "number";
            width = undefined;
        }
        else if (node.format === "date") {
            type = "date";
        }
        else if (node.format === "date-time") {
            type = "datetime-local";
            inputValue = inputValue && helpers_1.isoToDatetimeLocal(inputValue);
        }
        else if (node.format === "uri") {
            type = "url";
            placeholder = "URL";
        }
        function changeHandler(event) {
            var newValue = event.target.value;
            if (type === "number") {
                onChange(parseInt(newValue, 10));
            }
            else if (type === "datetime-local") {
                onChange(new Date(newValue).toISOString());
            }
            else {
                onChange(newValue);
            }
        }
        return (jsx_runtime_1.jsx(rimble_ui_1.Input, { type: type, disabled: false, value: inputValue, onChange: changeHandler, required: required, width: width, placeholder: placeholder }, void 0));
    };
    return (jsx_runtime_1.jsx(rimble_ui_1.Field, __assign({ label: node.title || name, width: "100%", mb: isDid ? 0 : 3 }, { children: jsx_runtime_1.jsxs(rimble_ui_1.Box, __assign({ required: required || ((_b = node.required) === null || _b === void 0 ? void 0 : _b.length), width: "100%" }, { children: [node.description ? jsx_runtime_1.jsx(rimble_ui_1.Text, __assign({ fontSize: 1 }, { children: node.description }), void 0) : jsx_runtime_1.jsx(jsx_runtime_1.Fragment, {}, void 0), renderInput()] }), void 0) }), void 0));
};
exports.IssueVcFormInput = IssueVcFormInput;
//# sourceMappingURL=IssueVcFormInput.js.map