"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AttributesStep = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var React = __importStar(require("react"));
var rimble_ui_1 = require("rimble-ui");
var themes_1 = require("../../../../themes");
var types_1 = require("../types");
var SchemaAttribute_1 = require("./SchemaAttribute");
var AttributesStep = function (props) {
    var _a;
    var schema = props.schema, updateSchema = props.updateSchema;
    var _b = React.useState(false), doValidation = _b[0], setDoValidation = _b[1];
    var _c = React.useState(""), error = _c[0], setError = _c[1];
    function addAttribute(e) {
        var _a, _b, _c, _d, _e, _f;
        if ((_c = (_b = (_a = schema.properties) === null || _a === void 0 ? void 0 : _a.credentialSubject) === null || _b === void 0 ? void 0 : _b.properties) === null || _c === void 0 ? void 0 : _c[""]) {
            // We have a property with no name - have them update that before creating a no one. We don't have to do anything, since the un-preventDefaulted event will trigger browser UI on empty required title field
            return;
        }
        e.preventDefault();
        updateSchema(__assign(__assign({}, schema), { properties: __assign(__assign({}, schema.properties), { credentialSubject: __assign(__assign({}, (_d = schema.properties) === null || _d === void 0 ? void 0 : _d.credentialSubject), { properties: __assign(__assign({}, (_f = (_e = schema.properties) === null || _e === void 0 ? void 0 : _e.credentialSubject) === null || _f === void 0 ? void 0 : _f.properties), { "": __assign({}, types_1.newSchemaAttribute) }) }) }) }));
    }
    function goNext(e) {
        var _a, _b;
        e.preventDefault();
        setError("");
        var propertyIds = new Set();
        var missingField = false;
        var duplicateId = false;
        var invalidId = false;
        // @TODO/tobek These checks should be recursive. Empty `title`'s are already handled by native browser form checks, but `$linkedData.term` collisions (which would have to be unique only among sibling properties) are not handled.
        Object.entries(((_b = (_a = schema.properties) === null || _a === void 0 ? void 0 : _a.credentialSubject) === null || _b === void 0 ? void 0 : _b.properties) || {}).forEach(function (_a) {
            var _b, _c;
            var key = _a[0], prop = _a[1];
            if (key === "") {
                missingField = true;
            }
            if ((_b = prop.$linkedData) === null || _b === void 0 ? void 0 : _b.term) {
                if (((_c = prop.$linkedData) === null || _c === void 0 ? void 0 : _c.term) === "type") {
                    setError("An attribute name result in ID \"" + prop.$linkedData.term + "\" - this is a reserved keyword in the JSON-LD specification that VCs use. Please use a different name.");
                    invalidId = true;
                }
                else if (propertyIds.has(prop.$linkedData.term)) {
                    setError("Two attribute names result in ID \"" + prop.$linkedData.term + "\" - all attributes must have unique IDs.");
                    duplicateId = true;
                }
                else {
                    propertyIds.add(prop.$linkedData.term);
                }
            }
        });
        if (missingField || duplicateId || invalidId) {
            setDoValidation(true);
        }
        else {
            setDoValidation(false);
            props.onComplete();
        }
    }
    return (jsx_runtime_1.jsxs(rimble_ui_1.Form, __assign({ validated: doValidation, onSubmit: goNext }, { children: [types_1.defaultSchemaProperties.map(function (prop, i) { return (jsx_runtime_1.jsx(SchemaAttribute_1.SchemaAttribute, { attr: prop, readOnly: true, parentRequired: ["issuanceDate", "issuer"] }, i + "required")); }),
            ((_a = schema.properties) === null || _a === void 0 ? void 0 : _a.credentialSubject) && (jsx_runtime_1.jsx(SchemaAttribute_1.SchemaAttribute, { attr: schema.properties.credentialSubject, isCredSubject: true, updateAttribute: function (attr) {
                    updateSchema(__assign(__assign({}, schema), { properties: __assign(__assign({}, schema.properties), { credentialSubject: attr }) }));
                } }, "credentialSubject")),
            jsx_runtime_1.jsxs(rimble_ui_1.Box, __assign({ mt: 3 }, { children: [jsx_runtime_1.jsx(rimble_ui_1.Button.Outline, __assign({ mb: 3, mx: "auto", type: "submit", width: "100%", onClick: addAttribute, style: { borderColor: themes_1.colors.primary.base } }, { children: "Add Another Attribute" }), void 0),
                    error && (jsx_runtime_1.jsxs(rimble_ui_1.Flash, __assign({ mb: 3, variant: "danger" }, { children: ["Error: ", error] }), void 0)),
                    jsx_runtime_1.jsx(rimble_ui_1.Button, __assign({ type: "submit", width: "100%" }, { children: "Review" }), void 0)] }), void 0)] }), void 0));
};
exports.AttributesStep = AttributesStep;
//# sourceMappingURL=AttributesStep.js.map