"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("@storybook/react");
var styled_components_1 = __importDefault(require("styled-components"));
var vc_schema_tools_1 = require("vc-schema-tools");
var IdentityTheme_1 = require("../../../../themes/IdentityTheme");
var _1 = require("./");
var schemaToUpdate = __assign(__assign({}, vc_schema_tools_1.baseVcJsonSchema), { $id: "https://example.com/schemas/employment-credential/1.0/json-schema.json", $schema: "http://json-schema.org/draft-07/schema#", $metadata: {
        slug: "employment-credential",
        version: "1.0",
        icon: "👔",
        discoverable: false,
        uris: {
            jsonLdContext: "https://example.com/schemas/employment-credential/1.0/ld-context.json",
            jsonSchema: "https://example.com/schemas/employment-credential/1.0/json-schema.json",
        },
    }, title: "Employment Credential", description: "Credential representing employment at an employer.", $linkedData: {
        term: "EmploymentCredential",
        "@id": "https://example.com/schemas/employment-credential/1.0/ld-context.json#EmploymentCredential",
    }, properties: __assign(__assign({}, vc_schema_tools_1.baseVcJsonSchema.properties), { credentialSubject: {
            $linkedData: {
                term: "Employment",
                "@id": "Employment",
            },
            type: "object",
            required: ["jobTitle", "employer", "employeeSubjectId"],
            properties: {
                employeeSubjectId: {
                    $linkedData: {
                        term: "employeeSubjectId",
                        "@id": "@id",
                    },
                    title: "Employee DID",
                    type: "string",
                    format: "uri",
                },
                jobTitle: {
                    $linkedData: {
                        term: "jobTitle",
                        "@id": "http://schema.org/Text",
                    },
                    title: "Job Title",
                    description: "",
                    type: "string",
                },
                hireDate: {
                    $linkedData: {
                        term: "hireDate",
                        "@id": "http://schema.org/Date",
                    },
                    title: "Hire Date",
                    description: "",
                    type: "string",
                    format: "date",
                },
                employer: {
                    $linkedData: {
                        term: "employer",
                        "@id": "employer",
                    },
                    title: "Employer",
                    description: "",
                    type: "object",
                    required: ["employerId", "name"],
                    properties: {
                        employerId: {
                            $linkedData: {
                                term: "employerId",
                                "@id": "@id",
                            },
                            title: "Employer DID",
                            description: "",
                            type: "string",
                            format: "uri",
                        },
                        name: {
                            $linkedData: {
                                term: "name",
                                "@id": "http://schema.org/Text",
                            },
                            title: "Name",
                            description: "",
                            type: "string",
                        },
                        website: {
                            $linkedData: {
                                term: "website",
                                "@id": "http://schema.org/URL",
                            },
                            title: "Website",
                            description: "",
                            type: "string",
                            format: "uri",
                        },
                    },
                },
            },
        } }) });
var StyledCreateSchema = styled_components_1.default(_1.CreateSchema)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  position: relative;\n\n  max-height: calc(100vh - 50px);\n\n  .right-pane {\n    pre,\n    .schema-formatted-preview {\n      max-height: calc(100vh - 150px);\n      overflow-y: auto;\n    }\n  }\n\n  textarea {\n    box-sizing: inherit;\n  }\n"], ["\n  position: relative;\n\n  max-height: calc(100vh - 50px);\n\n  .right-pane {\n    pre,\n    .schema-formatted-preview {\n      max-height: calc(100vh - 150px);\n      overflow-y: auto;\n    }\n  }\n\n  textarea {\n    box-sizing: inherit;\n  }\n"])));
var createSchemaStory = function (schemaToUpdate) { return function () {
    return (jsx_runtime_1.jsx(IdentityTheme_1.IdentityThemeProvider, { children: jsx_runtime_1.jsx(StyledCreateSchema, { isUpdate: !!schemaToUpdate, initialSchemaState: schemaToUpdate }, void 0) }, void 0));
}; };
react_1.storiesOf("Schemas", module)
    .add("Create Schema", createSchemaStory())
    .add("Update Schema", createSchemaStory(schemaToUpdate));
var templateObject_1;
//# sourceMappingURL=CreateSchema.stories.js.map