"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.InfoStep = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var slugify_1 = __importDefault(require("@sindresorhus/slugify"));
var React = __importStar(require("react"));
var icons_1 = require("@rimble/icons");
var rimble_ui_1 = require("rimble-ui");
var styled_components_1 = __importDefault(require("styled-components"));
var themes_1 = require("../../../../themes/");
var SchemaField = styled_components_1.default(rimble_ui_1.Field)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  &,\n  & input {\n    width: 100%;\n    font-family: ", ";\n  }\n"], ["\n  &,\n  & input {\n    width: 100%;\n    font-family: ", ";\n  }\n"])), themes_1.fonts.sansSerif);
var StyledTextarea = styled_components_1.default.textarea(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  width: 100%;\n  font-family: ", ";\n  font-size: 16px;\n  padding: 16px;\n  border-radius: 4px;\n  border-color: ", ";\n  box-shadow: ", ";\n"], ["\n  width: 100%;\n  font-family: ", ";\n  font-size: 16px;\n  padding: 16px;\n  border-radius: 4px;\n  border-color: ", ";\n  box-shadow: ", ";\n"])), themes_1.fonts.sansSerif, themes_1.colors.moonGray, function (props) { return props.theme.shadows[1] || 0; });
var SchemaLabel = styled_components_1.default.label(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  display: block;\n  width: 50%;\n  margin-bottom: 16px;\n  margin-left: 8px;\n  font-family: ", ";\n"], ["\n  display: block;\n  width: 50%;\n  margin-bottom: 16px;\n  margin-left: 8px;\n  font-family: ", ";\n"])), themes_1.fonts.sansSerif);
var InfoStep = function (props) {
    var isUpdate = props.isUpdate, userOwnsSchema = props.userOwnsSchema, isAuthenticated = props.isAuthenticated, initialSchemaState = props.initialSchemaState, schema = props.schema, updateSchema = props.updateSchema;
    var $metadata = schema.$metadata || {};
    var _a = React.useState(false), doValidation = _a[0], setDoValidation = _a[1];
    var _b = React.useState(""), error = _b[0], setError = _b[1];
    var _c = React.useState(!$metadata.slug), useDefaultSlug = _c[0], setUseDefaultSlug = _c[1];
    /** Convert first latin character in name to bubble unicode char (🅐-🅩) as default icon. */
    var defaultIcon = React.useMemo(function () {
        if (!schema.title) {
            return "";
        }
        var firstCharMatch = schema.title.match(/[a-zA-Z]/);
        if (!(firstCharMatch === null || firstCharMatch === void 0 ? void 0 : firstCharMatch[0])) {
            return "⓿";
        }
        var char = firstCharMatch[0].toLowerCase();
        return String.fromCodePoint(127302 + parseInt(char, 36));
    }, [schema.title]);
    function goNext(e) {
        var _a, _b;
        e.preventDefault();
        setError("");
        // If *not* authenticated they won't be able to save changes anyway, so we can let them explore the editor without worrying about what values need updating.
        if (isAuthenticated) {
            if (isUpdate && userOwnsSchema && $metadata.version === ((_a = initialSchemaState === null || initialSchemaState === void 0 ? void 0 : initialSchemaState.$metadata) === null || _a === void 0 ? void 0 : _a.version)) {
                setError("You must update the version number when updating a schema.");
                return;
            }
            if (isUpdate && !userOwnsSchema && $metadata.slug === ((_b = initialSchemaState === null || initialSchemaState === void 0 ? void 0 : initialSchemaState.$metadata) === null || _b === void 0 ? void 0 : _b.slug)) {
                setError("You must update the slug when forking a schema.");
                return;
            }
        }
        if (schema.title && $metadata.slug && $metadata.version) {
            setDoValidation(false);
            updateSchema({
                $metadata: __assign(__assign({}, $metadata), { icon: $metadata.icon || defaultIcon }),
            });
            props.onComplete();
        }
        else {
            setDoValidation(true);
        }
    }
    return (jsx_runtime_1.jsxs(rimble_ui_1.Form, __assign({ validated: doValidation, onSubmit: goNext }, { children: [jsx_runtime_1.jsx(SchemaField, __assign({ label: "Credential Schema Name" }, { children: jsx_runtime_1.jsx(rimble_ui_1.Input, { width: "100%", type: "text", required: true, placeholder: "Enter name", value: schema.title || "", onChange: function (event) {
                        return updateSchema({
                            title: event.target.value,
                            $metadata: __assign(__assign({}, $metadata), { slug: useDefaultSlug ? slugify_1.default(event.target.value) : $metadata.slug }),
                        });
                    } }, void 0) }), void 0),
            jsx_runtime_1.jsx(SchemaField, __assign({ label: "URL Slug" }, { children: jsx_runtime_1.jsx(rimble_ui_1.Input, { width: "100%", type: "text", required: true, placeholder: "Enter slug/ID", value: $metadata.slug, onChange: function (event) { return updateSchema({ slug: event.target.value }); }, onBlur: function () {
                        if ($metadata.slug) {
                            return;
                        }
                        updateSchema({
                            $metadata: __assign(__assign({}, $metadata), { slug: slugify_1.default($metadata.slug || "") }),
                        });
                        setUseDefaultSlug(false);
                    } }, void 0) }), void 0),
            jsx_runtime_1.jsxs(rimble_ui_1.Flex, { children: [jsx_runtime_1.jsx(SchemaField, __assign({ label: "Version", style: { width: "50%" } }, { children: jsx_runtime_1.jsx(rimble_ui_1.Input, { width: "100%", type: "text", required: true, value: $metadata.version, onChange: function (event) {
                                return updateSchema({
                                    $metadata: __assign(__assign({}, $metadata), { version: event.target.value }),
                                });
                            } }, void 0) }), void 0),
                    jsx_runtime_1.jsxs(SchemaLabel, { children: [jsx_runtime_1.jsxs(rimble_ui_1.Text, __assign({ fontSize: 1, fontWeight: 3, mb: 2 }, { children: ["Icon", " ", jsx_runtime_1.jsx(rimble_ui_1.Tooltip, __assign({ message: "This should be a single character, for example an emoji, that will be used to label this schema", placement: "top" }, { children: jsx_runtime_1.jsx(icons_1.Info, { size: 16, color: themes_1.colors.silver, style: { verticalAlign: "text-top" } }, void 0) }), void 0),
                                    jsx_runtime_1.jsx(rimble_ui_1.Text.span, __assign({ ml: 1, fontStyle: "italic", fontSize: 1 }, { children: "(optional)" }), void 0)] }), void 0),
                            jsx_runtime_1.jsx(rimble_ui_1.Input, { width: "100%", type: "text", placeholder: defaultIcon, value: $metadata.icon, onChange: function (event) {
                                    return updateSchema({
                                        $metadata: __assign(__assign({}, $metadata), { icon: event.target.value }),
                                    });
                                } }, void 0)] }, void 0)] }, void 0),
            jsx_runtime_1.jsx(SchemaField, __assign({ label: "Description" }, { children: jsx_runtime_1.jsx(StyledTextarea, { required: true, value: schema.description, placeholder: "Briefly describe how this schema will be used", onChange: function (event) { return updateSchema({ description: event.target.value }); }, style: { minHeight: "92px" } }, void 0) }), void 0),
            jsx_runtime_1.jsxs(rimble_ui_1.Box, __assign({ mb: 4 }, { children: [jsx_runtime_1.jsx(rimble_ui_1.Checkbox, { fontFamily: themes_1.fonts.sansSerif, label: "Searchable", checked: $metadata.discoverable, onChange: function () {
                            return updateSchema({
                                $metadata: __assign(__assign({}, $metadata), { discoverable: !$metadata.discoverable }),
                            });
                        } }, void 0),
                    jsx_runtime_1.jsx(rimble_ui_1.Text, __assign({ mt: 1, fontSize: 1, fontFamily: themes_1.fonts.sansSerif, color: themes_1.colors.gray60 }, { children: "If checked, this schema will be listed in the public schema registry. If unchecked, your schema will still be publicly accessible at an unlisted URL via the above slug." }), void 0)] }), void 0),
            error && (jsx_runtime_1.jsx(rimble_ui_1.Flash, __assign({ mb: 3, variant: "danger" }, { children: error }), void 0)),
            jsx_runtime_1.jsx(rimble_ui_1.Button, __assign({ type: "submit", width: "100%" }, { children: "Next" }), void 0)] }), void 0));
};
exports.InfoStep = InfoStep;
var templateObject_1, templateObject_2, templateObject_3;
//# sourceMappingURL=InfoStep.js.map