"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SchemaAttribute = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var styled_components_1 = __importDefault(require("styled-components"));
var rimble_ui_1 = require("rimble-ui");
var vc_schema_tools_1 = require("vc-schema-tools");
var themes_1 = require("../../../../themes");
var utils_1 = require("../utils");
var utils_2 = require("../../../../utils");
var DropDown_1 = require("../../../elements/DropDown/DropDown");
var types_1 = require("../types");
var AttributeBox = styled_components_1.default(rimble_ui_1.Box)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  &:first-child {\n    margin-top: 4px;\n  }\n  &:last-child {\n    margin-bottom: 0;\n  }\n"], ["\n  &:first-child {\n    margin-top: 4px;\n  }\n  &:last-child {\n    margin-bottom: 0;\n  }\n"])));
var IconButton = styled_components_1.default(rimble_ui_1.Button.Text)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  color: ", ";\n  &:hover {\n    color: ", ";\n  }\n"], ["\n  color: ", ";\n  &:hover {\n    color: ", ";\n  }\n"])), themes_1.colors.midGray, themes_1.colors.primary.base);
var SchemaAttribute = function (props) {
    var _a, _b, _c;
    var attr = props.attr, attrName = props.attrName, isCredSubject = props.isCredSubject, parentRequired = props.parentRequired, readOnly = props.readOnly, setParentRequired = props.setParentRequired, updateAttribute = props.updateAttribute, removeAttribute = props.removeAttribute;
    function updateAttrProperty(attrProperty, value) {
        var _a;
        var _b;
        var updatedProperty = __assign(__assign({}, attr), (_a = {}, _a[attrProperty] = value, _a));
        if (attrProperty === "title") {
            updatedProperty.$linkedData = {
                "@id": ((_b = updatedProperty.$linkedData) === null || _b === void 0 ? void 0 : _b["@id"]) || "",
                term: utils_2.convertToCamelCase(value),
            };
        }
        updateAttribute === null || updateAttribute === void 0 ? void 0 : updateAttribute(updatedProperty);
    }
    function toggleRequired() {
        var _a;
        var term = ((_a = attr.$linkedData) === null || _a === void 0 ? void 0 : _a.term) || "";
        if (parentRequired === null || parentRequired === void 0 ? void 0 : parentRequired.includes(term)) {
            var requiredI = parentRequired.indexOf(term);
            setParentRequired === null || setParentRequired === void 0 ? void 0 : setParentRequired(__spreadArrays(parentRequired.slice(0, requiredI), parentRequired.slice(requiredI + 1)));
        }
        else {
            setParentRequired === null || setParentRequired === void 0 ? void 0 : setParentRequired(__spreadArrays((parentRequired || []), [term]));
        }
    }
    function updateType(type) {
        var _a, _b;
        var newType = utils_1.typeOptions[type];
        var updatedAttr = __assign(__assign(__assign({}, attr), newType), { $linkedData: {
                term: ((_a = attr.$linkedData) === null || _a === void 0 ? void 0 : _a.term) || "",
                "@id": ((_b = utils_1.typeOptions[type].$linkedData) === null || _b === void 0 ? void 0 : _b["@id"]) || "",
            } });
        if (!newType.format) {
            delete updatedAttr.format;
        }
        if (type === utils_1.NESTED_TYPE_KEY) {
            updatedAttr.$linkedData["@id"] = updatedAttr.$linkedData.term;
        }
        else if (type !== utils_1.NESTED_TYPE_KEY) {
            delete updatedAttr.properties;
        }
        updateAttribute === null || updateAttribute === void 0 ? void 0 : updateAttribute(updatedAttr);
    }
    function addNestedAttribute(e) {
        var _a;
        if ((_a = attr.properties) === null || _a === void 0 ? void 0 : _a[""]) {
            // Do nothing, an un-preventDefaulted event will trigger browser UI on empty required title field
            return;
        }
        e.preventDefault();
        updateAttrProperty("properties", __assign(__assign({}, attr.properties), { "": __assign({}, types_1.newSchemaAttribute) }));
    }
    var updateNestedAttribute = function (key, updatedAttr) {
        var _a;
        var _b, _c, _d;
        var updatedProperties = {};
        var updatedRequired = attr.required || [];
        if (((_b = updatedAttr.$linkedData) === null || _b === void 0 ? void 0 : _b.term) !== key) {
            // Key has changed. Since nested attributes are listed by iterating over object keys, if we rename object key by deleting and adding, React will reorder inputs while user is typing and lose focus. So here we re-create object key by key in order to rename the updated key while preserving order. (Yes order isn't necessarily stable in JS objects but it's better than nothing and converting everything to use Maps would be a pain.)
            var oldKey_1 = key;
            var newKey_1 = ((_c = updatedAttr.$linkedData) === null || _c === void 0 ? void 0 : _c.term) || "";
            if (attr.properties && newKey_1 in attr.properties) {
                // Edge case but will clobber existing property with that key so let's give it a different one.
                newKey_1 = newKey_1 + "2";
            }
            Object.keys(attr.properties || {}).forEach(function (existingKey) {
                if (existingKey === oldKey_1) {
                    updatedProperties[newKey_1] = updatedAttr;
                }
                else {
                    updatedProperties[existingKey] = attr.properties[existingKey];
                }
            });
            if ((_d = attr.required) === null || _d === void 0 ? void 0 : _d.includes(oldKey_1)) {
                // We need to update this too when the key changes
                var requiredI = attr.required.indexOf(oldKey_1);
                updatedRequired = __spreadArrays(attr.required.slice(0, requiredI), attr.required.slice(requiredI + 1), [newKey_1]);
            }
        }
        else {
            updatedProperties = __assign(__assign({}, attr.properties), (_a = {}, _a[key] = updatedAttr, _a));
        }
        updateAttribute === null || updateAttribute === void 0 ? void 0 : updateAttribute(__assign(__assign({}, attr), { properties: updatedProperties, required: updatedRequired }));
    };
    var removeNestedAttribute = function (key) {
        var updatedProperties = __assign({}, attr.properties);
        delete updatedProperties[key];
        var required = attr.required || [];
        var requiredI = required.indexOf(key);
        if (requiredI !== -1) {
            required = __spreadArrays(required.slice(0, requiredI), required.slice(requiredI + 1));
        }
        updateAttribute === null || updateAttribute === void 0 ? void 0 : updateAttribute(__assign(__assign({}, attr), { properties: updatedProperties, required: required }));
        if (!Object.keys(updatedProperties).length) {
            if (!isCredSubject) {
                // No nested attributes left so delete the parent one. Maybe a weird flow but certainly simpler than either allowing empty nested attributes or performing a recursive check for empty nested attributes before letting user continue.
                removeAttribute === null || removeAttribute === void 0 ? void 0 : removeAttribute();
            }
            else {
                // Gotta leave at least one in
                updateAttrProperty("properties", { "": __assign({}, types_1.newSchemaAttribute) });
            }
        }
    };
    function renderNestedAttributes() {
        return (jsx_runtime_1.jsx(jsx_runtime_1.Fragment, { children: Object.entries(attr.properties || {}).map(function (_a, i) {
                var key = _a[0], node = _a[1];
                return (jsx_runtime_1.jsx(exports.SchemaAttribute, { attrName: key, attr: node, updateAttribute: function (attr) { return updateNestedAttribute(key, attr); }, removeAttribute: function () { return removeNestedAttribute(key); }, parentRequired: attr.required, setParentRequired: function (required) { return updateAttrProperty("required", required); } }, i));
            }) }, void 0));
    }
    if (isCredSubject) {
        return renderNestedAttributes();
    }
    var currentTypeValue = attr.type === "object" ? utils_1.NESTED_TYPE_KEY : vc_schema_tools_1.nodeToTypeName(attr);
    return (jsx_runtime_1.jsxs(AttributeBox, __assign({ border: 1, borderRadius: 1, p: 3, pb: readOnly ? 3 : 1, my: 3, backgroundColor: readOnly ? themes_1.colors.nearWhite : "transparent" }, { children: [jsx_runtime_1.jsxs(rimble_ui_1.Flex, { children: [jsx_runtime_1.jsx(rimble_ui_1.Input, { width: "100%", type: "text", required: true, placeholder: "Attribute Name", mr: 2, value: attr.title || ((_a = attr.$linkedData) === null || _a === void 0 ? void 0 : _a.term) || attrName || "", onChange: function (event) { return updateAttrProperty("title", event.target.value); }, disabled: readOnly, style: { borderColor: themes_1.colors.lightGray } }, void 0),
                    currentTypeValue && currentTypeValue in utils_1.typeOptions ? (jsx_runtime_1.jsx(DropDown_1.DropDown, { onChange: function (value) { return updateType(value); }, defaultSelectedValue: currentTypeValue, disabled: readOnly, options: Object.keys(utils_1.typeOptions).map(function (typeName) { return ({
                            name: typeName === utils_1.NESTED_TYPE_KEY ? "[nested properties]" : typeName,
                            value: typeName,
                        }); }), style: { borderColor: themes_1.colors.lightGray } }, void 0)) : (jsx_runtime_1.jsx(rimble_ui_1.Box, __assign({ width: "100%", maxWidth: "50%", pt: 1, px: 2, style: { overflow: "hidden", textOverflow: "ellipsis" }, title: currentTypeValue }, { children: currentTypeValue }), void 0))] }, void 0),
            !readOnly && (jsx_runtime_1.jsx(rimble_ui_1.Input, { width: "100%", placeholder: "Description", value: attr.description || "", style: { borderColor: themes_1.colors.lightGray }, onChange: function (event) { return updateAttrProperty("description", event.target.value); } }, void 0)),
            attr.type === "object" && jsx_runtime_1.jsx(rimble_ui_1.Box, __assign({ mt: 3 }, { children: renderNestedAttributes() }), void 0),
            jsx_runtime_1.jsxs(rimble_ui_1.Flex, __assign({ justifyContent: "space-between" }, { children: [jsx_runtime_1.jsx(rimble_ui_1.Checkbox, { fontFamily: themes_1.fonts.sansSerif, label: "Required", checked: ((_b = attr.$linkedData) === null || _b === void 0 ? void 0 : _b.term) && (parentRequired === null || parentRequired === void 0 ? void 0 : parentRequired.includes((_c = attr.$linkedData) === null || _c === void 0 ? void 0 : _c.term)), onChange: toggleRequired, disabled: readOnly, mt: readOnly ? 2 : 0 }, void 0),
                    attr.type === "object" && (jsx_runtime_1.jsx(rimble_ui_1.Button.Text, __assign({ onClick: addNestedAttribute, fontSize: 1 }, { children: "Add Nested Attribute" }), void 0)),
                    !readOnly && (jsx_runtime_1.jsx(IconButton, { icononly: true, icon: "DeleteForever", onClick: function (e) {
                            e.preventDefault();
                            removeAttribute === null || removeAttribute === void 0 ? void 0 : removeAttribute();
                        } }, void 0))] }), void 0)] }), void 0));
};
exports.SchemaAttribute = SchemaAttribute;
var templateObject_1, templateObject_2;
//# sourceMappingURL=SchemaAttribute.js.map