"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CreateSchema = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var React = __importStar(require("react"));
var slugify_1 = __importDefault(require("@sindresorhus/slugify"));
var icons_1 = require("@rimble/icons");
var rimble_ui_1 = require("rimble-ui");
var swr_1 = require("swr");
var react_simple_code_editor_1 = __importDefault(require("react-simple-code-editor"));
var prismjs_1 = __importDefault(require("prismjs"));
var use_debounce_1 = require("use-debounce");
var config_1 = require("../../../../config");
var types_1 = require("../types");
var utils_1 = require("../utils");
var AttributesStep_1 = require("./AttributesStep");
var ConfirmStep_1 = require("./ConfirmStep");
var InfoStep_1 = require("./InfoStep");
var layouts_1 = require("../../../layouts");
var themes_1 = require("../../../../themes");
var SertoUiContext_1 = require("../../../../context/SertoUiContext");
var SchemaDetail_1 = require("../SchemaDetail");
var Popup_1 = require("../../../elements/Popup/Popup");
var HighlightedJson_1 = require("../../../elements/HighlightedJson/HighlightedJson");
var helpers_1 = require("../../../../utils/helpers");
var STEPS = ["INFO", "ATTRIBUTES", "CONFIRM", "DONE"];
var CreateSchema = function (props) {
    var className = props.className, isUpdate = props.isUpdate, userOwnsSchema = props.userOwnsSchema, initialSchemaState = props.initialSchemaState, onComplete = props.onComplete, onSchemaUpdate = props.onSchemaUpdate, onSchemaSaved = props.onSchemaSaved;
    var _a = React.useState(STEPS[0]), currentStep = _a[0], setCurrentStep = _a[1];
    var _b = React.useState(false), loading = _b[0], setLoading = _b[1];
    var _c = React.useState(""), error = _c[0], setError = _c[1];
    var _d = React.useState(types_1.baseWorkingSchema), schema = _d[0], setSchema = _d[1];
    var debouncedSchema = use_debounce_1.useDebounce(schema, 500)[0];
    var _e = React.useState(), builtSchema = _e[0], setBuiltSchema = _e[1];
    var _f = React.useState("UI"), inputMode = _f[0], setInputMode = _f[1];
    var _g = React.useState(""), inputJson = _g[0], setInputJson = _g[1];
    var debouncedInputSchemaJson = use_debounce_1.useDebounce(inputJson, 500)[0];
    var _h = React.useState(""), inputJsonError = _h[0], setInputJsonError = _h[1];
    var schemasService = React.useContext(SertoUiContext_1.SertoUiContext).schemasService;
    React.useEffect(function () {
        if (initialSchemaState) {
            setSchema(initialSchemaState);
        }
        else {
            setSchema(types_1.baseWorkingSchema);
        }
    }, [initialSchemaState]);
    React.useEffect(function () {
        var _a;
        if (!((_a = debouncedSchema === null || debouncedSchema === void 0 ? void 0 : debouncedSchema.$metadata) === null || _a === void 0 ? void 0 : _a.slug) && (debouncedSchema === null || debouncedSchema === void 0 ? void 0 : debouncedSchema.title)) {
            setSchema(function (oldSchema) { return (__assign(__assign({}, oldSchema), { $metadata: __assign(__assign({}, oldSchema.$metadata), { slug: slugify_1.default((debouncedSchema === null || debouncedSchema === void 0 ? void 0 : debouncedSchema.title) || "") }) })); });
        }
        try {
            setInputJsonError("");
            setBuiltSchema(utils_1.jsonSchemaToSchemaInput(debouncedSchema, schemasService.buildSchemaUrl));
        }
        catch (err) {
            console.error("Failed to build schema. Schema:", debouncedSchema, "Error:", err);
            setInputJsonError("Failed to build schema from JSON: " + err.toString());
        }
    }, [debouncedSchema, schemasService.buildSchemaUrl]);
    React.useEffect(function () {
        if (inputMode === "JSON" && builtSchema) {
            setInputJson(JSON.stringify(JSON.parse(builtSchema.jsonSchema), null, 2));
            setInputJsonError("");
        }
        // Hook relies on `builtSchema` but would be huge waste to run this hook every time that changes. We only need to run it when input mode changes so we can populate the JSON textarea with the current state of the schema. So:
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, [inputMode]);
    React.useEffect(function () {
        if (!debouncedInputSchemaJson) {
            return;
        }
        try {
            setInputJsonError("");
            var parsedSchema = JSON.parse(debouncedInputSchemaJson);
            var fullSchema = utils_1.ensureFullSchema(parsedSchema, schemasService.buildSchemaUrl);
            if (!utils_1.isFullSchema(parsedSchema)) {
                // We've transformed the JSON that they put in the JSON editor, so let's update the JSON editor
                setInputJson(JSON.stringify(fullSchema, null, 2));
            }
            setSchema(fullSchema);
        }
        catch (err) {
            setInputJsonError(err.toString());
            console.warn("Error creating schema from JSON", err);
        }
    }, [debouncedInputSchemaJson, schemasService.buildSchemaUrl]);
    React.useEffect(function () {
        onSchemaUpdate === null || onSchemaUpdate === void 0 ? void 0 : onSchemaUpdate(debouncedSchema);
    }, [debouncedSchema, onSchemaUpdate]);
    function updateSchema(updates) {
        var _a;
        var newSchema = __assign(__assign({}, schema), updates);
        if (updates.title) {
            var subjectLdTerm = helpers_1.convertToPascalCase(updates.title);
            var credLdTerm = subjectLdTerm + "Credential";
            newSchema.$linkedData = { term: credLdTerm, "@id": credLdTerm };
            if ((_a = newSchema.properties) === null || _a === void 0 ? void 0 : _a.credentialSubject) {
                newSchema.properties.credentialSubject.$linkedData = { term: subjectLdTerm, "@id": subjectLdTerm };
            }
        }
        setSchema(newSchema);
    }
    function goBack() {
        setError("");
        setCurrentStep(STEPS[STEPS.indexOf(currentStep) - 1]);
    }
    function goForward() {
        return __awaiter(this, void 0, void 0, function () {
            var nextStep, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        setError("");
                        nextStep = STEPS[STEPS.indexOf(currentStep) + 1];
                        if (!(nextStep === "DONE")) return [3 /*break*/, 5];
                        setLoading(true);
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        if (!builtSchema) {
                            throw Error("Failed to build schema");
                        }
                        return [4 /*yield*/, publishSchema()];
                    case 2:
                        _a.sent();
                        setCurrentStep(nextStep);
                        onSchemaSaved === null || onSchemaSaved === void 0 ? void 0 : onSchemaSaved(builtSchema);
                        return [3 /*break*/, 4];
                    case 3:
                        err_1 = _a.sent();
                        console.error("Failed to " + (isUpdate && userOwnsSchema ? "update" : "create") + " schema:", err_1);
                        setError(err_1.toString());
                        return [3 /*break*/, 4];
                    case 4:
                        setLoading(false);
                        return [3 /*break*/, 6];
                    case 5:
                        setCurrentStep(nextStep);
                        _a.label = 6;
                    case 6: return [2 /*return*/];
                }
            });
        });
    }
    function publishSchema() {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        onSchemaUpdate === null || onSchemaUpdate === void 0 ? void 0 : onSchemaUpdate(schema);
                        if (!builtSchema) {
                            throw Error("Failed to build schema");
                        }
                        if (!(isUpdate && userOwnsSchema)) return [3 /*break*/, 2];
                        return [4 /*yield*/, schemasService.updateSchema(builtSchema)];
                    case 1:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 2: return [4 /*yield*/, schemasService.createSchema(builtSchema)];
                    case 3:
                        _a.sent();
                        _a.label = 4;
                    case 4:
                        swr_1.mutate(["getSchemas", true]);
                        if (schema.discoverable) {
                            swr_1.mutate(["getSchemas", false]);
                        }
                        return [2 /*return*/];
                }
            });
        });
    }
    if (currentStep === "DONE") {
        return (jsx_runtime_1.jsxs(rimble_ui_1.Box, __assign({ px: 4, py: 0, className: className }, { children: [jsx_runtime_1.jsxs(rimble_ui_1.Text, __assign({ mt: 3, mb: 6, textAlign: "center", color: themes_1.colors.success.base }, { children: [jsx_runtime_1.jsx(rimble_ui_1.Text, __assign({ bg: themes_1.colors.success.light, borderRadius: "50%", p: 2, width: "50px", height: "50px", fontSize: 4, style: { display: "inline-block" } }, { children: jsx_runtime_1.jsx(icons_1.Check, { size: "36px" }, void 0) }), void 0),
                        jsx_runtime_1.jsxs(layouts_1.H3, { children: ["Schema ", isUpdate ? "Updated" : "Published"] }, void 0)] }), void 0),
                jsx_runtime_1.jsx(rimble_ui_1.Box, __assign({ mt: 5 }, { children: jsx_runtime_1.jsx(rimble_ui_1.Button, __assign({ width: "100%", onClick: function () { return onComplete === null || onComplete === void 0 ? void 0 : onComplete(); } }, { children: "Done" }), void 0) }), void 0)] }), void 0));
    }
    return (jsx_runtime_1.jsxs(rimble_ui_1.Flex, __assign({ className: className }, { children: [jsx_runtime_1.jsxs(rimble_ui_1.Box, __assign({ px: 5, pt: 3, pb: 5, width: 9, minWidth: 9, maxHeight: "100%", overflowY: "auto" }, { children: [jsx_runtime_1.jsx(rimble_ui_1.Box, __assign({ pb: 3, mb: 4, borderBottom: 1 }, { children: jsx_runtime_1.jsxs(rimble_ui_1.Flex, __assign({ justifyContent: "space-between" }, { children: [jsx_runtime_1.jsxs(rimble_ui_1.Box, { children: [jsx_runtime_1.jsx(rimble_ui_1.Text, __assign({ fontWeight: 4, fontSize: 3 }, { children: currentStep === "INFO"
                                                ? (isUpdate ? (userOwnsSchema ? "Update" : "Fork") : "Create New") + " Schema"
                                                : currentStep === "ATTRIBUTES"
                                                    ? (isUpdate ? "Edit" : "Define") + " Schema Attributes"
                                                    : "Review Schema" }), void 0),
                                        currentStep !== "CONFIRM" && (jsx_runtime_1.jsx(rimble_ui_1.Text, __assign({ mt: 1, fontSize: 1 }, { children: "Edit and preview in the next panel" }), void 0))] }, void 0),
                                jsx_runtime_1.jsx(Popup_1.Popup, __assign({ triggerOnClick: true, popupContents: jsx_runtime_1.jsx(Popup_1.PopupGroup, { children: ["UI", "JSON"].map(function (inputName) { return (jsx_runtime_1.jsxs("a", __assign({ onClick: function () { return setInputMode(inputName); }, className: inputMode === inputName ? "selected" : "" }, { children: [inputName, " Editor"] }), inputName)); }) }, void 0) }, { children: jsx_runtime_1.jsx(jsx_runtime_1.Fragment, { children: jsx_runtime_1.jsxs(rimble_ui_1.Button.Outline, __assign({ size: "small" }, { children: [inputMode, " Editor ", jsx_runtime_1.jsx(icons_1.KeyboardArrowDown, { ml: 3, mr: "-5px", size: "16px" }, void 0)] }), void 0) }, void 0) }), void 0)] }), void 0) }), void 0),
                    inputMode === "JSON" ? (jsx_runtime_1.jsxs(jsx_runtime_1.Fragment, { children: [jsx_runtime_1.jsx(rimble_ui_1.Flash, __assign({ variant: "warning", mt: -2, mb: 3 }, { children: jsx_runtime_1.jsxs(rimble_ui_1.Text, __assign({ fontSize: 0 }, { children: ["Warning: This feature is for advanced users, and it is possible to create an unusable schema. Please check the preview on the right to ensure that your schema is as intended. The expected format is JSON Schema", " ", jsx_runtime_1.jsx(rimble_ui_1.Link, __assign({ href: "https://github.com/w3c-ccg/traceability-vocab#ontology-structure", target: "_blank", fontSize: 0 }, { children: "with embedded JSON-LD data" }), void 0), ". View examples at the", " ", jsx_runtime_1.jsx(rimble_ui_1.Link, __assign({ href: config_1.links.SCHEMAS_PLAYGROUND, target: "_blank", fontSize: 0 }, { children: "Schema Playground" }), void 0), ", or start with the UI editor and then adjust as needed."] }), void 0) }), void 0),
                            jsx_runtime_1.jsx(HighlightedJson_1.PrismHighlightedCodeWrap, __assign({ style: {
                                    background: "white",
                                    border: "1px solid transparent",
                                    borderColor: inputJsonError && themes_1.colors.danger.base,
                                } }, { children: jsx_runtime_1.jsx(react_simple_code_editor_1.default, { value: inputJson, onValueChange: setInputJson, highlight: function () { return prismjs_1.default.highlight(inputJson, prismjs_1.default.languages.json, "json"); }, style: { minHeight: "100%" } }, void 0) }), void 0),
                            inputJsonError && (jsx_runtime_1.jsxs(rimble_ui_1.Flash, __assign({ variant: "danger", my: 2 }, { children: ["Error creating schema from JSON:", jsx_runtime_1.jsx(rimble_ui_1.Box, __assign({ mt: 1 }, { children: jsx_runtime_1.jsx("code", { children: inputJsonError }, void 0) }), void 0)] }), void 0)),
                            jsx_runtime_1.jsx(rimble_ui_1.Button, __assign({ width: "100%", disabled: inputJsonError, onClick: function () {
                                    setCurrentStep("INFO");
                                    setInputMode("UI");
                                } }, { children: "Review" }), void 0)] }, void 0)) : (jsx_runtime_1.jsxs(jsx_runtime_1.Fragment, { children: [currentStep !== STEPS[0] && (jsx_runtime_1.jsxs(rimble_ui_1.Link, __assign({ display: "block", size: "small", onClick: goBack, mt: -2, mb: 4 }, { children: [jsx_runtime_1.jsx(rimble_ui_1.Box, __assign({ display: "inline-block", verticalAlign: "text-top", mr: 2 }, { children: jsx_runtime_1.jsx(icons_1.ArrowBack, { size: "16px" }, void 0) }), void 0), " ", "Back"] }), void 0)),
                            currentStep === "INFO" ? (jsx_runtime_1.jsx(InfoStep_1.InfoStep, { isUpdate: isUpdate, userOwnsSchema: userOwnsSchema, isAuthenticated: schemasService.isAuthenticated, initialSchemaState: initialSchemaState, schema: schema, updateSchema: updateSchema, onComplete: goForward }, void 0)) : currentStep === "ATTRIBUTES" ? (jsx_runtime_1.jsx(AttributesStep_1.AttributesStep, { schema: schema, updateSchema: updateSchema, onComplete: goForward }, void 0)) : builtSchema ? (jsx_runtime_1.jsx(rimble_ui_1.Box, __assign({ mt: 4 }, { children: jsx_runtime_1.jsx(ConfirmStep_1.ConfirmStep, { builtSchema: builtSchema, onComplete: goForward, loading: loading, isUpdate: isUpdate, userOwnsSchema: userOwnsSchema, isAuthenticated: schemasService.isAuthenticated, error: error }, void 0) }), void 0)) : (jsx_runtime_1.jsx(jsx_runtime_1.Fragment, {}, void 0))] }, void 0))] }), void 0),
            jsx_runtime_1.jsx(rimble_ui_1.Box, __assign({ className: "right-pane", minWidth: 9, backgroundColor: themes_1.colors.nearWhite, borderLeft: 1, px: 5, py: 3, flexGrow: "1" }, { children: builtSchema && (jsx_runtime_1.jsx(SchemaDetail_1.SchemaDetail, { schema: builtSchema, primaryView: inputMode === "JSON" ? "Formatted View" : "JSON Schema", hideTools: true, paneView: true }, void 0)) }), void 0)] }), void 0));
};
exports.CreateSchema = CreateSchema;
//# sourceMappingURL=index.js.map