"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SchemaCard = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var styled_components_1 = __importDefault(require("styled-components"));
var linkify_react_1 = __importDefault(require("linkify-react"));
var rimble_ui_1 = require("rimble-ui");
var icons_1 = require("@rimble/icons");
var themes_1 = require("../../../themes");
var SchemaHeader_1 = require("./SchemaHeader");
var Wrapper = styled_components_1.default(rimble_ui_1.Flex)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  ", "\n"], ["\n  ",
    "\n"])), function (props) {
    return props.onClick &&
        "\n    cursor: pointer;\n    &:hover {\n      border-color: " + themes_1.colors.primary.base + ";\n    }\n  ";
});
var IconWrap = styled_components_1.default(rimble_ui_1.Box)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  svg {\n    vertical-align: text-bottom;\n  }\n"], ["\n  svg {\n    vertical-align: text-bottom;\n  }\n"])));
var GitHubLink = styled_components_1.default.a(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  text-decoration: none;\n  color: ", ";\n  &:hover {\n    color: ", ";\n  }\n"], ["\n  text-decoration: none;\n  color: ", ";\n  &:hover {\n    color: ", ";\n  }\n"])), themes_1.colors.silver, themes_1.colors.primary.base);
var SchemaCard = function (props) {
    var schema = props.schema, className = props.className, style = props.style, onClick = props.onClick;
    return (jsx_runtime_1.jsxs(Wrapper, __assign({ className: className, pt: 4, border: 1, borderRadius: 2, fontFamily: themes_1.fonts.sansSerif, flexDirection: "column", justifyContent: "space-between", style: style, onClick: onClick }, { children: [jsx_runtime_1.jsxs(rimble_ui_1.Box, __assign({ px: 3 }, { children: [jsx_runtime_1.jsx(SchemaHeader_1.SchemaHeader, { schema: schema }, void 0),
                    "favoriteCount" in schema && (jsx_runtime_1.jsxs(IconWrap, __assign({ fontSize: 1, mt: 3, mb: 4 }, { children: [jsx_runtime_1.jsx(icons_1.StarBorder, { size: "18px" }, void 0), " ", schema.favoriteCount, jsx_runtime_1.jsx(icons_1.CallSplit, { size: "18px", ml: 3 }, void 0), " 0", jsx_runtime_1.jsx(icons_1.Send, { size: "18px", ml: 3 }, void 0), " 0"] }), void 0)),
                    schema.description && (jsx_runtime_1.jsx(rimble_ui_1.Text, __assign({ my: 2, onClick: function (event) { return event.stopPropagation(); } }, { children: jsx_runtime_1.jsx(linkify_react_1.default, __assign({ options: { target: "_blank" } }, { children: schema.description }), void 0) }), void 0))] }), void 0),
            jsx_runtime_1.jsxs(rimble_ui_1.Flex, __assign({ px: 3, borderTop: 2, height: "48px", fontSize: 1, justifyContent: "space-between", alignItems: "center" }, { children: ["creator" in schema && schema.creator ? (jsx_runtime_1.jsx(GitHubLink, __assign({ href: "https://github.com/" + schema.creator.nickName, target: "_blank", color: themes_1.colors.silver, onClick: function (event) { return event.stopPropagation(); } }, { children: schema.creator.name || schema.creator.nickName }), void 0)) : (jsx_runtime_1.jsx("span", {}, void 0)),
                    "updated" in schema && (jsx_runtime_1.jsx(rimble_ui_1.Box, __assign({ title: "Last Updated", color: themes_1.colors.silver }, { children: new Date(schema.updated).toLocaleDateString() }), void 0))] }), void 0)] }), void 0));
};
exports.SchemaCard = SchemaCard;
var templateObject_1, templateObject_2, templateObject_3;
//# sourceMappingURL=SchemaCard.js.map