"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SchemaCards = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var React = __importStar(require("react"));
var react_router_dom_1 = require("react-router-dom");
var styled_components_1 = __importDefault(require("styled-components"));
var rimble_ui_1 = require("rimble-ui");
var swr_1 = __importDefault(require("swr"));
var SertoUiContext_1 = require("../../../context/SertoUiContext");
var SchemaCard_1 = require("./SchemaCard");
var StyledFlex = styled_components_1.default(rimble_ui_1.Flex)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  // Fix for two alone on last row being spaced at beginning and end, instead of beginning and middle.\n  &:after {\n    content: \"\";\n    flex-basis: 32%;\n  }\n"], ["\n  // Fix for two alone on last row being spaced at beginning and end, instead of beginning and middle.\n  &:after {\n    content: \"\";\n    flex-basis: 32%;\n  }\n"])));
var SchemaCards = function (props) {
    var schemasService = React.useContext(SertoUiContext_1.SertoUiContext).schemasService;
    var _a = swr_1.default(["getSchemas", props.filter === "CREATED"], function () { return schemasService.getSchemas(props.filter === "CREATED"); }, {
        revalidateOnFocus: false,
    }), data = _a.data, error = _a.error, isValidating = _a.isValidating;
    var schemas = React.useMemo(function () { return data === null || data === void 0 ? void 0 : data.sort(function (schema1, schema2) {
        var favDifference = (schema2.favoriteCount || 0) - (schema1.favoriteCount || 0);
        return favDifference || (schema1.updated < schema2.updated ? 1 : -1);
    }).slice(0, props.maxLength || undefined); }, [data, props.maxLength]);
    if (!error && !isValidating && !(schemas === null || schemas === void 0 ? void 0 : schemas.length)) {
        return (props.noSchemasElement || (jsx_runtime_1.jsxs(rimble_ui_1.Text.p, __assign({ display: "block", fontSize: 1, py: 2, lineHeight: "copy" }, { children: [jsx_runtime_1.jsxs("b", __assign({ style: { display: "block", fontWeight: 600 } }, { children: [props.filter === "CREATED" ? "You have" : "There are", " no credential schemas yet."] }), void 0), "Please first ", jsx_runtime_1.jsx(react_router_dom_1.Link, __assign({ to: schemasService.createSchemaPath }, { children: "create a credential schema" }), void 0), " in order to coordinate around verified data with your customers and partners."] }), void 0)));
    }
    var loaderPlaceholders = props.firstCard ? [1, 2, 3, 4, 5] : [1, 2, 3, 4, 5, 6];
    return (jsx_runtime_1.jsxs(StyledFlex, __assign({ justifyContent: "space-between", flexWrap: "wrap" }, { children: [props.firstCard && jsx_runtime_1.jsx(rimble_ui_1.Box, __assign({ width: "32%" }, { children: props.firstCard }), void 0),
            isValidating && !(schemas === null || schemas === void 0 ? void 0 : schemas.length) ? (loaderPlaceholders.map(function (i) { return (jsx_runtime_1.jsx(rimble_ui_1.Box, __assign({ py: 6, width: "32%" }, { children: jsx_runtime_1.jsx(rimble_ui_1.Loader, { size: "32px", m: "auto" }, void 0) }), i)); })) : error ? (jsx_runtime_1.jsxs(rimble_ui_1.Flash, __assign({ variant: "danger", width: "33%" }, { children: ["Error loading schemas: ", error.message] }), void 0)) : (schemas === null || schemas === void 0 ? void 0 : schemas.map(function (schema, i) { return (jsx_runtime_1.jsx(SchemaCard_1.SchemaCard, { schema: schema, style: { width: "32%", minHeight: 300, marginBottom: "16px" }, onClick: props.onSchemaClick && (function () { var _a; return (_a = props.onSchemaClick) === null || _a === void 0 ? void 0 : _a.call(props, schema); }) }, i)); }))] }), void 0));
};
exports.SchemaCards = SchemaCards;
var templateObject_1;
//# sourceMappingURL=SchemaCards.js.map