"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("react/jsx-runtime");
var react_router_dom_1 = require("react-router-dom");
var react_1 = require("@storybook/react");
var vc_schema_tools_1 = require("vc-schema-tools");
var utils_1 = require("./utils");
var IdentityTheme_1 = require("../../../themes/IdentityTheme");
var SertoUiProvider_1 = require("../../../context/SertoUiProvider");
var SchemaCards_1 = require("./SchemaCards");
var schemas = Object.entries(vc_schema_tools_1.EXAMPLE_SCHEMAS)
    .map(function (_a) {
    var key = _a[0], schema = _a[1];
    if (key === "[no schema]") {
        return undefined;
    }
    try {
        return utils_1.jsonSchemaToSchemaInput(schema);
    }
    catch (err) {
        console.error("failed to create schema input for schema \"" + key + "\"", err);
        return undefined;
    }
})
    .filter(function (schema) { return !!schema; });
var SchemaCardsStory = function () {
    return (jsx_runtime_1.jsx(react_router_dom_1.BrowserRouter, { children: jsx_runtime_1.jsx(IdentityTheme_1.IdentityThemeProvider, { children: jsx_runtime_1.jsx(SertoUiProvider_1.SertoUiProvider, __assign({ context: {
                    schemasService: {
                        getSchemas: function () { return schemas.concat(schemas); },
                    },
                } }, { children: jsx_runtime_1.jsx(SchemaCards_1.SchemaCards, {}, void 0) }), void 0) }, void 0) }, void 0));
};
react_1.storiesOf("Schemas", module).add("SchemaCards", SchemaCardsStory);
//# sourceMappingURL=SchemaCards.stories.js.map