"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SchemaDetail = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var React = __importStar(require("react"));
var linkify_react_1 = __importDefault(require("linkify-react"));
var styled_components_1 = __importDefault(require("styled-components"));
var rimble_ui_1 = require("rimble-ui");
var icons_1 = require("@rimble/icons");
var layouts_1 = require("../../layouts");
var themes_1 = require("../../../themes");
var SchemaSaves_1 = require("./SchemaSaves");
var SchemaHeader_1 = require("./SchemaHeader");
var SchemaPreview_1 = require("./SchemaPreview");
var GitHub_1 = require("../../elements/Icons/GitHub");
var SertoUiContext_1 = require("../../../context/SertoUiContext");
var SidebarHeading = styled_components_1.default(layouts_1.H5)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  margin-bottom: 12px;\n  &:first-child {\n    margin-top: 0;\n  }\n"], ["\n  margin-bottom: 12px;\n  &:first-child {\n    margin-top: 0;\n  }\n"])));
var UserLink = styled_components_1.default.a(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  color: ", ";\n  text-decoration: none;\n  &:hover {\n    color: ", ";\n  }\n\n  &,\n  svg {\n    vertical-align: middle;\n  }\n  svg {\n    margin: 0 8px;\n  }\n  svg:first-child {\n    margin-left: 0;\n  }\n"], ["\n  color: ", ";\n  text-decoration: none;\n  &:hover {\n    color: ", ";\n  }\n\n  &,\n  svg {\n    vertical-align: middle;\n  }\n  svg {\n    margin: 0 8px;\n  }\n  svg:first-child {\n    margin-left: 0;\n  }\n"])), themes_1.baseColors.blurple, themes_1.colors.primary.light);
var SchemaDetail = function (props) {
    var _a, _b, _c;
    var schema = props.schema, primaryView = props.primaryView, hideTools = props.hideTools, hideIssueVc = props.hideIssueVc, fullPage = props.fullPage, paneView = props.paneView, noSwitcher = props.noSwitcher;
    var schemasService = React.useContext(SertoUiContext_1.SertoUiContext).schemasService;
    var _d = React.useState(primaryView || SchemaPreview_1.SCHEMA_VIEWS[0]), view = _d[0], setView = _d[1];
    var userOwnsSchema = "creator" in schema && ((_a = schemasService.userData) === null || _a === void 0 ? void 0 : _a.sub) === ((_b = schema.creator) === null || _b === void 0 ? void 0 : _b.identifier);
    // If `primaryView` prop changes, set the view to that - but future calls to `setView` will still take effect.
    React.useEffect(function () {
        if (primaryView) {
            setView(primaryView);
        }
    }, [primaryView]);
    return (jsx_runtime_1.jsxs(jsx_runtime_1.Fragment, { children: [!paneView && (jsx_runtime_1.jsxs(rimble_ui_1.Flex, __assign({ mb: 4, justifyContent: "space-between" }, { children: [jsx_runtime_1.jsx(SchemaHeader_1.SchemaHeader, { schema: schema }, void 0),
                    !hideTools && jsx_runtime_1.jsx(SchemaSaves_1.SchemaSaves, { schema: schema }, void 0)] }), void 0)),
            jsx_runtime_1.jsxs(rimble_ui_1.Flex, __assign({ justifyContent: "space-between" }, { children: [jsx_runtime_1.jsx(SchemaPreview_1.SchemaPreview, { schema: schema, view: view, setView: setView, hideTools: hideTools, hideIssueVc: hideIssueVc, fullPage: fullPage, paneView: paneView, noSwitcher: noSwitcher, rimbleProps: fullPage ? { flexGrow: 1, pr: 4, maxWidth: "665px" } : { maxWidth: "100%" } }, void 0),
                    fullPage && (jsx_runtime_1.jsxs(rimble_ui_1.Box, __assign({ maxWidth: "340px" }, { children: [jsx_runtime_1.jsx(SidebarHeading, { children: "Description" }, void 0),
                            jsx_runtime_1.jsx(rimble_ui_1.Text, { children: jsx_runtime_1.jsx(linkify_react_1.default, __assign({ options: { target: "_blank" } }, { children: schema.description }), void 0) }, void 0),
                            jsx_runtime_1.jsx(SidebarHeading, { children: "Schema Author" }, void 0),
                            jsx_runtime_1.jsx(rimble_ui_1.Text, { children: "creator" in schema && ((_c = schema.creator) === null || _c === void 0 ? void 0 : _c.name) && schema.creator.nickName ? (jsx_runtime_1.jsxs(jsx_runtime_1.Fragment, { children: [schema.creator.name && (jsx_runtime_1.jsxs(rimble_ui_1.Text, { children: [schema.creator.name, userOwnsSchema && " (you)"] }, void 0)),
                                        schema.creator.identifier.includes("github") && (jsx_runtime_1.jsxs(UserLink, __assign({ href: "https://github.com/" + schema.creator.nickName, target: "_blank" }, { children: [jsx_runtime_1.jsx(GitHub_1.GitHub, { style: { width: 16, height: "auto" } }, void 0), schema.creator.nickName, jsx_runtime_1.jsx(icons_1.OpenInNew, { size: "16px" }, void 0)] }), void 0))] }, void 0)) : (jsx_runtime_1.jsx("i", { children: "Author details coming soon" }, void 0)) }, void 0),
                            "updated" in schema && (jsx_runtime_1.jsxs(jsx_runtime_1.Fragment, { children: [jsx_runtime_1.jsx(SidebarHeading, { children: "Releases" }, void 0),
                                    jsx_runtime_1.jsxs(rimble_ui_1.Text, { children: ["Version ", schema.version, " on ", new Date(schema.updated).toLocaleDateString()] }, void 0),
                                    jsx_runtime_1.jsx(rimble_ui_1.Text, __assign({ mt: 2 }, { children: jsx_runtime_1.jsx("i", { children: "Full version history coming soon" }, void 0) }), void 0)] }, void 0))] }), void 0))] }), void 0)] }, void 0));
};
exports.SchemaDetail = SchemaDetail;
var templateObject_1, templateObject_2;
//# sourceMappingURL=SchemaDetail.js.map