"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = __importDefault(require("react"));
var react_2 = require("@storybook/react");
var rimble_ui_1 = require("rimble-ui");
var vc_schema_tools_1 = require("vc-schema-tools");
var SchemaDetail_1 = require("./SchemaDetail");
var utils_1 = require("./utils");
var IdentityTheme_1 = require("../../../themes/IdentityTheme");
var SertoUiProvider_1 = require("../../../context/SertoUiProvider");
var helpers_1 = require("../../../utils/helpers");
var DEFAULT_SCHEMA = "ContentPublishCredential";
var IDENTIFIERS = [
    {
        did: "did:ethr:rinkeby:0xcfa8829812f1b4fe09b27cacf7d36e4d1b5dce76",
        provider: "did:ethr:rinkeby",
        alias: "Admin",
    },
    {
        did: "did:ethr:rinkeby:0x88298d36e4d1b5dce76cf9b27cacf7a12f1b4fe0",
        provider: "did:ethr:rinkeby",
        alias: "Another User",
    },
];
var SchemaDetailStory = function () {
    var _a = react_1.default.useState(DEFAULT_SCHEMA), schemaKey = _a[0], setSchemaKey = _a[1];
    var schemaData;
    var error;
    try {
        schemaData = utils_1.jsonSchemaToSchemaInput(vc_schema_tools_1.EXAMPLE_SCHEMAS[schemaKey]);
    }
    catch (err) {
        console.error("Failed to generate schema input from schema:", err);
        error = err.message || JSON.stringify(err);
    }
    return (jsx_runtime_1.jsxs(IdentityTheme_1.IdentityThemeProvider, { children: [jsx_runtime_1.jsx(rimble_ui_1.Box, __assign({ mb: 3 }, { children: jsx_runtime_1.jsx("select", __assign({ value: schemaKey, onChange: function (event) { return setSchemaKey(event.target.value); } }, { children: Object.keys(vc_schema_tools_1.EXAMPLE_SCHEMAS).map(function (key) { return (jsx_runtime_1.jsx("option", __assign({ value: key }, { children: key }), key)); }) }), void 0) }), void 0),
            jsx_runtime_1.jsxs(rimble_ui_1.Box, { children: [schemaData && jsx_runtime_1.jsx(SchemaDetail_1.SchemaDetail, { schema: schemaData }, void 0),
                    error && jsx_runtime_1.jsxs(rimble_ui_1.Flash, __assign({ variant: "danger" }, { children: ["Error: ", error] }), void 0)] }, schemaKey)] }, void 0));
};
react_2.storiesOf("Schemas", module)
    .add("SchemaDetail", SchemaDetailStory)
    .add("SchemaDetail (saveable)", function () {
    return (jsx_runtime_1.jsx(SertoUiProvider_1.SertoUiProvider, __assign({ context: {
            schemasService: {
                isAuthenticated: true,
            },
        } }, { children: jsx_runtime_1.jsx(SchemaDetailStory, {}, void 0) }), void 0));
})
    .add("SchemaDetail (VC issuable)", function () {
    return (jsx_runtime_1.jsx(SertoUiProvider_1.SertoUiProvider, __assign({ context: {
            userDids: IDENTIFIERS,
            issueVc: helpers_1.createMockApiRequest(),
        } }, { children: jsx_runtime_1.jsx(SchemaDetailStory, {}, void 0) }), void 0));
});
//# sourceMappingURL=SchemaDetail.stories.js.map