"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SchemaPlayground = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = __importDefault(require("react"));
var rimble_ui_1 = require("rimble-ui");
var vc_schema_tools_1 = require("vc-schema-tools");
var styled_components_1 = __importDefault(require("styled-components"));
var react_simple_code_editor_1 = __importDefault(require("react-simple-code-editor"));
var prismjs_1 = __importDefault(require("prismjs"));
require("prismjs/components/prism-json");
var use_debounce_1 = require("use-debounce");
var layouts_1 = require("../../layouts");
var HighlightedJson_1 = require("../../elements/HighlightedJson/HighlightedJson");
var Pane = styled_components_1.default(rimble_ui_1.Flex)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  flex-direction: column;\n  width: 50%;\n  height: 94vh;\n"], ["\n  flex-direction: column;\n  width: 50%;\n  height: 94vh;\n"])));
var Section = styled_components_1.default(rimble_ui_1.Flex)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  flex-direction: column;\n  height: 50%;\n"], ["\n  flex-direction: column;\n  height: 50%;\n"])));
var SchemaPlayground = function () {
    var _a = react_1.default.useState(""), inputSchema = _a[0], setInputSchema = _a[1];
    var debouncedSchema = use_debounce_1.useDebounce(inputSchema, 500)[0];
    var _b = react_1.default.useState(), inputSchemaError = _b[0], setInputSchemaError = _b[1];
    var _c = react_1.default.useState(), vcSchema = _c[0], setVcSchema = _c[1];
    var _d = react_1.default.useState(""), inputVc = _d[0], setInputVc = _d[1];
    var debouncedVc = use_debounce_1.useDebounce(inputVc, 500)[0];
    var _e = react_1.default.useState(), inputVcValid = _e[0], setInputVcValid = _e[1];
    var _f = react_1.default.useState(), inputVcValidityMessage = _f[0], setInputVcValidityMessage = _f[1];
    var _g = react_1.default.useState(""), outputContext = _g[0], setOutputContext = _g[1];
    react_1.default.useEffect(function () {
        setInputSchemaError(undefined);
        if (!debouncedSchema) {
            setVcSchema(undefined);
            return;
        }
        try {
            setVcSchema(new vc_schema_tools_1.VcSchema(debouncedSchema, true));
        }
        catch (err) {
            setInputSchemaError(err.message);
        }
    }, [debouncedSchema]);
    react_1.default.useEffect(function () {
        setOutputContext(vcSchema ? vcSchema.getJsonLdContextString(true) : "");
    }, [vcSchema]);
    react_1.default.useEffect(function () {
        if (vcSchema && debouncedVc) {
            (function () {
                return __awaiter(this, void 0, void 0, function () {
                    var _a, isValid, message;
                    return __generator(this, function (_b) {
                        switch (_b.label) {
                            case 0: return [4 /*yield*/, vcSchema.validateVc(debouncedVc)];
                            case 1:
                                _a = _b.sent(), isValid = _a.isValid, message = _a.message;
                                setInputVcValid(isValid);
                                setInputVcValidityMessage(message);
                                return [2 /*return*/];
                        }
                    });
                });
            })();
        }
        else {
            setInputVcValid(undefined);
        }
    }, [vcSchema, debouncedVc]);
    return (jsx_runtime_1.jsxs(rimble_ui_1.Box, { children: [jsx_runtime_1.jsxs(rimble_ui_1.Text, __assign({ fontSize: 1, style: { textAlign: "center" } }, { children: ["Examples:", " ", jsx_runtime_1.jsxs("select", __assign({ onChange: function (event) {
                            var name = event.target.value;
                            if (name) {
                                setInputSchema(JSON.stringify(vc_schema_tools_1.EXAMPLE_SCHEMAS[name], null, 2));
                            }
                            if (vc_schema_tools_1.EXAMPLE_VCS[name]) {
                                setInputVc(JSON.stringify(vc_schema_tools_1.EXAMPLE_VCS[name], null, 2));
                            }
                        } }, { children: [jsx_runtime_1.jsx("option", { value: "" }, void 0),
                            Object.keys(vc_schema_tools_1.EXAMPLE_SCHEMAS).map(function (key) { return (jsx_runtime_1.jsx("option", __assign({ value: key }, { children: key }), key)); })] }), void 0)] }), void 0),
            jsx_runtime_1.jsxs(rimble_ui_1.Flex, { children: [jsx_runtime_1.jsxs(Pane, { children: [jsx_runtime_1.jsx(layouts_1.H5, __assign({ my: 2 }, { children: "JSON Schema input" }), void 0),
                            jsx_runtime_1.jsx(HighlightedJson_1.PrismHighlightedCodeWrap, __assign({ style: { background: "#fdfdfd" } }, { children: jsx_runtime_1.jsx(react_simple_code_editor_1.default, { value: inputSchema, onValueChange: setInputSchema, highlight: function () { return prismjs_1.default.highlight(inputSchema, prismjs_1.default.languages.json, "json"); }, style: { minHeight: "100%" } }, void 0) }), void 0),
                            inputSchemaError && jsx_runtime_1.jsxs(rimble_ui_1.Flash, __assign({ variant: "danger" }, { children: ["Error: ", inputSchemaError] }), void 0)] }, void 0),
                    jsx_runtime_1.jsxs(Pane, { children: [jsx_runtime_1.jsxs(Section, { children: [jsx_runtime_1.jsxs(rimble_ui_1.Flex, __assign({ justifyContent: "space-between", pr: 2 }, { children: [jsx_runtime_1.jsx(layouts_1.H5, __assign({ my: 2 }, { children: "VC input for validation" }), void 0),
                                            jsx_runtime_1.jsx(rimble_ui_1.Text, __assign({ my: 2, fontSize: 1 }, { children: "playground @context will automatically be appended" }), void 0)] }), void 0),
                                    jsx_runtime_1.jsx(HighlightedJson_1.PrismHighlightedCodeWrap, __assign({ style: { background: "#fdfdfd" } }, { children: jsx_runtime_1.jsx(react_simple_code_editor_1.default, { value: inputVc, onValueChange: setInputVc, highlight: function () { return prismjs_1.default.highlight(inputVc, prismjs_1.default.languages.json, "json"); }, style: { minHeight: "100%" } }, void 0) }), void 0),
                                    typeof inputVcValid !== "undefined" && (jsx_runtime_1.jsxs(rimble_ui_1.Flash, __assign({ variant: inputVcValid ? "success" : inputVcValid === null ? "warning" : "danger" }, { children: [jsx_runtime_1.jsx(rimble_ui_1.Text, __assign({ fontSize: 1, style: { wordBreak: "break-word", float: "left", display: "inline-block" } }, { children: inputVcValidityMessage }), void 0),
                                            jsx_runtime_1.jsx(rimble_ui_1.Tooltip, __assign({ placement: "top", message: "@context output below will be added to the VC sent to the tool" }, { children: jsx_runtime_1.jsxs(rimble_ui_1.Text, __assign({ fontSize: 1, style: { float: "right", display: "inline-block" } }, { children: ["Open in", " ", jsx_runtime_1.jsx(rimble_ui_1.Button.Outline, __assign({ size: "small", onClick: function () { return vcSchema === null || vcSchema === void 0 ? void 0 : vcSchema.openJsonLdChecker(inputVc); } }, { children: "JSON-LD Checker" }), void 0),
                                                        jsx_runtime_1.jsx(rimble_ui_1.Button.Outline, __assign({ size: "small", ml: 2, onClick: function () { return vcSchema === null || vcSchema === void 0 ? void 0 : vcSchema.openJsonLdPlaygroundPage(inputVc); } }, { children: "JSON-LD Playground" }), void 0)] }), void 0) }), void 0)] }), void 0))] }, void 0),
                            jsx_runtime_1.jsxs(Section, { children: [jsx_runtime_1.jsx(layouts_1.H5, __assign({ my: 2 }, { children: "JSON-LD @context output" }), void 0),
                                    jsx_runtime_1.jsx(HighlightedJson_1.HighlightedJson, { json: outputContext, alreadyPrettified: true }, void 0)] }, void 0)] }, void 0)] }, void 0)] }, void 0));
};
exports.SchemaPlayground = SchemaPlayground;
var templateObject_1, templateObject_2;
//# sourceMappingURL=SchemaPlayground.js.map