import * as React from "react";
import { SchemaDataInput, SchemaDataResponse } from "./types";
export declare const SCHEMA_VIEWS: readonly ["Formatted View", "JSON Schema", "JSON-LD Context"];
export declare type SchemaViewTypes = typeof SCHEMA_VIEWS[number];
export interface SchemaPreviewProps {
    schema: SchemaDataInput | SchemaDataResponse;
    view: SchemaViewTypes;
    setView(view: SchemaViewTypes): void;
    /** Whether to show "view in editor" and "issue VC" functionality. */
    hideTools?: boolean;
    /** Whether to show "issue VC" functionality. */
    hideIssueVc?: boolean;
    fullPage?: boolean;
    paneView?: boolean;
    noSwitcher?: boolean;
    rimbleProps?: {
        [prop: string]: any;
    };
}
export declare const SchemaPreview: React.FunctionComponent<SchemaPreviewProps>;
