"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SchemaPreview = exports.SCHEMA_VIEWS = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var React = __importStar(require("react"));
var linkify_react_1 = __importDefault(require("linkify-react"));
var rimble_ui_1 = require("rimble-ui");
var icons_1 = require("@rimble/icons");
var vc_schema_tools_1 = require("vc-schema-tools");
var themes_1 = require("../../../themes");
var types_1 = require("./types");
var HighlightedJson_1 = require("../../elements/HighlightedJson/HighlightedJson");
var Modals_1 = require("../../elements/Modals");
var SchemaUsage_1 = require("./SchemaUsage");
var SertoUiContext_1 = require("../../../context/SertoUiContext");
var IssueVcForm_1 = require("../Credentials/IssueVc/IssueVcForm");
var Popup_1 = require("../../elements/Popup/Popup");
var SchemaHeader_1 = require("./SchemaHeader");
var MetadataText = function (props) { return (jsx_runtime_1.jsx(rimble_ui_1.Text, __assign({ color: themes_1.colors.silver, my: 2 }, props, { children: props.children }), void 0)); };
var PropertyText = function (props) { return (jsx_runtime_1.jsx(rimble_ui_1.Text, __assign({ color: themes_1.colors.silver, fontSize: 1, my: 1 }, props, { children: props.children }), void 0)); };
var PropertyRequired = function (props) { return (jsx_runtime_1.jsx(PropertyText, __assign({ fontWeight: 3 }, { children: props.children }), void 0)); };
var PropertyType = function (props) { return (jsx_runtime_1.jsx(PropertyText, __assign({ color: themes_1.baseColors.black, fontSize: 2, mb: 0, maxWidth: "75%", style: { wordBreak: "break-all" } }, props, { children: props.children }), void 0)); };
var PropertyName = function (props) { return jsx_runtime_1.jsx(PropertyType, __assign({ fontWeight: 3 }, { children: props.children }), void 0); };
var renderProperty = function (key, prop, required) {
    if (!prop) {
        console.warn("Could not find prop for key:", key);
        return jsx_runtime_1.jsx(jsx_runtime_1.Fragment, {}, void 0);
    }
    var propType;
    if (prop.type === "object") {
        // Looks nicer with blank type name - nested object will be displayed underneath
        propType = "";
    }
    else {
        propType = vc_schema_tools_1.nodeToTypeName(prop);
        if (!propType) {
            propType = "[unknown]";
            console.warn("Unrecognized property:", { key: key, prop: prop });
        }
    }
    return (jsx_runtime_1.jsxs(rimble_ui_1.Box, __assign({ my: 3 }, { children: [jsx_runtime_1.jsxs(rimble_ui_1.Flex, __assign({ justifyContent: "space-between" }, { children: [jsx_runtime_1.jsx(PropertyName, { children: prop.title || key }, void 0),
                    jsx_runtime_1.jsx(PropertyType, { children: propType }, void 0)] }), void 0),
            prop.description && jsx_runtime_1.jsx(PropertyText, { children: prop.description }, void 0),
            required && jsx_runtime_1.jsx(PropertyRequired, { children: "Required" }, void 0),
            prop.properties && (jsx_runtime_1.jsx(rimble_ui_1.Box, __assign({ pl: 3, mt: 3 }, { children: Object.entries(prop.properties).map(function (entry) { var _a; return renderProperty(entry[0], entry[1], (_a = prop.required) === null || _a === void 0 ? void 0 : _a.includes(entry[0])); }) }), void 0))] }), key));
};
exports.SCHEMA_VIEWS = ["Formatted View", "JSON Schema", "JSON-LD Context"];
var SchemaPreview = function (props) {
    var _a, _b;
    var schema = props.schema, view = props.view, setView = props.setView, hideTools = props.hideTools, hideIssueVc = props.hideIssueVc, fullPage = props.fullPage, paneView = props.paneView, noSwitcher = props.noSwitcher, rimbleProps = props.rimbleProps;
    var _c = React.useState(""), error = _c[0], setError = _c[1];
    var _d = React.useState(false), isUseModalOpen = _d[0], setIsUseModalOpen = _d[1];
    var context = React.useContext(SertoUiContext_1.SertoUiContext);
    var userOwnsSchema = "creator" in schema && ((_a = context.schemasService.userData) === null || _a === void 0 ? void 0 : _a.sub) === ((_b = schema.creator) === null || _b === void 0 ? void 0 : _b.identifier);
    var schemaInstance = React.useMemo(function () {
        try {
            setError("");
            return new vc_schema_tools_1.VcSchema(schema.jsonSchema);
        }
        catch (err) {
            console.error("Failed to generate schema instance:", err);
            setError(err.message || JSON.stringify(err));
        }
    }, [schema]);
    var jsons = React.useMemo(function () {
        var _a;
        if (!schemaInstance) {
            return {};
        }
        var jsonLdContextString;
        if (schema.ldContextPlus) {
            // old format with manually created LD context, so use that:
            jsonLdContextString = schema.ldContext;
        }
        else {
            // new format, with manually created JSON Schema and schema instance will have generated JSON LD context from that:
            jsonLdContextString = schemaInstance === null || schemaInstance === void 0 ? void 0 : schemaInstance.getJsonLdContextString(true);
        }
        return _a = {},
            _a[exports.SCHEMA_VIEWS[1]] = schemaInstance === null || schemaInstance === void 0 ? void 0 : schemaInstance.getJsonSchemaString(true),
            _a[exports.SCHEMA_VIEWS[2]] = jsonLdContextString,
            _a;
    }, [schemaInstance, schema.ldContext, schema.ldContextPlus]);
    var credentialSubject = React.useMemo(function () {
        var _a, _b;
        var credentialSubject = (_b = (_a = schemaInstance === null || schemaInstance === void 0 ? void 0 : schemaInstance.jsonSchema) === null || _a === void 0 ? void 0 : _a.properties) === null || _b === void 0 ? void 0 : _b.credentialSubject;
        if (!credentialSubject) {
            console.error("Invalid schema format: could not find `credentialSubject`");
        }
        return credentialSubject;
    }, [schemaInstance]);
    return (jsx_runtime_1.jsxs(rimble_ui_1.Box, __assign({}, rimbleProps, { children: [jsx_runtime_1.jsxs(rimble_ui_1.Flex, __assign({ mb: noSwitcher && hideTools ? 0 : 3, justifyContent: "space-between" }, { children: [jsx_runtime_1.jsxs(rimble_ui_1.Box, { children: [!noSwitcher && (jsx_runtime_1.jsx(Popup_1.Popup, __assign({ rimbleProps: { display: "inline-block", verticalAlign: "text-bottom" }, triggerOnClick: true, popupContents: jsx_runtime_1.jsx(Popup_1.PopupGroup, { children: exports.SCHEMA_VIEWS.map(function (viewName) { return (jsx_runtime_1.jsx("a", __assign({ onClick: function () { return setView(viewName); }, className: view === viewName ? "selected" : "" }, { children: viewName }), viewName)); }) }, void 0) }, { children: jsx_runtime_1.jsx(jsx_runtime_1.Fragment, { children: jsx_runtime_1.jsxs(rimble_ui_1.Button.Outline, __assign({ size: "small" }, { children: [view, " ", jsx_runtime_1.jsx(icons_1.KeyboardArrowDown, { ml: 3, mr: "-5px", size: "16px" }, void 0)] }), void 0) }, void 0) }), void 0)),
                            !hideTools && context.schemasUiUrl && (jsx_runtime_1.jsx(rimble_ui_1.Button.Outline, __assign({ as: "a", href: context.schemasUiUrl + "/editor/" + schema.slug, target: window.location.origin === context.schemasUiUrl ? undefined : "_blank", icon: "Edit", size: "small", ml: 3 }, { children: userOwnsSchema ? "Edit Schema" : "View in Schema Editor" }), void 0))] }, void 0),
                    !hideTools &&
                        !hideIssueVc &&
                        (context.issueVc ? (jsx_runtime_1.jsxs(rimble_ui_1.Button, __assign({ size: "small", onClick: function () { return setIsUseModalOpen(true); } }, { children: [jsx_runtime_1.jsx(icons_1.Send, { size: "15px", mr: 2 }, void 0), " Issue VC"] }), void 0)) : (jsx_runtime_1.jsx(Popup_1.Popup, __assign({ triggerOnClick: true, remainOpenOnClick: true, popupContents: jsx_runtime_1.jsx(SchemaUsage_1.SchemaUsage, { schema: schema }, void 0), popupRimbleProps: { width: "350px" }, popupRightPos: -2 }, { children: jsx_runtime_1.jsxs(rimble_ui_1.Button, __assign({ size: "small" }, { children: ["Use this VC Schema", jsx_runtime_1.jsx(icons_1.KeyboardArrowDown, { ml: 2, mr: "-5px", size: "16px" }, void 0)] }), void 0) }), void 0)))] }), void 0),
            view === "Formatted View" ? (jsx_runtime_1.jsxs(rimble_ui_1.Box, __assign({ className: "schema-formatted-preview", width: hideTools || hideIssueVc ? 9 : "640px", maxWidth: "100%", px: 4, py: 3, border: 1, borderRadius: 1, fontFamily: themes_1.fonts.sansSerif }, { children: [paneView && jsx_runtime_1.jsx(SchemaHeader_1.SchemaHeader, { schema: schema, rimbleProps: { mb: 4 } }, void 0),
                    !fullPage && jsx_runtime_1.jsx(MetadataText, __assign({ fontFamily: themes_1.fonts.monospace }, { children: schema.slug }), void 0),
                    jsx_runtime_1.jsxs(MetadataText, { children: ["Version ", schema.version] }, void 0),
                    jsx_runtime_1.jsxs(MetadataText, { children: [!schema.discoverable && "Not ", "Searchable"] }, void 0),
                    !fullPage && schema.description && (jsx_runtime_1.jsx(MetadataText, { children: jsx_runtime_1.jsx(linkify_react_1.default, __assign({ options: { target: "_blank" } }, { children: schema.description }), void 0) }, void 0)),
                    types_1.defaultSchemaProperties.map(function (prop, i) {
                        return renderProperty(prop.$linkedData.term, prop, types_1.defaultSchemaPropertiesRequired[i]);
                    }),
                    (credentialSubject === null || credentialSubject === void 0 ? void 0 : credentialSubject.properties) &&
                        Object.entries(credentialSubject.properties).map(function (entry) { var _a; return renderProperty(entry[0], entry[1], (_a = credentialSubject.required) === null || _a === void 0 ? void 0 : _a.includes(entry[0])); }),
                    error && jsx_runtime_1.jsxs(rimble_ui_1.Flash, __assign({ variant: "danger" }, { children: ["Error: ", error] }), void 0)] }), void 0)) : (jsx_runtime_1.jsxs(jsx_runtime_1.Fragment, { children: [view === "JSON-LD Context" && (jsx_runtime_1.jsxs(rimble_ui_1.Text, __assign({ mb: 3 }, { children: ["To be used on top of", " ", jsx_runtime_1.jsx("a", __assign({ href: "https://www.w3.org/2018/credentials/v1", rel: "noopener noreferrer", target: "_blank" }, { children: "the base W3C credential context" }), void 0), "."] }), void 0)),
                    jsx_runtime_1.jsx(HighlightedJson_1.HighlightedJson, { json: jsons[view] || schema }, void 0)] }, void 0)),
            jsx_runtime_1.jsx(Modals_1.ModalWithX, __assign({ isOpen: isUseModalOpen, close: function () { return setIsUseModalOpen(false); }, width: 9 }, { children: jsx_runtime_1.jsx(IssueVcForm_1.IssueVcForm, { schema: schema, onComplete: function () { return setIsUseModalOpen(false); } }, void 0) }), void 0)] }), void 0));
};
exports.SchemaPreview = SchemaPreview;
//# sourceMappingURL=SchemaPreview.js.map