"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SchemaUsage = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var styled_components_1 = __importDefault(require("styled-components"));
var rimble_ui_1 = require("rimble-ui");
var icons_1 = require("@rimble/icons");
var LayoutComponents_1 = require("../../layouts/LayoutComponents");
var themes_1 = require("../../../themes");
var CopyableTruncatableText_1 = require("../../elements/CopyableTruncatableText/CopyableTruncatableText");
var HighlightedJson_1 = require("../../elements/HighlightedJson/HighlightedJson");
var Tabs_1 = require("../../layouts/Tabs/Tabs");
var Modals_1 = require("../../elements/Modals");
var Popup_1 = require("../../elements/Popup/Popup");
var utils_1 = require("./utils");
var config_1 = require("../../../config");
var StyledTabs = styled_components_1.default(Tabs_1.Tabs)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  li:first-child {\n    margin-left: 0;\n  }\n  li:last-child {\n    margin-right: 0;\n  }\n"], ["\n  li:first-child {\n    margin-left: 0;\n  }\n  li:last-child {\n    margin-right: 0;\n  }\n"])));
var StyledLink = function (props) { return jsx_runtime_1.jsx(rimble_ui_1.Link, __assign({ fontSize: 2, fontWeight: 2 }, props), void 0); };
var SchemaUsage = function (props) {
    var schema = props.schema;
    var _a = react_1.useState("jsonLd"), urlTab = _a[0], setUrlTab = _a[1];
    var _b = react_1.useState("sertoAgent"), issueTab = _b[0], setIssueTab = _b[1];
    var _c = react_1.useState(false), infoModalOpen = _c[0], setInfoModalOpen = _c[1];
    var _d = react_1.useState(false), exampleVcModalOpen = _d[0], setExampleVcModalOpen = _d[1];
    var uris = utils_1.getSchemaUris(schema);
    var _e = utils_1.getLdTypesFromSchemaResponse(schema), subjectLdType = _e.subjectLdType, credLdType = _e.credLdType;
    // @TODO/tobek Need a more elegant way to do this, probably VcSchema library should have a utility that creates an example VC that actually has all the fields filled in based on schema.
    var exampleVc = __assign(__assign({ "@context": __spreadArrays(["https://www.w3.org/2018/credentials/v1"], ((uris === null || uris === void 0 ? void 0 : uris.jsonLdContext) ? [uris.jsonLdContext] : [])) }, ((uris === null || uris === void 0 ? void 0 : uris.jsonSchema) && {
        credentialSchema: {
            id: uris.jsonSchema,
            type: "JsonSchemaValidator2018",
        },
    })), { type: __spreadArrays(["VerifiableCredential"], (credLdType ? [credLdType] : [])), issuer: "[ISSUER]", issuanceDate: "[DATE]", credentialSubject: __assign(__assign({}, (subjectLdType ? { type: subjectLdType } : {})), { id: "[SUBJECT]", "...": "..." }) });
    return (jsx_runtime_1.jsxs(rimble_ui_1.Box, __assign({ fontFamily: themes_1.fonts.sansSerif, style: props.style }, { children: [jsx_runtime_1.jsxs(Popup_1.PopupGroup, { children: [jsx_runtime_1.jsx(LayoutComponents_1.H5, __assign({ mt: 1, mb: 2 }, { children: jsx_runtime_1.jsxs(rimble_ui_1.Flex, __assign({ alignItems: "center" }, { children: [jsx_runtime_1.jsx(icons_1.LinkIcon, { size: "20px" }, void 0),
                                jsx_runtime_1.jsx(rimble_ui_1.Box, __assign({ ml: 1 }, { children: "Schema URLs" }), void 0)] }), void 0) }), void 0),
                    jsx_runtime_1.jsx(StyledTabs, { activeTabName: urlTab, onTabClicked: function (tabName) { return setUrlTab(tabName); }, titleFontSize: 1, tabs: [
                            {
                                tabName: "jsonLd",
                                title: "JSON-LD Context",
                                content: (jsx_runtime_1.jsxs(rimble_ui_1.Box, __assign({ mt: 3, mb: 2 }, { children: [jsx_runtime_1.jsx(CopyableTruncatableText_1.CopyableTruncatableText, { fontFamily: themes_1.fonts.monospace, fontSize: 0, size: "20px", fontWeight: 2, text: (uris === null || uris === void 0 ? void 0 : uris.jsonLdContext) || "[none]", linkOutHref: !!(uris === null || uris === void 0 ? void 0 : uris.jsonLdContext) }, void 0),
                                        jsx_runtime_1.jsx(StyledLink, __assign({ display: "inline-block", fontSize: 0, mt: 2, onClick: function () { return setInfoModalOpen(true); } }, { children: "Learn more about JSON-LD Context" }), void 0)] }), void 0)),
                            },
                            {
                                tabName: "jsonSchema",
                                title: "JSON Schema",
                                content: (jsx_runtime_1.jsxs(rimble_ui_1.Box, __assign({ mt: 3, mb: 2 }, { children: [jsx_runtime_1.jsx(CopyableTruncatableText_1.CopyableTruncatableText, { fontFamily: themes_1.fonts.monospace, fontSize: 0, size: "20px", fontWeight: 2, text: (uris === null || uris === void 0 ? void 0 : uris.jsonSchema) || "[none]", linkOutHref: !!(uris === null || uris === void 0 ? void 0 : uris.jsonSchema) }, void 0),
                                        jsx_runtime_1.jsx(StyledLink, __assign({ display: "inline-block", fontSize: 0, mt: 2, onClick: function () { return setInfoModalOpen(true); } }, { children: "Learn more about JSON Schema" }), void 0)] }), void 0)),
                            },
                        ] }, void 0)] }, void 0),
            jsx_runtime_1.jsxs(Popup_1.PopupGroup, { children: [jsx_runtime_1.jsx(LayoutComponents_1.H5, __assign({ mt: 1, mb: 2 }, { children: jsx_runtime_1.jsxs(rimble_ui_1.Flex, __assign({ alignItems: "center" }, { children: [jsx_runtime_1.jsx(icons_1.Send, { size: "18px" }, void 0),
                                jsx_runtime_1.jsx(rimble_ui_1.Box, __assign({ ml: 1 }, { children: "Issue Verifiable Credentials" }), void 0)] }), void 0) }), void 0),
                    jsx_runtime_1.jsx(StyledTabs, { activeTabName: issueTab, onTabClicked: function (tabName) { return setIssueTab(tabName); }, titleFontSize: 1, tabs: [
                            {
                                tabName: "sertoAgent",
                                title: "Use Serto Agent",
                                content: (jsx_runtime_1.jsxs(rimble_ui_1.Box, __assign({ mt: 3, mb: 2 }, { children: [jsx_runtime_1.jsx(rimble_ui_1.Text, __assign({ fontSize: 0, my: 2 }, { children: "Use Serto Agent, our user-friendly admin tool, to issue VCs." }), void 0),
                                        jsx_runtime_1.jsxs(rimble_ui_1.Button.Outline, __assign({ as: "a", size: "small", width: "100%", href: config_1.links.SUITE, target: "_blank" }, { children: [jsx_runtime_1.jsx(icons_1.Send, { size: "15px", mr: 2 }, void 0), "Issue VC with Serto Agent"] }), void 0)] }), void 0)),
                            },
                            {
                                tabName: "manual",
                                title: "Manually",
                                content: (jsx_runtime_1.jsxs(rimble_ui_1.Box, __assign({ mt: 3, mb: 2 }, { children: [jsx_runtime_1.jsxs(rimble_ui_1.Text, __assign({ fontSize: 0, my: 2 }, { children: ["Use your own agent, like", " ", jsx_runtime_1.jsx(StyledLink, __assign({ fontSize: 0, href: "https://veramo.io/", target: "_blank" }, { children: "Veramo" }), void 0), ", to issue VCs manually."] }), void 0),
                                        jsx_runtime_1.jsx(rimble_ui_1.Button.Outline, __assign({ size: "small", width: "100%", onClick: function () { return setExampleVcModalOpen(true); } }, { children: "View example VC for this schema" }), void 0)] }), void 0)),
                            },
                        ] }, void 0)] }, void 0),
            jsx_runtime_1.jsx(Modals_1.ModalWithX, __assign({ isOpen: infoModalOpen, close: function () { return setInfoModalOpen(false); }, width: 9 }, { children: jsx_runtime_1.jsxs(Modals_1.ModalContent, __assign({ onClick: function (e) { return e.stopPropagation(); } }, { children: [jsx_runtime_1.jsxs(rimble_ui_1.Text, __assign({ my: 3 }, { children: [jsx_runtime_1.jsx("b", { children: "JSON-LD contexts" }, void 0), " (", jsx_runtime_1.jsx(StyledLink, __assign({ href: "https://w3c.github.io/json-ld-syntax/#the-context", target: "_blank" }, { children: "specification" }), void 0), ") are JSON data that define data relationships and semantics, and can leverage property and entity types on schema repositories such as", " ", jsx_runtime_1.jsx(StyledLink, __assign({ href: "https://schema.org", target: "_Blank" }, { children: "schema.org" }), void 0), "."] }), void 0),
                        jsx_runtime_1.jsxs(rimble_ui_1.Text, __assign({ my: 3 }, { children: ["For more details on using JSON-LD contexts in VCs, see", " ", jsx_runtime_1.jsx(StyledLink, __assign({ href: "https://www.w3.org/TR/vc-data-model/#contexts", target: "_blank" }, { children: "the contexts section of the VC spec" }), void 0), "."] }), void 0),
                        jsx_runtime_1.jsxs(rimble_ui_1.Text, __assign({ my: 3 }, { children: [jsx_runtime_1.jsx("b", { children: "JSON Schema" }, void 0), " (", jsx_runtime_1.jsx(StyledLink, __assign({ href: "https://json-schema.org/", target: "_blank" }, { children: "specification" }), void 0), ") schemas are also JSON data, but define data structure, requirements, descriptions and other metadata, thereby supporting validation of VCs to ensure conformance."] }), void 0),
                        jsx_runtime_1.jsxs(rimble_ui_1.Text, __assign({ my: 3 }, { children: ["For more details on using JSON Schemas in VCs, see", " ", jsx_runtime_1.jsxs(StyledLink, __assign({ href: "https://www.w3.org/TR/vc-data-model/#data-schemas", target: "_blank" }, { children: ["the ", jsx_runtime_1.jsx("code", { children: "credentialSchema" }, void 0), " field in the VC spec"] }), void 0), "."] }), void 0),
                        jsx_runtime_1.jsx(rimble_ui_1.Text, { my: 3 }, void 0)] }), void 0) }), void 0),
            jsx_runtime_1.jsx(Modals_1.ModalWithX, __assign({ isOpen: exampleVcModalOpen, close: function () { return setExampleVcModalOpen(false); }, width: 10 }, { children: jsx_runtime_1.jsx(Modals_1.ModalContent, __assign({ onClick: function (e) { return e.stopPropagation(); } }, { children: jsx_runtime_1.jsx(HighlightedJson_1.HighlightedJson, { json: exampleVc }, void 0) }), void 0) }), void 0)] }), void 0));
};
exports.SchemaUsage = SchemaUsage;
var templateObject_1;
//# sourceMappingURL=SchemaUsage.js.map