"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SchemasTable = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var React = __importStar(require("react"));
var react_router_dom_1 = require("react-router-dom");
var rimble_ui_1 = require("rimble-ui");
var swr_1 = __importDefault(require("swr"));
var themes_1 = require("../../../themes");
var LayoutComponents_1 = require("../../layouts/LayoutComponents");
var SertoUiContext_1 = require("../../../context/SertoUiContext");
var ViewSchemaButton_1 = require("./ViewSchemaButton");
var SchemasTable = function (props) {
    var context = React.useContext(SertoUiContext_1.SertoUiContext);
    var _a = swr_1.default(["getSchemas", !props.discover], function () {
        return context.schemasService.getSchemas(!props.discover);
    }), data = _a.data, error = _a.error, isValidating = _a.isValidating;
    var sortedData = React.useMemo(function () { return data === null || data === void 0 ? void 0 : data.sort(function (schema1, schema2) { return (schema1.updated < schema2.updated ? 1 : -1); }); }, [data]);
    if (sortedData === null || sortedData === void 0 ? void 0 : sortedData.length) {
        return (jsx_runtime_1.jsx(jsx_runtime_1.Fragment, { children: jsx_runtime_1.jsxs(rimble_ui_1.Table, __assign({ border: 0, boxShadow: 0, width: "100%" }, { children: [jsx_runtime_1.jsx("thead", { children: jsx_runtime_1.jsxs(LayoutComponents_1.TR, { children: [jsx_runtime_1.jsx(LayoutComponents_1.TH, {}, void 0),
                                jsx_runtime_1.jsx(LayoutComponents_1.TH, { children: "Name" }, void 0),
                                jsx_runtime_1.jsx(LayoutComponents_1.TH, { children: "Slug" }, void 0),
                                jsx_runtime_1.jsx(LayoutComponents_1.TH, { children: "Version" }, void 0),
                                !props.discover && jsx_runtime_1.jsx(LayoutComponents_1.TH, { children: "Discoverable" }, void 0),
                                jsx_runtime_1.jsx(LayoutComponents_1.TH, { children: "Created" }, void 0),
                                jsx_runtime_1.jsx(LayoutComponents_1.TH, {}, void 0),
                                props.onSchemaSelect && jsx_runtime_1.jsx(LayoutComponents_1.TH, {}, void 0)] }, void 0) }, void 0),
                    jsx_runtime_1.jsx(LayoutComponents_1.TBody, { children: sortedData.map(function (schema, i) {
                            return (jsx_runtime_1.jsxs(LayoutComponents_1.TR, { children: [jsx_runtime_1.jsx("td", __assign({ style: { maxWidth: 32 } }, { children: schema.icon }), void 0),
                                    jsx_runtime_1.jsx("td", __assign({ style: { fontWeight: 600 } }, { children: schema.name }), void 0),
                                    jsx_runtime_1.jsx("td", { children: schema.slug }, void 0),
                                    jsx_runtime_1.jsx("td", { children: schema.version }, void 0),
                                    !props.discover && jsx_runtime_1.jsx("td", { children: (!!schema.discoverable).toString() }, void 0),
                                    jsx_runtime_1.jsx("td", { children: schema.created && (jsx_runtime_1.jsx("time", __assign({ title: schema.created, dateTime: schema.created }, { children: new Date(schema.created).toDateString() }), void 0)) }, void 0),
                                    jsx_runtime_1.jsxs("td", __assign({ style: { whiteSpace: "nowrap" } }, { children: [jsx_runtime_1.jsx(ViewSchemaButton_1.ViewSchemaButton, { schema: schema, hideIssueVcInDetail: props.hideIssueVcInDetail }, void 0),
                                            !props.discover && !props.onSchemaSelect && (jsx_runtime_1.jsx(rimble_ui_1.Button.Outline, __assign({ as: "a", href: context.schemasUiUrl + "/editor/" + schema.slug, target: window.location.origin === context.schemasUiUrl ? undefined : "_blank", ml: 3, size: "small" }, { children: "Update" }), void 0))] }), void 0),
                                    props.onSchemaSelect && (jsx_runtime_1.jsx("td", { children: jsx_runtime_1.jsx(rimble_ui_1.Button.Outline, __assign({ size: "small", onClick: function () { var _a; return (_a = props.onSchemaSelect) === null || _a === void 0 ? void 0 : _a.call(props, schema); } }, { children: "Select" }), void 0) }, void 0))] }, i));
                        }) }, void 0)] }), void 0) }, void 0));
    }
    else if (error) {
        return (jsx_runtime_1.jsxs(rimble_ui_1.Flash, __assign({ my: 3, variant: "danger" }, { children: ["Error loading schemas: ", error.toString()] }), void 0));
    }
    else if (isValidating) {
        return (jsx_runtime_1.jsx(rimble_ui_1.Flex, __assign({ minHeight: 8, alignItems: "center", justifyContent: "center" }, { children: jsx_runtime_1.jsx(rimble_ui_1.Loader, { color: themes_1.colors.primary.base, size: 5 }, void 0) }), void 0));
    }
    else {
        return (props.noSchemasElement || (jsx_runtime_1.jsxs(rimble_ui_1.Text.p, __assign({ display: "block", fontSize: 1, py: 2, lineHeight: "copy" }, { children: [jsx_runtime_1.jsxs("b", __assign({ style: { display: "block", fontWeight: 600 } }, { children: [props.discover ? "There are" : "You have", " no credential schemas yet."] }), void 0), "Please first ", jsx_runtime_1.jsx(react_router_dom_1.Link, __assign({ to: context.schemasService.createSchemaPath }, { children: "create a credential schema" }), void 0), " in order to coordinate around verified data with your customers and partners."] }), void 0)));
    }
};
exports.SchemasTable = SchemasTable;
//# sourceMappingURL=SchemasTable.js.map