"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.mergeServerConfig = exports.links = exports.config = exports.DEV_ENV = void 0;
exports.DEV_ENV = "development";
var ENVIRONMENT = process.env.NODE_ENV || exports.DEV_ENV;
var domain = window.location.hostname;
exports.config = {
    ENVIRONMENT: ENVIRONMENT,
    IS_DEV: ENVIRONMENT === exports.DEV_ENV,
    FEATURE_FLAGS: process.env.REACT_APP_FEATURE_FLAGS,
    SEARCH_API_URL: "http://staging.api.search.serto.id",
    SEARCH_UI_URL: "http://staging.search.serto.id",
    SCHEMAS_API_URL: "https://staging.api.schemas.serto.id",
    SCHEMAS_UI_URL: "https://staging.schemas.serto.id",
};
if (window.location.protocol.includes("https")) {
    // staging search doesn't have https, so we gotta use beta or else requests will fail
    exports.config = __assign(__assign({}, exports.config), { SEARCH_API_URL: "https://beta.api.search.serto.id", SEARCH_UI_URL: "https://beta.search.serto.id" });
}
if (ENVIRONMENT !== "development") {
    if (domain.includes("serto.id") && domain.includes("staging")) {
        // config above is right
    }
    else if (domain.includes("serto.id") && domain.includes("beta")) {
        exports.config = __assign(__assign({}, exports.config), { SEARCH_API_URL: "https://beta.api.search.serto.id", SEARCH_UI_URL: "https://beta.search.serto.id", SCHEMAS_API_URL: "https://beta.api.schemas.serto.id", SCHEMAS_UI_URL: "https://beta.schemas.serto.id" });
    }
    else {
        // prod
        exports.config = __assign(__assign({}, exports.config), { SEARCH_API_URL: "https://beta.api.search.serto.id", SEARCH_UI_URL: "https://search.serto.id", SCHEMAS_API_URL: "https://beta.api.schemas.serto.id", SCHEMAS_UI_URL: "https://schemas.serto.id" });
    }
}
exports.links = {
    CONTACT: "https://www.serto.id/about#contact-section",
    SUITE: "https://www.serto.id/products",
    SCHEMAS_FEEDBACK: "https://forms.gle/tGLwuYTc1VkKFmhs6",
    SCHEMAS_PLAYGROUND: exports.config.SCHEMAS_UI_URL + "/playground",
    CREATE_SCHEMA_PATH: "/schemas/",
};
function mergeServerConfig(defaultConfig) {
    var serverConfigString = window.SERVER_CONFIG;
    var serverConfig;
    if (serverConfigString && serverConfigString !== "$ENVIRONMENT") {
        try {
            serverConfig = JSON.parse(serverConfigString);
        }
        catch (e) {
            console.error("error parsing server config: ", { serverConfigString: serverConfigString, defaultConfig: defaultConfig, e: e });
        }
    }
    var config = __assign(__assign({}, defaultConfig), serverConfig);
    console.log("config loaded", { config: config, defaultConfig: defaultConfig, serverConfig: serverConfig });
    return config;
}
exports.mergeServerConfig = mergeServerConfig;
//# sourceMappingURL=config.js.map