import * as React from "react";
import { SertoSchemasService } from "../services/SertoSchemasService";
import { SertoSearchService } from "../services/SertoSearchService";
import { NavItemProps } from "../components/layouts/Global/Nav";
import { Identifier, VeramoIssueVcOptions } from "../types";
export declare enum RENDER_CONTEXT {
    AGENT = 0,
    SCHEMAS = 1,
    SEARCH = 2,
    VC_EMBED = 3
}
export interface ToastInterface {
    addMessage(message: string, options: {
        colorTheme?: string;
        variant?: string;
        [key: string]: any;
    }): void;
    [key: string]: any;
}
export interface SertoUiContextInterface {
    toastProvider: ToastInterface;
    navItems?: NavItemProps[];
    renderContext?: RENDER_CONTEXT;
    schemasService: Omit<SertoSchemasService, "url" | "request" | "ensureAuthenticated">;
    schemasUiUrl?: string;
    searchService: Omit<SertoSearchService, "url" | "request">;
    userDids?: Identifier[];
    issueVc?(vc: any, options: VeramoIssueVcOptions): Promise<any>;
    sendVc?(from: string, to: string, vc: {
        [key: string]: any;
    }): Promise<any>;
}
export declare const defaultSertoUiContext: SertoUiContextInterface;
export declare const SertoUiContext: React.Context<SertoUiContextInterface>;
