import * as React from "react";
import { SertoUiContextInterface, ToastInterface } from "./SertoUiContext";
import { JwtUserData } from "../types";
declare global {
    interface Window {
        toastProvider: ToastInterface;
    }
}
declare type DeepPartial<T> = {
    [P in keyof T]?: DeepPartial<T[P]>;
};
export interface SertoUiContextProviderProps {
    schemasApiUrl?: string;
    schemasApiJwt?: string;
    schemasApiUserData?: JwtUserData;
    searchApiUrl?: string;
    theme?: any;
    context?: DeepPartial<SertoUiContextInterface>;
}
export declare const SertoUiProvider: React.FunctionComponent<SertoUiContextProviderProps>;
export {};
