"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SertoUiProvider = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var rimble_ui_1 = require("rimble-ui");
var IdentityTheme_1 = require("../themes/IdentityTheme");
var SertoUiContext_1 = require("./SertoUiContext");
var SertoSearchService_1 = require("../services/SertoSearchService");
var SertoSchemasService_1 = require("../services/SertoSchemasService");
var SertoUiProvider = function (props) {
    var _a, _b;
    // We want to merge props.context.schemasService into the default SertoSchemasService, but can't use the spread operator cause it will ignore the prototype properties of SertoSchemasService. So instead instantiate the class and then apply any overrides from props:
    var schemasService = new SertoSchemasService_1.SertoSchemasService(props.schemasApiUrl, props.schemasApiJwt, props.schemasApiUserData);
    Object.keys(((_a = props.context) === null || _a === void 0 ? void 0 : _a.schemasService) || {}).forEach(function (key) {
        var _a;
        // "as any" cause TypeScript doesn't like indexing a class instance with an arbitrary string, and `Object.keys` doesn't seem to preserve types.
        schemasService[key] = ((_a = props.context) === null || _a === void 0 ? void 0 : _a.schemasService)[key];
    });
    var searchService = new SertoSearchService_1.SertoSearchService(props.searchApiUrl);
    Object.keys(((_b = props.context) === null || _b === void 0 ? void 0 : _b.searchService) || {}).forEach(function (key) {
        var _a;
        searchService[key] = ((_a = props.context) === null || _a === void 0 ? void 0 : _a.searchService)[key];
    });
    var context = __assign(__assign(__assign({}, SertoUiContext_1.defaultSertoUiContext), props.context), { schemasService: schemasService,
        searchService: searchService, toastProvider: window.toastProvider });
    return (jsx_runtime_1.jsx(SertoUiContext_1.SertoUiContext.Provider, __assign({ value: context }, { children: jsx_runtime_1.jsxs(IdentityTheme_1.IdentityThemeProvider, __assign({ theme: props.theme }, { children: [props.children, jsx_runtime_1.jsx(rimble_ui_1.ToastMessage.Provider, { ref: function (node) { return (window.toastProvider = node); } }, void 0)] }), void 0) }), void 0));
};
exports.SertoUiProvider = SertoUiProvider;
//# sourceMappingURL=SertoUiProvider.js.map