import { SchemaDataInput, SchemaDataResponse } from "../components/views/Schemas/types";
import { JwtUserData } from "../types";
export declare class SertoSchemasService {
    private url;
    private jwt?;
    userData?: JwtUserData;
    isAuthenticated?: boolean;
    /** Path (or URL) to send user to in order for them to create a schema. */
    createSchemaPath: string;
    constructor(url?: string, jwt?: string, userData?: JwtUserData, createSchemaPath?: string);
    /** Build URL at which a given schema will be hosted. */
    buildSchemaUrl: (slug: string, type: string, version?: string | undefined) => string;
    getSchemas(userCreated?: boolean): Promise<SchemaDataResponse[]>;
    getSchema(slug: string): Promise<SchemaDataResponse>;
    createSchema(schema: SchemaDataInput): Promise<any>;
    updateSchema(schema: SchemaDataInput): Promise<any>;
    toggleSaveSchema(slug: string): Promise<any>;
    private request;
    private ensureAuthenticated;
}
export declare const mockSertoSchemasService: {
    createSchemaPath: string;
    buildSchemaUrl: (slug: string, type: string, version?: string | undefined) => string;
    createSchema: (...args: any[]) => Promise<any>;
    updateSchema: (...args: any[]) => Promise<any>;
    getSchemas: (...args: any[]) => Promise<any>;
    getSchema: (...args: any[]) => Promise<any>;
    toggleSaveSchema: (...args: any[]) => Promise<any>;
};
