"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.mockSertoSchemasService = exports.SertoSchemasService = void 0;
var config_1 = require("../config");
var helpers_1 = require("../utils/helpers");
// @TODO/toby Temp dummy data for demoing, sorry
var DUMMY_SCHEMA_SAVES = {
    "serto-organization-profile": 3,
    "serto-team-member": 5,
    "consen-sys-employee": 3,
    "twitter-verify": 2,
    "consen-sys-retreat-2021": 4,
    "consen-sys-mesh-portfolio-company": 1,
    "consen-sys-hackathon-2021-participant": 3,
    "vaccination-certificate": 8,
    "immunoglobulin-detection-test-card": 4,
    "diploma-credential": 3,
    "tachyon-portfolio-company": 1,
};
var SertoSchemasService = /** @class */ (function () {
    function SertoSchemasService(url, jwt, userData, createSchemaPath) {
        var _this = this;
        /** Build URL at which a given schema will be hosted. */
        this.buildSchemaUrl = function (slug, type, version) {
            return _this.url + "/v1/public/" + slug + (version && "/" + version) + "/" + type + ".json";
        };
        this.url = url || config_1.config.SCHEMAS_API_URL;
        this.jwt = jwt;
        this.userData = userData;
        this.isAuthenticated = !!(jwt && userData);
        this.createSchemaPath = createSchemaPath || config_1.links.CREATE_SCHEMA_PATH;
    }
    SertoSchemasService.prototype.getSchemas = function (userCreated) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var schemas;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this.request("/v1/" + (userCreated ? "currentUser" : ""), "GET", undefined, userCreated)];
                    case 1:
                        schemas = _b.sent();
                        // @TODO/tobek This handles API bug where sometimes there is a wrapper object with schema inside `schema` property - remove when fixed.
                        if ((_a = schemas === null || schemas === void 0 ? void 0 : schemas[0]) === null || _a === void 0 ? void 0 : _a.schema) {
                            schemas = schemas.map(function (schema) { return schema.schema; });
                        }
                        schemas.forEach(function (schema) {
                            schema.favoriteCount = (schema.favoriteCount || 0) + (DUMMY_SCHEMA_SAVES[schema.slug] || 0);
                        });
                        return [2 /*return*/, schemas];
                }
            });
        });
    };
    SertoSchemasService.prototype.getSchema = function (slug) {
        return __awaiter(this, void 0, void 0, function () {
            var schema;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!slug) {
                            throw new Error("API error: Must provide a schema ID");
                        }
                        return [4 /*yield*/, this.request("/v1/public/" + slug, "GET")];
                    case 1:
                        schema = _a.sent();
                        // @TODO/tobek This handles API bug where sometimes there is a wrapper object with schema inside `schema` property - remove when fixed.
                        schema = (schema === null || schema === void 0 ? void 0 : schema.schema) || schema;
                        schema.favoriteCount = (schema.favoriteCount || 0) + (DUMMY_SCHEMA_SAVES[schema.slug] || 0);
                        return [2 /*return*/, schema];
                }
            });
        });
    };
    SertoSchemasService.prototype.createSchema = function (schema) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.request("/v1/", "POST", schema, true)];
            });
        });
    };
    SertoSchemasService.prototype.updateSchema = function (schema) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.request("/v1/" + schema.slug + "/update", "POST", __assign(__assign({}, schema), { slug: undefined }), true)];
            });
        });
    };
    SertoSchemasService.prototype.toggleSaveSchema = function (slug) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.request("/v1/" + slug + "/favorite", "POST")];
            });
        });
    };
    SertoSchemasService.prototype.request = function (path, method, body, authenticated) {
        var _a, _b;
        if (method === void 0) { method = "GET"; }
        return __awaiter(this, void 0, void 0, function () {
            var headers, response, responseIsJson, errorMessage, errorJson, err_1;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        if (authenticated) {
                            this.ensureAuthenticated();
                        }
                        headers = {};
                        if (this.jwt) {
                            headers.authorization = "Bearer " + this.jwt;
                        }
                        if (body) {
                            headers["Content-Type"] = "application/json";
                        }
                        return [4 /*yield*/, fetch("" + this.url + path, {
                                method: method,
                                headers: headers,
                                body: JSON.stringify(body),
                            })];
                    case 1:
                        response = _c.sent();
                        responseIsJson = ((_a = response.headers.get("content-type")) === null || _a === void 0 ? void 0 : _a.indexOf("application/json")) === 0;
                        if (!!response.ok) return [3 /*break*/, 6];
                        errorMessage = void 0;
                        if (!responseIsJson) return [3 /*break*/, 3];
                        return [4 /*yield*/, response.json()];
                    case 2:
                        errorJson = _c.sent();
                        if ((_b = errorJson === null || errorJson === void 0 ? void 0 : errorJson.error) === null || _b === void 0 ? void 0 : _b.message) {
                            errorMessage = errorJson.error.message;
                            if (errorJson.error.code) {
                                errorMessage += " (" + errorJson.error.code + ")";
                            }
                        }
                        else {
                            errorMessage = JSON.stringify(errorJson);
                        }
                        return [3 /*break*/, 5];
                    case 3: return [4 /*yield*/, response.text()];
                    case 4:
                        errorMessage = _c.sent();
                        _c.label = 5;
                    case 5:
                        console.error("API error", response.status, errorMessage);
                        throw new Error("API error: " + errorMessage);
                    case 6:
                        if (!responseIsJson) return [3 /*break*/, 11];
                        _c.label = 7;
                    case 7:
                        _c.trys.push([7, 9, , 10]);
                        return [4 /*yield*/, response.json()];
                    case 8: return [2 /*return*/, _c.sent()];
                    case 9:
                        err_1 = _c.sent();
                        if (response.headers.get("content-length") === "0") {
                            throw new Error('API error: API returned invalid JSON: ""');
                        }
                        throw err_1;
                    case 10: return [3 /*break*/, 13];
                    case 11: return [4 /*yield*/, response.text()];
                    case 12: return [2 /*return*/, _c.sent()];
                    case 13: return [2 /*return*/];
                }
            });
        });
    };
    SertoSchemasService.prototype.ensureAuthenticated = function () {
        if (!this.jwt) {
            throw new Error("Not authenticated");
        }
    };
    return SertoSchemasService;
}());
exports.SertoSchemasService = SertoSchemasService;
exports.mockSertoSchemasService = {
    createSchemaPath: "/schemas/",
    buildSchemaUrl: function (slug, type, version) {
        return "https://example.com/schemas/" + slug + (version && "/" + version) + "/" + type + ".json";
    },
    createSchema: helpers_1.createMockApiRequest(),
    updateSchema: helpers_1.createMockApiRequest(),
    getSchemas: helpers_1.createMockApiRequest([]),
    getSchema: helpers_1.createMockApiRequest({}),
    toggleSaveSchema: helpers_1.createMockApiRequest({}),
};
//# sourceMappingURL=SertoSchemasService.js.map