"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.mockSertoSearchService = exports.SertoSearchService = void 0;
var config_1 = require("../config");
var helpers_1 = require("../utils/helpers");
var SertoSearchService = /** @class */ (function () {
    function SertoSearchService(url) {
        this.url = url || config_1.config.SEARCH_API_URL;
    }
    SertoSearchService.prototype.getEntries = function (domain) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.request("/v1/search/", "POST", { domain: domain })];
            });
        });
    };
    SertoSearchService.prototype.request = function (path, method, body) {
        var _a, _b;
        if (method === void 0) { method = "GET"; }
        return __awaiter(this, void 0, void 0, function () {
            var headers, response, responseIsJson, errorMessage, errorJson, err_1;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        headers = {};
                        if (body) {
                            headers["Content-Type"] = "application/json";
                        }
                        return [4 /*yield*/, fetch("" + this.url + path, {
                                method: method,
                                headers: headers,
                                body: JSON.stringify(body),
                            })];
                    case 1:
                        response = _c.sent();
                        responseIsJson = ((_a = response.headers.get("content-type")) === null || _a === void 0 ? void 0 : _a.indexOf("application/json")) === 0;
                        if (!!response.ok) return [3 /*break*/, 6];
                        errorMessage = void 0;
                        if (!responseIsJson) return [3 /*break*/, 3];
                        return [4 /*yield*/, response.json()];
                    case 2:
                        errorJson = _c.sent();
                        if ((_b = errorJson === null || errorJson === void 0 ? void 0 : errorJson.error) === null || _b === void 0 ? void 0 : _b.message) {
                            errorMessage = errorJson.error.message;
                            if (errorJson.error.code) {
                                errorMessage += " (" + errorJson.error.code + ")";
                            }
                        }
                        else {
                            errorMessage = JSON.stringify(errorJson);
                        }
                        return [3 /*break*/, 5];
                    case 3: return [4 /*yield*/, response.text()];
                    case 4:
                        errorMessage = _c.sent();
                        _c.label = 5;
                    case 5:
                        console.error("API error", response.status, errorMessage);
                        throw new Error("API error: " + errorMessage);
                    case 6:
                        if (!responseIsJson) return [3 /*break*/, 11];
                        _c.label = 7;
                    case 7:
                        _c.trys.push([7, 9, , 10]);
                        return [4 /*yield*/, response.json()];
                    case 8: return [2 /*return*/, _c.sent()];
                    case 9:
                        err_1 = _c.sent();
                        if (response.headers.get("content-length") === "0") {
                            throw new Error('API error: API returned invalid JSON: ""');
                        }
                        throw err_1;
                    case 10: return [3 /*break*/, 13];
                    case 11: return [4 /*yield*/, response.text()];
                    case 12: return [2 /*return*/, _c.sent()];
                    case 13: return [2 /*return*/];
                }
            });
        });
    };
    return SertoSearchService;
}());
exports.SertoSearchService = SertoSearchService;
exports.mockSertoSearchService = {
    getEntries: helpers_1.createMockApiRequest([]),
};
//# sourceMappingURL=SertoSearchService.js.map