import { VC, JsonSchema } from "vc-schema-tools";
import { SchemaDataResponse, SchemaMetadata } from "../components/views/Schemas/types";
export declare type SchemaDataResponseWithParsedJson = SchemaDataResponse & {
    parsedJsonSchema: JsonSchema<SchemaMetadata>;
};
/**
 * Given a VC, returns the Serto Schemas representation of its schema.
 *
 * This should probably be implemented with some API that finds schema by VC, but for now we can do it just by just getting all schemas (getSchemas request is probably cached anyway) and searching through it for the right schema.
 *
 * @NOTE This only handles VCs issued using Serto Schemas schemas. Some of this functionality could be implemented by fetching @context and/or JSON Schema from the URLs in the VC and transforming those.
 */
export declare function useVcSchema(vc: VC): {
    loading?: boolean;
    error?: any;
    vcSchema?: SchemaDataResponseWithParsedJson;
    vcSchemaName: string;
};
