"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.colors = exports.baseColors = void 0;
var polished_1 = require("polished");
exports.baseColors = {
    black: "#000E1A",
    white: "#FFF",
    info: "#36ADF1",
    success: "#28C081",
    warning: "#F1A446",
    danger: "#E9403A",
    blurple: "#5952FF",
    consensysblue: "#3259D6",
};
exports.colors = {
    nearBlack: "#111",
    darkGray: "#32323F",
    midGray: "#53535F",
    gray60: "#838393",
    grey: "#BDBDC6",
    silver: "#9797A5",
    lightSilver: "#AAAAB5",
    moonGray: "#BDBDC6",
    lightGray: "#D8D8E1",
    nearWhite: "#F2F2F8",
    blacks: [
        "rgba(0,0,0,.0125)",
        "rgba(0,0,0,.025)",
        "rgba(0,0,0,.05)",
        "rgba(0,0,0,.1)",
        "rgba(0,0,0,.2)",
        "rgba(0,0,0,.3)",
        "rgba(0,0,0,.4)",
        "rgba(0,0,0,.5)",
        "rgba(0,0,0,.6)",
        "rgba(0,0,0,.7)",
        "rgba(0,0,0,.8)",
        "rgba(0,0,0,.9)",
    ],
    whites: [
        "rgba(255,255,255,.0125)",
        "rgba(255,255,255,.025)",
        "rgba(255,255,255,.05)",
        "rgba(255,255,255,.1)",
        "rgba(255,255,255,.2)",
        "rgba(255,255,255,.3)",
        "rgba(255,255,255,.4)",
        "rgba(255,255,255,.5)",
        "rgba(255,255,255,.6)",
        "rgba(255,255,255,.7)",
        "rgba(255,255,255,.8)",
        "rgba(255,255,255,.9)",
    ],
    primary: {
        base: exports.baseColors.blurple,
        text: polished_1.readableColor(exports.baseColors.blurple),
        light: [null, polished_1.tint(0.2, exports.baseColors.blurple)],
        dark: [null, polished_1.shade(0.2, exports.baseColors.blurple)],
        disabled: [null, polished_1.tint(0.5, exports.baseColors.blurple)],
        border: "#EDECFA",
        background: [null, polished_1.tint(0.9, exports.baseColors.blurple)],
    },
    info: {
        base: exports.baseColors.info,
        text: polished_1.readableColor(exports.baseColors.info),
        light: [null, polished_1.tint(0.9, exports.baseColors.info)],
        dark: [null, polished_1.shade(0.4, exports.baseColors.info)],
    },
    success: {
        base: exports.baseColors.success,
        text: exports.baseColors.white,
        light: [null, polished_1.tint(0.9, exports.baseColors.success)],
        dark: [null, polished_1.shade(0.4, exports.baseColors.success)],
    },
    warning: {
        base: exports.baseColors.warning,
        text: polished_1.readableColor(exports.baseColors.warning),
        light: [null, polished_1.tint(0.9, exports.baseColors.warning)],
        dark: [null, polished_1.shade(0.4, exports.baseColors.warning)],
    },
    danger: {
        base: exports.baseColors.danger,
        text: exports.baseColors.white,
        light: [null, polished_1.tint(0.9, exports.baseColors.danger)],
        dark: [null, polished_1.shade(0.4, exports.baseColors.danger)],
    },
};
//# sourceMappingURL=colors.js.map