"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getNftIdentifiersFromUrl = exports.createMockApiRequest = exports.getAllUrlSearchParam = exports.convertToPascalCase = exports.convertToCamelCase = exports.isoToDatetimeLocal = exports.dateTimeFormat = exports.hexEllipsis = exports.truncateDid = exports.ellipsis = exports.copyCanvasImage = exports.copyImageSupported = exports.downloadCanvasImage = exports.copyToClipboard = void 0;
var slugify_1 = __importDefault(require("@sindresorhus/slugify"));
/** Copy given string to clipboard. Returns true if successful, false if failed. */
function copyToClipboard(text) {
    var textArea = document.createElement("textarea");
    textArea.style.position = "fixed";
    textArea.style.left = "-9999px";
    textArea.value = text;
    document.body.appendChild(textArea);
    textArea.focus();
    textArea.select();
    try {
        document.execCommand("copy");
    }
    catch (error) {
        console.error("Failed to copy text:", error);
        return false;
    }
    document.body.removeChild(textArea);
    return true;
}
exports.copyToClipboard = copyToClipboard;
function downloadCanvasImage(canvas, filename) {
    var image = canvas.toDataURL();
    var link = document.createElement("a");
    link.download = filename;
    link.href = image;
    link.click();
}
exports.downloadCanvasImage = downloadCanvasImage;
exports.copyImageSupported = "ClipboardItem" in window && navigator.clipboard && "write" in navigator.clipboard;
function copyCanvasImage(canvas) {
    if (!exports.copyImageSupported) {
        throw Error("Copying images not supported on this browser");
    }
    canvas.toBlob(function (blob) {
        return navigator.clipboard.write([new window.ClipboardItem({ "image/png": blob })]);
    });
    return true;
}
exports.copyCanvasImage = copyCanvasImage;
function ellipsis(text, startLength, endLength) {
    if (startLength + endLength + 2 >= text.length) {
        // +2 because there's reason to ellide something shorter than "..."
        return text;
    }
    return text.substr(0, startLength) + "..." + text.substr(text.length - endLength, text.length);
}
exports.ellipsis = ellipsis;
function truncateDid(did, maxCharCount) {
    if (maxCharCount === void 0) { maxCharCount = 20; }
    var overMaxCount = did.length > maxCharCount;
    return did.includes("did:web") ? did : overMaxCount ? hexEllipsis(did) : did;
}
exports.truncateDid = truncateDid;
/** Finds where "0x" hex value starts and takes start length from there. */
function hexEllipsis(text, startLength, endLength) {
    if (startLength === void 0) { startLength = 4; }
    if (endLength === void 0) { endLength = 4; }
    var addressIndex = text.indexOf("0x") === -1 ? text.lastIndexOf(":") + 1 : text.indexOf("0x") + 2;
    return ellipsis(text, addressIndex + startLength, endLength);
}
exports.hexEllipsis = hexEllipsis;
function dateTimeFormat(date) {
    var year = new Intl.DateTimeFormat("en", { year: "numeric" }).format(date);
    var month = new Intl.DateTimeFormat("en", { month: "short" }).format(date);
    var day = new Intl.DateTimeFormat("en", { day: "2-digit" }).format(date);
    var dateFormatted = " " + month + " " + day + ", " + year;
    var timeFormatted = new Intl.DateTimeFormat("en-US", { hour: "numeric", minute: "numeric" }).format(date);
    return { dateFormatted: dateFormatted, timeFormatted: timeFormatted };
}
exports.dateTimeFormat = dateTimeFormat;
/** <input type="datetime-local"> element requires a nonstandard time format ("yyyy-MM-ddThh:mm"). This converts from ISO datetime string into that format.  */
function isoToDatetimeLocal(isoString) {
    var offset = new Date().getTimezoneOffset() * 1000 * 60;
    var offsetDate = new Date(isoString).valueOf() - offset;
    return new Date(offsetDate).toISOString().substring(0, 16);
}
exports.isoToDatetimeLocal = isoToDatetimeLocal;
function convertToCamelCase(s) {
    return slugify_1.default(s).replace(/-./g, function (x) { return x.replace("-", "").toUpperCase(); });
}
exports.convertToCamelCase = convertToCamelCase;
function convertToPascalCase(s) {
    return slugify_1.default(s).replace(/(^|-)./g, function (x) { return x.replace("-", "").toUpperCase(); });
}
exports.convertToPascalCase = convertToPascalCase;
function getAllUrlSearchParam(name) {
    if (window.URLSearchParams) {
        var urlParams = new URLSearchParams(window.location.search.slice(1));
        return urlParams.getAll(name);
    }
    else {
        // eslint-disable-next-line no-useless-escape
        var nameForRegex = name.replace(/[\[]/, "\\[").replace(/[\]]/, "\\]");
        var regex = new RegExp("[\\?&]" + nameForRegex + "=([^&#]*)", "g");
        var output = [];
        var results = void 0;
        // eslint-disable-next-line no-constant-condition
        while (true) {
            results = regex.exec(window.location.search);
            if (!results) {
                break;
            }
            output.push(decodeURIComponent(results[1].replace(/\+/g, " ")));
        }
        return output;
    }
}
exports.getAllUrlSearchParam = getAllUrlSearchParam;
// eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types
var createMockApiRequest = function (response) {
    return (function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return __awaiter(void 0, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve) {
                        return setTimeout(function () {
                            console.log.apply(console, __spreadArrays(["SertoUiContext mock API request resolving. Request args:"], args));
                            resolve(response);
                        }, 500);
                    })];
            });
        });
    });
};
exports.createMockApiRequest = createMockApiRequest;
function getNftIdentifiersFromUrl(url) {
    var contractAddress = "";
    var tokenId = "";
    var error = "";
    if (url) {
        var splitVal = url.split("?");
        if (splitVal && splitVal.length > 0) {
            url = splitVal[0];
        }
        var splitURL = url.split("/");
        var length_1 = splitURL.length;
        if (length_1 < 2) {
            error = "Contract Address or TokenID not found on URL";
        }
        else {
            var theorizedAddress = splitURL[length_1 - 2];
            var addressMatch = theorizedAddress.startsWith("0x") && theorizedAddress.length == 42;
            if (!addressMatch) {
                error = "Unable to find Contract Address in provided URL";
            }
            else {
                contractAddress = theorizedAddress;
                var tokenIdMatch = splitURL[length_1 - 1].match("[0-9]+");
                if (!tokenIdMatch || tokenIdMatch.length == 0) {
                    error = "Unable to find Token ID in provided URL";
                }
                else {
                    tokenId = tokenIdMatch[0];
                }
            }
        }
    }
    return { contractAddress: contractAddress, tokenId: tokenId, error: error };
}
exports.getNftIdentifiersFromUrl = getNftIdentifiersFromUrl;
//# sourceMappingURL=helpers.js.map